function generateAttendanceOutDraftList(list){
	var listHtml = '';
	for(var i=0;i<list.length;i++) {
		var listItem;
		listItem = list[i];
		listHtml += generateAttendanceOutDraftItem(listItem);
	}
	return listHtml;
}

function generateAttendanceOutDraftItem(listItem){
	var createDate = (new Date(listItem.createDate)).format('yyyy年MM月dd日 hh:mm');
	var itemHtml = ''+
		'<div class="draft-item" atid="'+listItem.id+'">'+
		'	<div class="mui-pull-left item-left-panel">'+
		'		<div>'+
		'			<span class="mui-icon iconfont icon-riqi lesson-iconfont-size"></span>'+
		'			<span>'+createDate+'</span>'+
		'		</div>'+
		'		<div>'+
		'			<span class="mui-icon mui-icon-location"></span>'+
		'			<span>'+listItem.addr+'</span>'+
		'		</div>'+
		'	</div>'+
		'	<div class="mui-pull-right item-right-panel">'+
		'		<button class="btn-detail" type="button">查看</button>'+
		'	</div>'+
		'</div>';
	return itemHtml;
}

function generateAttendanceOutMineList(list){
	var listHtml = '';
	for(var i=0;i<list.length;i++) {
		var listItem;
		listItem = list[i];
		listHtml += generateAttendanceOutMineItem(listItem);
	}
	return listHtml;
}

function generateAttendanceOutMineItem(listItem){
	var createDate = (new Date(listItem.createDate)).format('yyyy年MM月dd日 hh:mm');
	var itemHtml = ''+
		'<div class="mine-item" atid="'+listItem.id+'">'+
		'		<div class="first-line">'+
		'			<span class="mui-pull-left">外勤</span>'+
		'			<div class="mui-pull-right">'+
		'				<span class="mui-icon mui-icon-checkmarkempty check-mark-greenbg"></span>'+
		'				<span>签到成功</span>'+
		'			</div>'+
		'		</div>'+
		'		<div>'+
		'			<span class="mui-icon iconfont icon-riqi lesson-iconfont-size"></span>'+
		'			<span>时间：'+createDate+'</span>'+
		'		</div>'+
		'		<div class="mui-ellipsis">'+
		'			<span class="mui-icon mui-icon-location"></span>'+
		'			<span>地址：'+listItem.addr+'</span>'+
		'		</div>'+
		'		<div class="mui-ellipsis">'+
		'			<span class="mui-icon mui-icon-info-filled lesson-iconfont-size"></span>'+
		'			<span>备注：'+(listItem.note ? listItem.note :'无')+'</span>'+
		'		</div>'+
		'	</div>'+
		'</div>';
	return itemHtml;
}

function generateAttendanceAllList(list){
	var listHtml = '';
	for(var i=0;i<list.length;i++) {
		var listItem;
		listItem = list[i];
		listHtml += generateAttendanceAllItem(listItem);
	}
	return listHtml;
}

function generateAttendanceAllItem(listItem){
	var createDate = (new Date(listItem.createDate)).format('yyyy年MM月dd日 hh:mm');
	var itemHtml = ''+
		'<div class="at-all-item" atid="listItem.id">'+
		'		<div class="width-whole overflow-hide-wrapper">'+
		'			<div class="mui-pull-left">'+
		'				<span class="mui-icon iconfont icon-riqi lesson-iconfont-size"></span>'+
		'				<span>时间：'+createDate+'</span>'+
		'			</div>'+
		'			<div class="mui-pull-right">'+
		'				<span class="mui-icon mui-icon-checkmarkempty check-mark-greenbg"></span>'+
		'				<span>'+AttendanceTypePool[listItem.atTypeInt]+'</span>'+
		'			</div>'+
		'		</div>'+
		'		<div class="width-whole mj-work-break">'+
		'			<span class="mui-icon mui-icon-location"></span>'+
		'			<span>地址：'+listItem.addr+'</span>'+
		'		</div>';
	if(listItem.atTypeInt == ATTENDANCE_TYPE_OUT){
		itemHtml +=
		'		<div class="width-whole mj-work-break">' +
		'			<span class="mui-icon mui-icon-info-filled lesson-iconfont-size"></span>' +
		'			<span>备注：' + (listItem.note ? listItem.note : '无') + '</span>' +
		'		</div>' +
		'		<div class="upload-attach-wrapper"> <span>附件：</span>';
		if(listItem.attaches.length>0){
			itemHtml +=
			'	<div class="row attach-list pd0 dis-delete attach-list-'+listItem.id+'">'+generateAttendanceList(listItem.attaches,listItem.id)+'</div>' ;
		}else{
			itemHtml +='无附件';
		}
		
		itemHtml +='</div>';
	}
	itemHtml+='</div>';
	return itemHtml;
}


function showAttendanceEditView(objItem){
	var atId = objItem.getAttribute('atid');
	var href = 'views/attendance/attendance_out_edit_temp.html';
	pushWebView({
    webType: 'newWebview_Third',
    id: href,
    href: href,
    aniShow: 'slide-in-right',
    title: '外勤编辑',
    isBars: false,
    barsIcon: '',
    extendOptions: {
      atId: atId,
      noCache: true
    }
  })
}

function showAttendanceDetailView(objItem){
	var atId = objItem.getAttribute('atid');
	var href = 'views/attendance/attendance_out_detail_temp.html';
	log(atId);
	pushWebView({
    webType: 'newWebview_Third',
    id: href,
    href: href,
    aniShow: 'slide-in-right',
    title: '外勤详情',
    isBars: false,
    barsIcon: '',
    extendOptions: {
      atId: atId,
      noCache: true
    }
  })
}

function mjQueryAttendanceOutDetail(atId,callback){
	mj.get(MJ_URL.USER_ATTENDANCE_OUT_DETAIL.mjFormat(atId), {}, function(d){
		callback && callback(d.data);
	}, function(xhr){
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

function fnGetAttendanceAttachUrl(attachId) {
  return MJ_URL.USER_ATTENDANCE_ATTACH_DL + attachId;
}

function fnGetAttendanceAttachSavePath(attachId, attachExt) {
  return '_downloads/image/' + mj.getId() + '_attach_' + attachId + attachExt;
}

function renderAttendanceAttaches(data){
	var atId = data.id;
  if(data.atStatusInt == ATTENDANCE_OUT_STATUS_CREATED) {
  	mj.deletAttachItem('attachWrapper',MJ_URL.USER_ATTENDANCE_ATTACH_DEL);
  }
  
  mj.get(MJ_URL.USER_ATTENDANCE_ATTACH_LIST + atId, {}, function(d) {
    renderAttendanceAttachesList(d);
  }, function() {});
}

function renderAttendanceAttachesList(d){
	var item;
  for(var i = 0; i < d.length; i++) {
    item = d[i];

    var isImg = imgFilter.test(item.ext);
    var imgName = item.name;
    var attachExt = imgName.substr(imgName.lastIndexOf('.'));

    var loadUrl = fnGetAttendanceAttachUrl(item.id);
    var relativePath = fnGetAttendanceAttachSavePath(item.id, attachExt);
    doGetAttach(loadUrl, relativePath, imgName, 'attachWrapper', item.id);
  }
}

	
function generateAttendanceList(list,imgId){
	var listItem;
	var pid;
	var str = '';
	setTimeout(function(){
		mui.each(list,function(index,item){
			listItem = list[index];
			pid = listItem.id;
			var imgSrc = "src = '../../@/img/file/file_sm.png'";
			var pid = listItem.id;
			var imgDiv = document.createElement('div');
	  	imgDiv.setAttribute("pid",pid);
	  	imgDiv.className = 'attach-list-item';
	  	imgDiv.innerHTML = '<img class="img-'+pid+'" style="width:100%;height:100%;" data-preview-src="" data-preview-group="1" '+imgSrc+'/>';
			document.querySelector('.attach-list-'+imgId).appendChild(imgDiv);
			doGetAttendanceAttach(listItem,function(itemUrl){
				document.querySelector('.img-'+item.id).src = itemUrl;
			});
		});
	},100);
	return str;
}

function doGetAttendanceAttach(listItem,callback){
	var loadUrl = fnGetAttendanceAttachUrl(listItem.id);	
 	var imgName = listItem.name;
	var attachExt = imgName.substr(imgName.lastIndexOf('.'));
	var relativePath = fnGetAttendanceAttachSavePath(listItem.id, attachExt);
	var itemUrl = '';
 	var imgSrc = '';
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
     itemUrl = plus.io.convertLocalFileSystemURL(relativePath);
     callback  && callback(itemUrl);
  }, function(e) {
  	log('图片不存在');
  	mj.download(loadUrl, relativePath, function(succeed) {
			if(succeed) {
	   		callback && callback(plus.io.convertLocalFileSystemURL(relativePath));
			}
		});
  });
}
