var sortTypes = {1:'cost', 2: 'value' };
var workChartColors=['rgb(120,160,254)','rgb(253,109,116)'];
var chartColors=['rgb(120,160,254)','rgb(192,208,254)','rgb(101,189,233)','rgb(127,235,123)','rgb(253,224,87)','rgb(253,109,116)'];
var pieChartColors=['#1086ff','#65faff','#28ff0b','#ffde00','#ff9732','#ff0072','#b28be2','#8800af','#ff0026','#cb001e'];
var CHART_UNIT_SW = 4;
var CHART_UNIT_W = 3;
var CHART_UNIT_Q = 2;
var CHART_UNIT_Y = 1;

//隐藏弹出框
function hidePopover(){
	mui('.mui-popover').on('tap','.btn-bill-popover-close',function(){
		mui('.mui-popover').popover('hide');
	});
}

//千位分节符
function thousandBitSeparator(num) {
    return num && num.toString()
            .replace(/(\d)(?=(\d{3})+\.)/g, function($0, $1) {
                return $1 + ",";
            });
}

function chartListSort(list, sortField, sortDesc) {
    var sortDirection = sortDesc ? -1 : 1;
    return _.sortBy(list, function(item) {
        return sortDirection * Number(item[sortField]);
    });
}

function chartToW(val) {
    return (Number(val)/10000).toFixed(3);
}

function chartToSw(val){
    return (Number(val)/100000).toFixed(3);
}

function chartToQ(val){
    return (Number(val)/1000).toFixed(3);
}

function mjChartToChangeUnit(unit,data){
	if(unit==undefined) return data;
	
    switch(parseInt(unit)){
        case CHART_UNIT_SW:
            data = chartToSw(data);
            break;
        case CHART_UNIT_W:
            data = chartToW(data);
            break;
        case CHART_UNIT_Q:
            data = chartToQ(data);
            break;
        case CHART_UNIT_Y:
            break;
        default:
            data = chartToW(data);
            break;
    }
    return data;
}
function chartToHour(val) {
    return (Number(val)/60).toFixed(1);
}

function chartToPercent(val, total) {
    if(Number(total)==0){
        return '-';
    }
    return (Number(val) * 100 / Number(total)).toFixed(2) + "%";
}

function chartListSum(list, sumField) {
    return _.reduce(list, function(memo, item) {
        return memo + Number(item[sumField]);
    }, 0);
}

function chartListSortText(list, sortField) {
    return _.sortBy(list, function(item) {
        return item[sortField];
    });
}

//返回数组除了n个元素外的其他元素
function mjArrayFirst(array,n){
	var len = n>array.length?array.length:n;
	var arr=[];
	for(var i=0;i<len;i++){
		arr.push(array[i]);
	}
	return arr;
}

//返回数组除了n个元素外的其他元素
function mjArrayRest(array,n){
	var arr=[];
	for(var i=n;i<array.length;i++){
		arr.push(array[i]);
	}
	return arr;
}

//数组升序排序
function mjChartListSort(array){
	array.sort(function(a,b){
		return b.cost - a.cost;
	});
	return array;
}

//数组根据某个字段求和
function mjChartListSum(array,item){
	var sum=0;
	for(var i=0;i<array.length;i++){				
		sum += Number(array[i][item]);
	}
	return sum;
}

function mjChartClickHandler (){
    var chartClickTimer;
    var lastClickTime = null;

    function onClickChart(callback) {
        clearTimeout(chartClickTimer);
        chartClickTimer = setTimeout(function () {
            callback && callback();
        }, 300);
    }

    function onDbClickChart(callback) {
        clearTimeout(chartClickTimer);
        callback && callback();
    }
    
    function isDouble() {
		var curTime = new Date();
		if (lastClickTime == null || lastClickTime == '') {
			lastClickTime = curTime;
		} else {
			var minus = curTime - lastClickTime;
			if (minus <= 300) {
				return true;
			} else {
				lastClickTime = curTime;
				return false;
			}
		}
	}

    return function(isDbClick, callback) {
    		if(isDbClick) {
            isDouble() && callback();
        } else {
            callback();
        }
        
//      if(isDbClick) {
//          onDbClickChart(callback);
//      } else {
//          onClickChart(callback);
//      }
    };
}

function mjClickHandler (){
    var lastClickTime = null;
    
    function isDouble() {
		var curTime = new Date();
		if (lastClickTime == null || lastClickTime == '') {
			lastClickTime = curTime;
		} else {
			var minus = curTime - lastClickTime;
			if (minus <= 300) {
				return true;
			} else {
				lastClickTime = curTime;
				return false;
			}
		}
	}

    return function(targetDbClick, callback) {
    		if(targetDbClick) {
            isDouble() && callback();
        } else {
            callback();
        }
    };
}

//获取数据
function showChart(url,parameters,$container,callback){
	mj.showLoading();
	mj.get(url,parameters,function(d){
		mj.hideLoading();
		if(d.length==0){
			mj.showNoneChartView($container);
			return false;
		}
      	callback && callback(d);
	},function(xhr){
		showResult(xhr, LOST_NETWORK_CONNECTION);
		mj.hideLoading();
	});
}

function buildFeeSerie(fee, feeId,xList,xIdList,itemCostHash,showLabel,totalNumber) {
    var data = [];
    for(var i=0; i<xList.length; i++) {
        data.push({
            id: xList[i],
            value: 0,
            hid: xIdList[i],
            text2: fee.text2
        });
    }
    for(var key in itemCostHash) {
        var dataItem = _.findWhere(data, {id: key});
        dataItem.value = itemCostHash[key];
    }

    var serieType = 'bar';
    return {
        name: fee.text,
        type: serieType,
        stack:'费用',
        yAxisIndex:0,
        smooth:true,
        itemStyle: {
            normal: {
                barBorderRadius: 0,
                label : {
			    	show: showLabel,
			    	textStyle:{
			    		color:'#000'
					},
			    	position: 'top',
			  		formatter:function(item) {
			  			var cur = Number(item.data.value);
			  			totalNumber = Number(totalNumber);
		                return (totalNumber!=0 && cur!=0) ? (cur.toFixed(2)+'万\n'+Number(cur*100/totalNumber).toFixed(2)+'%') : '';
		            }
		        }
            }
        },
        tooltip: {
            show: true,
            trigger: 'axis',
            formatter: function(item) {
                return item.seriesName + '<br/>'  + item.data.value;
            }
        },
        data: data
    };
}

//饼图
function buildPieCostChartOption(option,data,fixNameDup){
	var newOption = option;
	var texts=[],datas=[];
	var otherList, firstList;
	var otherTotalList=[],otherTotal=0;
	var topN = data.length;
	
	topN = topN && (topN>5 ? 5 : topN);
	
	data = mjChartListSort(data);
	
	firstList = mjArrayFirst(data,topN);
	otherList = mjArrayRest(data,topN);
	otherTotal = mjChartListSum(otherList,"cost");
	
	if(fixNameDup){
		firstList = mjChartFixNameDup(firstList);
	}
	
    for(var i=0;i<firstList.length;i++){
      var item = firstList[i];
	  var name = item.text;
      texts.push(name);
      datas.push({
      	id: item.id,
        name: name,
        value: chartToW(item.cost),
        text2: item.text2
      });
    }
    if(data.length > topN){
      texts.push('其余');
      datas.push({
      	id: 0,
        name:'其余',
        value:chartToW(otherTotal),
        text2: '其余'
      });
    }
    
    newOption.legend.data = texts;
    newOption.series[0].data = datas;
    return newOption;
}

//竖向根据名字分组堆叠柱状图（部门:部门-业务活动/部门-项目；项目:项目-业务活动；个人:员工-业务活动）
function buildStackVerticalBarChartGroupByNameOption(option, data, sortField, showNumber, showOther, showLabel,showUnit,showTotal) {
    var newOption = option;
    newOption.series = [];
    //1,整理
    var topGroups = [], topGroupsHash = {}, filterList = data, groupList, xList = [], xIdList = [];
    var totalNumber = 0;
    if(showNumber && showNumber>0) {
        groupList = _.groupBy(data, function(item) { return item.text2; });
        _.each(groupList, function(item, key) {
            var groupId = 0, groupText = '', cost = 0;
            _.each(item, function(d, index) {
                if(index==0) {
                		groupId = d.id2;
                    groupText = d.text2;
                }
                cost += Number(d.cost);
                totalNumber += Number(d.cost);
            });

            topGroups.push({groupId: groupId, group: groupText, cost: cost});
        });
        topGroups = chartListSort(topGroups, 'cost', true);
        topGroups = _.first(topGroups, showNumber);
        _.each(topGroups, function(item, key) {
            topGroupsHash[item.group] = true;
            xList.push(item.group);
            xIdList.push(item.groupId);
        });

        filterList = _.filter(data, function(item){
            return topGroupsHash.hasOwnProperty(item.text2);
        });
    } else {
        groupList = _.groupBy(data, function(item) { return item.text2; });
        _.each(groupList, function(item, key) {
            _.each(item, function(d, index) {
                if(index==0) {
                    xList.push(d.text2);
                    xIdList.push(d.id2);
//                  return;
                }
                totalNumber += Number(d.cost);
            });
        });
    }
    //2.组数据
    var legends = [];
    var filterList = _.groupBy(filterList, function(item) { return item.id; });
    var series = [];
    totalNumber = mjChartToChangeUnit(showUnit,totalNumber);
    _.each(filterList, function(item, key) {
        var costHash = [];
        var itemLength=item.length;
        _.each(item, function(d, index) {
            costHash[d.text2] = mjChartToChangeUnit(showUnit,d.cost);
        });
        var serie = buildFeeSerie(item[0], key,xList,xIdList,costHash,showLabel,totalNumber);
        series.push(serie);
        legends.push(item[0].text);
    });
    if(showTotal) {
    		series.push(appendTotalSerie(series,totalNumber));
    }
    newOption.series = series;
    //横坐标文字
    var texts=[];
    for(var i=0; i<xList.length; i++) {
        texts.push(xList[i]);
    }
    newOption.legend.data = legends;
    newOption.xAxis[0].data = texts;
    return newOption;
}

function appendTotalSerie(series,totalNumber) {
	var totals = [];
	for(var k = 0;k<series[0].data.length;k++){
	    totals[k] = 0;
	}
	for(var i=0;i<series.length;i++){
	    for(var j=0;j<series[i].data.length;j++){
	        totals[j] += Number(series[i].data[j].value);
	    }
	}
	return serie = {
		name: "总计",
		type:'bar',
		stack:'费用',
		yAxisIndex:0,
		itemStyle:{
		    normal:{
		        color:'rgba(0,0,0,0)'
		    }
		}, 
		label: {
		    normal: {
		    	position:'insideBottom',
				show: true,
				textStyle:{
		    		color:'#000'
				},
				formatter:function(params){
					var cur = Number(params.data);
		    		return totalNumber!=0 ? (cur.toFixed(2) +'万\n' + Number(cur*100/totalNumber).toFixed(2)+'%') : 0;
		        }
		    }
		},
		data:totals
	};
}

//时耗成本（人力分析图）
function buildTimeCostChartOption(option, data, sortField, showNumber, showOther) {
    var newOption = option;

    var sortType = sortTypes[sortField];
    sortType = sortType || 'cost';

    var texts = [], times = [], costs = [];
    var filterList = [], otherList = [];
    var total = 0;

    total = chartListSum(data, sortType);

    filterList = chartListSort(data, sortType, true);
    if(showNumber>0) {
        otherList = _.rest(filterList, showNumber);
        filterList = _.first(filterList, showNumber);
        filterList = chartListSort(filterList, 'id', false);
    }

    var otherTotalTime=0, otherTotalCost=0;
    if(showOther && otherList && otherList.length>0) {
        otherTotalTime = chartListSum(otherList, 'value');
        otherTotalCost = chartListSum(otherList, 'cost');
    }

    _.each(filterList, function(item, index) {
        times.push(chartToHour(item.value));
        costs.push(chartToW(item.cost));
        var percent;
        if(sortField==1) {
            percent = chartToPercent(item.cost, total);
        } else {
            percent = chartToPercent(item.value, total);
        }
//      var text = item.text + '(' + percent + ')';
		var text = item.text;
        texts.push(text);
    });

    if(showOther && otherList && otherList.length>0) {
        times.push(chartToHour(otherTotalTime));
        costs.push(chartToW(otherTotalCost));
        var otherTotal = sortField==1 ? otherTotalCost : otherTotalTime;
        var percent = chartToPercent(otherTotal, total);
//      var text = '其余(' + percent + ')';
		var text = '其余';
        texts.push(text);
    }

    newOption.xAxis[0].data = texts;
    newOption.series[0].data = times;
    newOption.series[1].data = costs;
    return newOption;
}

function mjChartFixNameDup(data) {
	var newData = [];
	var nameMap = {};
	mui.each(data, function(index, item) {
		var oldName = item.text,name;
		var count = 1;
		if(nameMap.hasOwnProperty(oldName)){
	    	  	count = nameMap[oldName] + 1;
	    	  	name = oldName + '(' + count + ')';
	    	  	nameMap[oldName] = count;
	    	} else {
	    	  	name = oldName;
	    	  	nameMap[oldName] = count;
	    	}
	    	item.text = name;
	    	item.oldText = oldName;
	    	newData.push(item);
	});
	mui.each(newData, function(index, item) {
		var oldName = item.text,name;
		if(nameMap.hasOwnProperty(oldName)){
	    	  	var count = nameMap[oldName];
	    	  	if(count>1){
	    	  		item.text = oldName + '(1)';
	    	  	}
	    }
	});
	return newData;
}

function fixTooltipPosition(window, dom, point) {
	var domClientWidth = dom.clientWidth;
	var domOffsetWidth = point[0];
	var windowWidth = window.innerWidth;
	return (domClientWidth+domOffsetWidth>windowWidth) ? [windowWidth-domClientWidth-15, 0] : [point[0], 0];
}
/**
 * 折线图阴影颜色
 */
function buildChartLinearGradientColor(){
  return new echarts.graphic.LinearGradient(0, 0, 0, 1, [
    {offset: 0, color: 'rgba(120,160,254,0.9)'},
    {offset: 0.5, color: 'rgba(120,160,254,0.5)'},
    {offset: 1, color: 'rgba(120,160,254,0.2)'}
  ], false);
}
