function generateEditBtn() {
	return '<a class="mui-btn mui-btn-grey edit-btn">编辑</a>';
}

function generateDeleteBtn() {
	return '<a class="mui-btn mui-btn-red delete-btn">删除</a>';
}

function generateNullBtn() {
	return '<a class="mui-btn mui-disabled mui-btn-grey">无操作</a>';
}

function generateMineActionButtons(dailylogStatus) {
	var actionHtml = '';
	switch(dailylogStatus) {
		case DL_STATUS_CREATED:
			actionHtml += generateEditBtn();
			actionHtml += generateDeleteBtn();
			break;
		case DL_STATUS_CANCELLED:
		case DL_STATUS_REVIEWED:
		default:
			actionHtml = generateNullBtn();
			break;
	}
	return actionHtml;
}

function doDeleteDailylog(dailylogId, objLi) {
	mj.showLoading();
	mj.post("/api/m/dailylogs/"+dailylogId+"/delete", {},
		function(){
			if (objLi) {
				objLi.parentNode.removeChild(objLi);
				objLi = null;
			}
			mj.alert('删除日报成功');
		},
		function(xhr){
			showResult(xhr, LOST_NETWORK_CONNECTION);
		},
		function(){
			mj.hideLoading();
		}
	);
}

function showDetailView(objItem) {
	var dailylogId = objItem.getAttribute('pid');
	var dailylogName = objItem.getAttribute('pname');
	var dailylogStatus = Number(objItem.getAttribute('pstatus'));
	var href = 'dailylog_detail_temp.html';
	var isBars = false;
	var barsIcon = '';
	if(DL_STATUS_CREATED==dailylogStatus) {
		isBars = true;
		barsIcon = 'mui-icon mui-icon-compose';
	}
	pushWebView({
		webType: 'newWebview_Third',
		id: href,
		href: 'views/dailylog/' + href,
		aniShow: 'slide-in-right',
		title: dailylogName,
		isBars: isBars,
		barsIcon: barsIcon,
		extendOptions: {
			dailylogId: dailylogId,
			noCache: true
		}
	})
}

function showEditView(objItem) {
	var dailylogId = objItem.getAttribute('pid');
	var dailylogName = objItem.getAttribute('pname');
	var href = 'dailylog_edit_temp.html';
	pushWebView({
		webType: 'newWebview_Third',
		id: href,
		href: 'views/dailylog/' + href,
		aniShow: 'slide-in-right',
		title: '编辑日报',
		isBars: true,
		barsIcon: 'mui-icon iconfont icon-baocun',
		extendOptions: {
			dailylogId: dailylogId,
			noCache: true
		}
	})
}

function bindActionEvents(muiDailylogList) {
	muiDailylogList.on('tap','.edit-btn',function(){
		var div = this.parentNode;
		var li = div.parentNode;
		showEditView(li);
	});
	
	muiDailylogList.on('tap','.delete-btn',function(){
		var div = this.parentNode;
		var li = div.parentNode;
		var taskId = li.getAttribute('pid');
		var taskName = li.getAttribute('pname');
		
		mui.confirm('确认删除日报"'+taskName+'"？','删除日报',['删除','取消'],function(e){
			if (e.index == 0) {
				doDeleteDailylog(taskId, li);
			}
		});
	});
	
}

//日志附件
function renderCreateDailylogAttaches() {
    prepareUpload('#btnAddAttach', 'attachWrapper', 'dailylog', 0, '/api/m/dailylogs/attach/upload','/api/m/dailylogs/attach/delete',mj.getCompress(),mj.getMultiple());
}
	
function canUploadAttach(dailylog) {
    var canUpload = false;
    if(dailylog.status !=DL_STATUS_REVIEWED && dailylog.owner == mj.getId()) {
        canUpload = true;
    }
    return canUpload;
}

function fnGetDailylogAttachUrl(attachId){
	return '/api/m/dailylogs/attach/download?id='+attachId;
}

function fnGetDailylogAttachSavePath(attachId, attachExt) {
	return '_downloads/image/' + mj.getId() + '_attach_' + attachId + attachExt;
}

function renderDailylogAttaches(dailylog) {
	var canUpload = canUploadAttach(dailylog);
    if(canUpload) {
        document.getElementById('btnAddAttach').style.display = 'block';
        prepareUpload('#btnAddAttach', 'attachWrapper', 'dailylog', dailylogId, '/api/m/dailylogs/attach/upload','/api/m/dailylogs/attach/delete',mj.getCompress(),mj.getMultiple());
    }
    
    mj.get(MJ_URL.DL_ATTACH_LIST+dailylogId, {}, function(d){
    		var item;
    		var defaultFileImg= "../../@/img/file/file_sm.png";
    		
    		for(var i=0;i<d.length;i++){
    			item = d[i];
    			
    			var isImg = imgFilter.test(item.ext);
    			var imgName = item.name;
    			var attachExt = imgName.substr(imgName.lastIndexOf('.'));
    			
    			if(isImg){
    				var loadUrl = fnGetDailylogAttachUrl(item.id);
    				var relativePath = fnGetDailylogAttachSavePath(item.id, attachExt);
    				doGetAttach(loadUrl, relativePath, imgName, 'attachWrapper',item.id);
    			} else {
    				var imgDom = setImgFromLocal(defaultFileImg,imgName,'attachWrapper',item.id);
  					imgDom.setAttribute('vi', item.id);
  					imgDom.setAttribute('vt', attachExt);
  				
	  				var img = imgDom.getElementsByTagName('img');
					for (var j=0;j<img.length;j++) {
						img[j].removeAttribute('data-preview-src');
						img[j].removeAttribute('data-preview-group');
					}
					
					imgDom.addEventListener('tap',function(){
						var attachId = this.getAttribute('vi');
						var attachExt = this.getAttribute('vt');
						
    					var relativePath = fnGetDailylogAttachSavePath(attachId, attachExt);
						plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
							log("附件已存在,地址:" + relativePath);
							showAttach(relativePath);
					    }, function(e) {
				    		var loadUrl = fnGetDailylogAttachUrl(attachId);
				    		mj.download(loadUrl, relativePath, function(succeed) {
								if(succeed) {
									log("附件已下载,地址:" + relativePath);
									showAttach(relativePath);
								}
							});
					    });
					});
    			}
    		}
    	}, function(){
    });
}

function showAttach(relativePath){
	var imgUrl = 'file://' + plus.io.convertLocalFileSystemURL(relativePath);
	
	plus.runtime.openFile(imgUrl, {}, function(e) {
		mui.toast("无法打开此文件：" + e.emssage);
	});
}

function queryDlFields(callback){
	mj.get(MJ_URL.DICT_DL_FIELDS, {},  
		function(data){
			var dict = data.replace('，', ',');
      dict = dict.split(',');
      
      mui.each(dict,function(index,item){
          switch(item){
            case 'dm1':
              showDm1 = true;
              break;
            case 'dm2':
              showDm2 = true;
              break;
            case 'dm3':
              showDm3 = true;
              break;
            case 'dm4':
              showDm4 = true;
              break;
            case 'dm5':
              showDm5 = true;
              break;
            case 'bizId':
              showBiz = true;
              break;
            case 'consumerId':
              showConsumer = true;
              break;
            default:
              break;
          }
      });
      
      var dmHtml='';
      var showDm=false;
      var dm1Name = mj.getDict(DL_DM1);
      var dm2Name = mj.getDict(DL_DM2);
      var dm3Name = mj.getDict(DL_DM3);
      var dm4Name = mj.getDict(DL_DM4);
			var dm5Name = mj.getDict(DL_DM5);
			if(showDm1){
			 	showDm=true;
			    dmHtml += '<li class="mui-table-view-cell">'+
			   '	<span>' + dm1Name + '</span>'+
			   '<span id="dlDm1" class="mui-pull-right"></span>'
			   '</li>';
			}
			
			if(showDm2){
				showDm=true;
			  dmHtml += '<li class="mui-table-view-cell">'+
			   '	<span>' + dm2Name + '</span>'+
			   '<span id="dlDm2" class="mui-pull-right"></span>'
			   '</li>';
			}
			
			if(showDm3){
				showDm=true;
			  dmHtml += '<li class="mui-table-view-cell">'+
			   '	<span>' + dm3Name + '</span>'+
			   '<span id="dlDm3" class="mui-pull-right"></span>'
			   '</li>';
			}
			
			if(showDm4){
				showDm=true;
			  dmHtml += '<li class="mui-table-view-cell">'+
			   '	<span>' + dm4Name + '</span>'+
			   '<span id="dlDm4" class="mui-pull-right"></span>'
			   '</li>';
			}
			
			if(showDm5){
				showDm=true;
			  dmHtml += '<li class="mui-table-view-cell">'+
			   '	<span>' + dm5Name + '</span>'+
			   '<span id="dlDm5" class="mui-pull-right"></span>'
			   '</li>';
			}
			
			if(showDm){
				document.getElementById('dmsWrapper').innerHTML = dmHtml;
				document.getElementById('dmsWrapper').style.display = "block";
			}
			
			if(showBiz){
				document.getElementById('bizWrapper').style.display = "block";
			}
			if(showConsumer){
				document.getElementById('consumerWrapper').style.display = "block";
			}
			
			callback && callback(true);
		},
		function(xhr){
			showResult(xhr, LOST_NETWORK_CONNECTION);
			callback && callback(false);
		}
	);
}

function queryDlDms(callback){
	mj.get(MJ_URL.DICT_DL_DMS, {},
		function(data){
			var dict = data.dict;
      var dms = data.dms;
      dict = dict.replace('，', ',');
      dict = dict.split(',');
      
      mui.each(dict,function(index,item){
          switch(item){
            case 'dm1':
              showDm1 = true;
              break;
            case 'dm2':
              showDm2 = true;
              break;
            case 'dm3':
              showDm3 = true;
              break;
            case 'dm4':
              showDm4 = true;
              break;
            case 'dm5':
              showDm5 = true;
              break;
            case 'bizId':
              showBiz = true;
              break;
            case 'consumerId':
              showConsumer = true;
              break;
            default:
              break;
          }
      });
      
      var dmHtml='';
      var showDm=false;
      var dm1Name = mj.getDict(DL_DM1);
      var dm2Name = mj.getDict(DL_DM2);
      var dm3Name = mj.getDict(DL_DM3);
      var dm4Name = mj.getDict(DL_DM4);
      var dm5Name = mj.getDict(DL_DM5);
      if(showDm1){
       	showDm=true;
          getConfDms('dm1', dms, function(showInput,showSelect,dlDms){
            showDm1Input = showInput;
            showDm1Select = showSelect;
            dm1s = dlDms;
            if(showInput){
            		dmHtml += '<li class="mui-table-view-cell hr-create-input-wrapper no-left-table-view-cell">'+
									   '	<span>' + dm1Name + '</span>'+
									   '	<input id="dlDm1" type="text" class="mui-pull-right" placeholder="" value="" >'+
									   '</li>';
            }
            if(showSelect){
            		dmHtml += '<li id="dlDm1Cell" class="mui-table-view-cell no-left-table-view-cell dl-dm1-table-cell">'+
            		   '	<a href="javascript:void(0)" class="mui-navigate-right">'+
                 '		<span>' + dm1Name + '</span>'+
                 '		<span id="dlSelectedDm1" class="mui-pull-right has-link dl-dm1"></span>'+
                 '	</a>'+
                 '</li>';
            }
          });
        }

        if(showDm2){
        		showDm=true;
          getConfDms('dm2', dms, function(showInput,showSelect,dlDms){
            showDm2Input = showInput;
            showDm2Select = showSelect;
            dm2s = dlDms;
            if(showInput){
	            	dmHtml += '<li class="mui-table-view-cell hr-create-input-wrapper no-left-table-view-cell">'+
										   '	<span>' + dm2Name + '</span>'+
										   '	<input id="dlDm2" type="text" class="mui-pull-right" placeholder="" value="" >'+
										   '</li>';
            }
            if(showSelect){
            		dmHtml += '<li id="dlDm2Cell" class="mui-table-view-cell no-left-table-view-cell dl-dm2-table-cell">'+
            		   			'	<a href="javascript:void(0)" class="mui-navigate-right">'+
                       '		<span>' + dm2Name + '</span>'+
                       '		<span id="dlSelectedDm2" class="mui-pull-right has-link dl-dm2"></span>'+
                       '	</a>'+
                       '</li>';
            }
          });
        }

        if(showDm3){
        		showDm=true;
          getConfDms('dm3', dms, function(showInput,showSelect,dlDms){
            showDm3Input = showInput;
            showDm3Select = showSelect;
            dm3s = dlDms;
            if(showInput){
	            	dmHtml += '<li class="mui-table-view-cell hr-create-input-wrapper no-left-table-view-cell">'+
										   '	<span>' + dm3Name + '</span>'+
										   '	<input id="dlDm3" type="text" class="mui-pull-right" placeholder="" value="" >'+
										   '</li>';
            }
            if(showSelect){
            		dmHtml += '<li id="dlDm3Cell" class="mui-table-view-cell no-left-table-view-cell dl-dm3-table-cell">'+
          		   				'	<a href="javascript:void(0)" class="mui-navigate-right">'+
                       '		<span>' + dm3Name + '</span>'+
                       '		<span id="dlSelectedDm3" class="mui-pull-right has-link dl-dm3"></span>'+
                       '	</a>'+
                       '</li>';
            }
          });
        }

        if(showDm4){
        		showDm=true;
          getConfDms('dm4', dms, function(showInput,showSelect,dlDms){
            showDm4Input = showInput;
            showDm4Select = showSelect;
            dm4s = dlDms;
            if(showInput){
	            	dmHtml += '<li class="mui-table-view-cell hr-create-input-wrapper no-left-table-view-cell">'+
										   '	<span>' + dm4Name + '</span>'+
										   '	<input id="dlDm4" type="text" class="mui-pull-right" placeholder="" value="" >'+
										   '</li>';
            }
            if(showSelect){
            		dmHtml += '<li id="dlDm4Cell" class="mui-table-view-cell no-left-table-view-cell dl-dm4-table-cell">'+
          		   				'	<a href="javascript:void(0)" class="mui-navigate-right">'+
                       '		<span>' + dm4Name + '</span>'+
                       '		<span id="dlSelectedDm4" class="mui-pull-right has-link dl-dm4"></span>'+
                       '	</a>'+
                       '</li>';
            }
          });
        }

        if(showDm5){
        		showDm=true;
          getConfDms('dm5', dms, function(showInput,showSelect,dlDms){
            showDm5Input = showInput;
            showDm5Select = showSelect;
            dm5s = dlDms;
            if(showInput){
	            	dmHtml += '<li class="mui-table-view-cell hr-create-input-wrapper no-left-table-view-cell">'+
										   '	<span>' + dm5Name + '</span>'+
										   '	<input id="dlDm5" type="text" class="mui-pull-right" placeholder="" value="" >'+
										   '</li>';
            }
            if(showSelect){
            		dmHtml += '<li id="dlDm5Cell" class="mui-table-view-cell no-left-table-view-cell dl-dm5-table-cell">'+
            		   			'	<a href="javascript:void(0)" class="mui-navigate-right">'+
                       '		<span>' + dm5Name + '</span>'+
                       '		<span id="dlSelectedDm5" class="mui-pull-right has-link dl-dm5"></span>'+
                       '	</a>'+
                       '</li>';
            }
          });
        }
        
        if(showDm){
        		document.getElementById('dmsWrapper').innerHTML = dmHtml;
        		document.getElementById('dmsWrapper').style.display = "block";
        }
        
        if(showDm1Select){
      		initDmBookForDailylog({
      			dmTapId:'dlDm1Cell',
      			dmShowId:'dlSelectedDm1',
      			dmTitle:dm1Name,
      			dms:dm1s
      		},function(seledted){
      			dm1Id = seledted.id;
      		});
        }
        if(showDm2Select){
      		initDmBookForDailylog({
      			dmTapId:'dlDm2Cell',
      			dmShowId:'dlSelectedDm2',
      			dmTitle:dm2Name,
      			dms:dm2s
      		},function(seledted){
      			dm2Id = seledted.id;
      		});
        }
        if(showDm3Select){
        	initDmBookForDailylog({
      			dmTapId:'dlDm3Cell',
      			dmShowId:'dlSelectedDm3',
      			dmTitle:dm3Name,
      			dms:dm3s
      		},function(seledted){
      			dm3Id = seledted.id;
      		});
        }
        if(showDm4Select){
        	initDmBookForDailylog({
      			dmTapId:'dlDm4Cell',
      			dmShowId:'dlSelectedDm4',
      			dmTitle:dm4Name,
      			dms:dm4s
      		},function(seledted){
      			dm4Id = seledted.id;
      		});
        }
        if(showDm5Select){
        	initDmBookForDailylog({
      			dmTapId:'dlDm5Cell',
      			dmShowId:'dlSelectedDm5',
      			dmTitle:dm5Name,
      			dms:dm5s
      		},function(seledted){
      			dm5Id = seledted.id;
      		});
        }
        
        if(showBiz){
        		document.getElementById('bizWrapper').style.display = "block";
        }
        if(showConsumer){
        		document.getElementById('consumerWrapper').style.display = "block";
        }
        
    		callback && callback(true);
		},
		function(xhr){
			showResult(xhr, LOST_NETWORK_CONNECTION);
			callback && callback(false);
		}
	);
}

function getConfDms(dm, data, callback){
    var showInput = false;
    var showSelect = false;
    var dms = [];
    if(data.hasOwnProperty(dm) && data[dm].hasOwnProperty('t')){
      switch(data[dm]['t']){
        case 'input':
          showInput = true;
          showSelect = false;
          break;
        case 'select':
          dms = data[dm]['data'];
          showInput = false;
          showSelect = true;
          break;
        default:
          break;
      }
    }
    callback && callback(showInput,showSelect,dms);
}

function initDmBookForDailylog(options,callback){
	options = options || {};
	var dmTapId = options.dmTapId;
	var dmShowId = options.dmShowId;
	var dmTitle = options.dmTitle || '请选择扩展字段';
	var dlDms = options.dms || [];
	document.getElementById(dmTapId).addEventListener('tap',function(){
		pushUserSelectWebView({
	  	source:'DL_DM',
	  	title:dmTitle,
	    param:{},
	    hasSpecial:true,
	    showDlDms:dlDms,
	    callback: function(selected){
	    	if(dmShowId) document.getElementById(dmShowId).innerText = selected.name;
	      callback && callback(selected);
	    }
	  });
  });
}

//个人工作内容
function initUserWcBookForDailylog(){
	document.getElementById('showWorkcontet').addEventListener('tap',function(){
    pushUserSelectWebView({
    	source:'WC',
    	title:'请选择工作内容',
      param:{
      	url:MJ_URL.WC_LIST_BY_USER,
      	user:mj.getId()
      },
      callback: function(selected){
        wcId=selected.id;
        
        document.getElementById('workcontentResult').innerText = selected.name;
      }
    });
  });
}
	
//个人业务活动
function initUserBizBookForDailylog(){
	if(!showBiz){
		return;
	}
	document.getElementById('showBiz').addEventListener('tap',function(){
    pushUserSelectWebView({
    	source:'BIZ',
    	title:'请选择业务活动',
      param:{
      	url:MJ_URL.BIZ_LIST_BY_USER,
      	user:mj.getId()
      },
      hasSpecial:true,
      callback: function(selected){
        bizId=selected.id;
        
        document.getElementById('bizResult').innerText = selected.name;
      }
    });
  });
}
	
//可见客户
function initUserVisibleConsumerBookForDailylog(){
	if(!showConsumer){
		return;
	}

	initWorkConsumerBookByPermissionForHr({
		consumerTapId:'showConsumer',
		consumerShowId:'consumerResult',
		hasSpecial:true,
		showAll:false
	},function(selected){
		consumerId=selected.id;

		document.getElementById('consumerResult').innerText = selected.name;
	});
}
	
//所属部门
function initUserDepartmentBookForDailylog(){
	myDepartments = mj.getDepartments();
	var mineDepartments = mj.getDepartments();
	if(mineDepartments.length>1){
		document.getElementById('multiDepartment').style.display = "block";
			
		document.getElementById('showDepartment').addEventListener('tap',function(){
	    pushUserSelectWebView({
	    	source:'DEPARTMENT',
	    	title:'请选择所属部门',
	      param:{
	      	url:MJ_URL.DEPT_LIST_BY_ME
	      },
	      hasSpecial:false,
	      showDirectSub:false,
	      showDepartments:mineDepartments,
	      callback: function(selected){
	        departmentId=selected.id;
	        
	        document.getElementById('departmentResult').innerText = selected.name;
	      }
	    });
	  });
	}
//		setTimeout(function(){
//			mjQueryDepartmentsByUser(function(departments){
//				if(departments.length>1){
//					
//			 	}
//			});
//		},100);
}
	
//关联任务
function initUserTaskForDailylog(){
	document.getElementById('showTask').addEventListener('tap',function(){
    pushUserSelectWebView({
    	source:'TASK',
    	title:'请选择关联任务',
      param:{
      	url:MJ_URL.TASK_LIST_BY_ME,
      	pid:projectId
      },
     
      callback: function(selected){
        taskId=selected.id;
        
        document.getElementById('taskResult').innerText = selected.name;
      }
    });
  });
}

