var __first = "&__f=1";
var MJReport = function(option) {
	if (!option) {
		throw "Report option can not be null.";
	}
	var serverUrl = option["serverUrl"];
	var reportFileUrl = "_u=file:" + option["report"] + ".ureport.xml";
	this.reportUrl = serverUrl + "/ureport/html?" + reportFileUrl;
	this.exportExcelUrl = serverUrl + "/ureport/excel?" + reportFileUrl;
	this.method = option["method"] || "GET";
	this.parameters = option["parameters"] || {};
	this.success = option["success"];
	this.beforeSend = option["beforeSend"] || function() {};
	if (!this.success) {
		throw "没有定义成功回调函数.";
	}
	this.error = option["error"] || function() {};
	this.pageCount = 0;
	this._initExportUrls();
};

MJReport.prototype._initExportUrls = function() {
	for (var key in this.parameters) {
		this.exportExcelUrl += "&" + key + "=" + this.parameters[key];
	}
};

MJReport.prototype.requestReport = function(pageIndex) {
	var url = this.reportUrl;
	if (pageIndex) {
		url += "&page=" + pageIndex + "";
		if (__first != 0) {
			url += __first;
			__first = 0;
		}
	}
	var self = this;
	mui.ajax({
		url: url,
		type: self.method,
		timeout: 15000,
		headers: {
			"Authorization": '' + mj.getToken(),
			"App-Version": '' + mj.getVersion()
		},
		success: function(data) {
			try {
				//				data = data.replace(/\\\"/g, "'");
				//				data=$.parseJSON(data);
				data = JSON.parse(data);
			} catch (e) {
				mui.toast('数据量太大，请缩小搜索范围');
				self.error.call(self);
				return;
			}

			if (data["pageCount"]) {
				self.pageCount = data["pageCount"];
			}
			self.success.call(self, data["table"]);
		},
		error: function(xhr, type, e) {
			mj.rpcErrHandler(xhr, type, e, function() {
				showResult(xhr, LOST_NETWORK_CONNECTION);
				self.error.call(self);
			});
		},
		beforeSend: function() {
			self.beforeSend.call(self);
		},
		data: self.parameters
	});
};

MJReport.prototype.getPageCount = function() {
	return this.pageCount;
};

MJReport.prototype.getExportExcelUrl = function() {
	return this.exportExcelUrl;
};

function showScrollTable($table, removeRows, fixedColumns, footerRows, targetWidth, targetHeight, rightRemoveCols,
	leftRemoveCols) {
	cleanTableRows($table, removeRows);
	cleanTableColumns($table, rightRemoveCols, leftRemoveCols);

	var scrollBarSize = 0;

	var width = 0;
	var itemWidth;
	var colModal = [];
	var $tr = $('tr:first', $table);
	var $td = $('td', $tr);
	$.each($td, function(index, item) {
		itemWidth = $(item).outerWidth();
		width += itemWidth;
		colModal.push({
			width: itemWidth
		});
	});
	$.each($('tr', $table), function(rowIndex, row) {
		$.each($('td', $(row)), function(tdIndex, td) {
			$(td).width(colModal[tdIndex].width);
		});
	});

	fixScrollTable($table, footerRows);

	width = width < targetWidth ? (width + scrollBarSize) : targetWidth;

	$table.fxdHdrCol({
		fixedCols: fixedColumns,
		width: width,
		height: targetHeight,
		scrollBarSize: scrollBarSize,
		colModal: colModal,
		sort: false
	});
}

function cleanTableColumns($table, rightRemoveCols, leftRemoveCols) {
	if (rightRemoveCols) {
		$.each($('tr', $table), function(rowIndex, row) {
			for (var j = 0; j < rightRemoveCols; j++) {
				$td = $('td:last', $(row));
				$td.remove();
			}
		});
	}
	if (leftRemoveCols) {
		$.each($('tr', $table), function(rowIndex, row) {
			for (var j = 0; j < leftRemoveCols; j++) {
				$td = $('td:first', $(row));
				$td.remove();
			}
		});
	}
}

function cleanTableRows($table, removeRows) {
	var $tr, $td;
	for (var i = 0; i < removeRows; i++) {
		$tr = $('tr:first', $table);
		$tr.remove();
	}
}

function fixScrollTable($table, footerRows) {
	var $tr;

	$('tr:first', $table)
		//.detach()
		.wrap('<thead/>')
		.parent()
		.prependTo($table);

	if (footerRows && footerRows > 0) {
		$('tr:last', $table)
			//.detach()
			.wrap('<tfoot/>')
			.parent()
			.appendTo($table);

		$tr = $('tr:last', $table);
		$tr.html($tr.html().replace(/\<td/g, '<th').replace(/\<\/td/g, '</th'));
	}
	$tr = $('tr:first', $table);
	$tr.html($tr.html().replace(/\<td/g, '<th').replace(/\<\/td/g, '</th'));

	return $tr;
}

//分析表
function showFeeTable($container, parameters, callback) {
	var mjExpenseDepartmentreport;
	var departmenrReportOption = {
		serverUrl: mj.getServerUrl(),
		//serverUrl: 'http://192.168.5.31:8090/mj-ureport',
		report: 'fin',
		parameters: parameters,
		success: function(data) {
			$container.html(data);
			var $table = $('.report>table');
			var tableWidth = document.body.clientWidth;
			var tableHeight = document.body.clientHeight - 156;
			showScrollTable($table, 2, 1, 0, tableWidth, tableHeight, 0, 0);

			//预警
			var warnRuleLastDiffRate, warnRuleDiffRate;
			switch (parameters.feeType) {
				case 'income':
					warnRuleDiffRate = WARN_TYPE_INCOME_DIFF_RATE;
					warnRuleLastDiffRate = WARN_TYPE_INCOME_LAST_DIFF_RATE;
					break;
				case 'fee':
				case 'cost':
				default:
					warnRuleDiffRate = WARN_TYPE_FEE_COST_DIFF_RATE;
					warnRuleLastDiffRate = WARN_TYPE_FEE_COST_LAST_DIFF_RATE;
					break;
			}
			//同比增减
			checkUReportWarn(".report table tr td._I4", warnRuleLastDiffRate);
			//预算差异率
			checkUReportWarn(".report table tr td._F4", warnRuleDiffRate, function(warnTr, tdClassName) {
				warnTr.getElementsByClassName('_B4')[0].classList.add(tdClassName);
			});

			callback && callback();
		},
		error: function(e) {
			mj.hideLoading();
		}
	};
	mjExpenseDepartmentreport = new MJReport(departmenrReportOption);
	mjExpenseDepartmentreport.requestReport();
}

function addATagForTable(dm1, dm1Id, dm2, dmSrcName, caliber, parameters) {
	var fixDm = 'c=' + caliber + '&startTime=' + parameters.startTime + '&endTime=' + parameters.endTime;
	if (parameters.account >= 0) {
		fixDm += '&account=' + parameters.account;
	}
	fixDm += '&dm=';

	mui.each(document.querySelectorAll('.report table tr a'), function(index, aDom) {
		var hrefJson = aDom.getAttribute('href').split('?')[1].queryToJson();
		var did = hrefJson['gid'];
		var d1Level = 0;
		if (hrefJson.hasOwnProperty('d1level')) {
			d1Level = hrefJson.d1level;
		}

		var reportFeeType;
		if (hrefJson.hasOwnProperty('feeType')) {
			reportFeeType = hrefJson.feeType;
		} else {
			reportFeeType = parameters.feeType
		}

		var finalDm = fixDm;
		if (dm1 !=0) {
			finalDm += dm1 + '.' + dm1Id + '.' + (parameters.gatherChild ? '1' : '0') + '.' + d1Level + ',';
		}
		finalDm += dm2 + '.' + did + '.0.0' + '&feeType=' + reportFeeType;
		aDom.setAttribute('dm', finalDm);
		aDom.removeAttribute('href');

		aDom.addEventListener("tap", function(e) {
			e.detail.gesture.preventDefault();
			var dmItem = this.getAttribute('dm');
			showBillBaseData(reportFeeType,dm1,dm1Id,dmItem);
		});
	});
}

function showHrDailylogTable($contanier, parameters, callback) {
	var reportOption = {
		serverUrl: mj.getServerUrl(),
		//serverUrl: 'http://192.168.3.114:8090/mj-ureport',
		report: 'dailylog1',
		parameters: parameters,
		success: function(data) {
			$contanier.html(data);

			var $table = $('.report>table');

			//removeATagForTable('.report>table a');
			mui.each(document.querySelectorAll('.report table tr'), function(index, trDom) {
				trDom.lastChild.style.display = 'none';
			});

			var tableWidth = document.body.clientWidth;
			var tableHeight = document.body.clientHeight - 156;
			showScrollTable($table, 2, 1, 0, tableWidth, tableHeight, 0, 0);

			callback && callback();
		},
		error: function(e) {
			mj.hideLoading();
		}
	};
	var mjReport = new MJReport(reportOption);
	mjReport.requestReport();
}

//客户拜访情况分析表
function buildConsumerVisitTable(opt,callback) {
	var parameters = opt.parameters;
	var $container = opt.$container;
	if (!parameters) {
		return false;
	}
	mj.showLoading();
	var consumerVisitReportOption = {
		serverUrl: mj.getServerUrl(),
		report: 'sale.consumer.visit',
		parameters: parameters,
		success: function(data) {
			$container.html(data);

			var $table = $('>table',$container);
			var tableTitle= $('table tr td._A1',$container).text();
			var tableTimeRange= $('table tr td._A2',$container).text();

			var tableWidth = document.body.clientWidth;
			var tableClientHeight = document.body.clientHeight;
			var tableHeight = parameters.s == REPORT_DIMENSION_DEPARTMENT ? (tableClientHeight - 156) : (tableClientHeight - 114);

			showScrollTable($table, 2, 1, 0, tableWidth, tableHeight, 0, 0);

			addCvATagForSaleDataDetail(parameters);

			mj.hideLoading();

			callback && callback(tableTitle,tableTimeRange);
		},
		error: function(e) {
			mj.hideLoading();
		}
	};
	var mjConsumerVisitReport = new MJReport(consumerVisitReportOption);
	mjConsumerVisitReport.requestReport();
}

//客户拜访记录链接明细记录
function addCvATagForSaleDataDetail(parameters) {
	var isGatherChild = parameters.gatherChild;
	var curStartTime = parameters.startTime;
	var curEndTime = parameters.endTime;

	mui.each(document.querySelectorAll('.consumer-visit-report table tr td._A4 a'), function(index, aDom) {
		var hrefJson = aDom.getAttribute('href').split('?')[1].queryToJson();
		var consumerId = hrefJson['cid'];

		aDom.setAttribute('cid', consumerId);
		aDom.removeAttribute('href');

		var fixDom = 's=' + REPORT_DIMENSION_ALL +'&gatherChild=' + isGatherChild + '&startTime=' + curStartTime + '&endTime=' + curEndTime;
		var dimensions = REPORT_DIMENSION_CONSUMER + '.' + consumerId + ','+(parameters.s==REPORT_DIMENSION_DEPARTMENT?REPORT_DIMENSION_DEPARTMENT:REPORT_DIMENSION_USER) + '.' + parameters.d;
		fixDom +='&c='+dimensions;
		aDom.setAttribute('dm', fixDom);

		aDom.addEventListener("tap", function(e) {
			e.detail.gesture.preventDefault();
			var dmItem = this.getAttribute('dm');
			showSaleConsumerVisitBaseData(dmItem, 'y');
		});
	});
}

function removeATagForTable(aSelector, parameters) {
	mui.each(document.querySelectorAll(aSelector), function(index, aDom) {
		aDom.removeAttribute('href');
	});
}

function addTagForDailylogTable(parameters, dm1) {
	var fixDom = 's=' + parameters.s + '&startTime=' + parameters.startTime + '&endTime=' + parameters.endTime;
	if (parameters.hasOwnProperty('onlyDirect')) {
		fixDom += '&onlyDirect=' + parameters.onlyDirect;
	}
	if (parameters.hasOwnProperty('gatherChild')) {
		fixDom += '&gatherChild=' + parameters.gatherChild;
	}
	mui.each(document.querySelectorAll('.report table tr a'), function(index, aDom) {
		aDom.removeAttribute('href');
		aDom.addEventListener("tap", function(e) {
			e.detail.gesture.preventDefault();
			var topParent = this.parentNode.parentNode;
			var childrenLength = topParent.childNodes.length;
			var dimensions = topParent.childNodes[childrenLength - 1].innerText;
			var dmItem = fixDom + '&c=' + dm1 + dimensions;
			showDailylogBaseData(dmItem, 'n');
		});
	});
}
/**分析表增加预警颜色
 * @param {Object} $td
 * @param {Object} warnRule
 */
function checkUReportWarn($td, warnRule, callback) {
	mui($td).each(function() {
		var tdClassName = checkReportWarnRule(warnRule, this.innerText);
		if (tdClassName != '') {
			this.classList.add(tdClassName);
			callback && callback(this.parentNode, tdClassName);
		}
	});
}

/**
 * 预警规则颜色
 * @param warnRuleType
 * @param warnRule
 * @param cellValue
 */
function checkReportWarnRule(warnRuleType, cellValue) {
	if (cellValue == undefined) cellValue = 0;
	if ((/%/g).exec(cellValue)) cellValue = cellValue.replace(/%/g, '');
	cellValue = Number(cellValue);

	var cacheWarnRules = mj.getWarnRules() != undefined ? mj.getWarnRules() : {};
	var warnProfitRateNlms1 = cacheWarnRules.warnProfitRateNlms1 ? cacheWarnRules.warnProfitRateNlms1 : '';
	var warnProfitRateNlms2 = cacheWarnRules.warnProfitRateNlms2 ? cacheWarnRules.warnProfitRateNlms2 : '';
	var warnBudgetDiffRateIncomeNlms1 = cacheWarnRules.warnBudgetDiffRateIncomeNlms1 ? cacheWarnRules.warnBudgetDiffRateIncomeNlms1 : '';
	var warnBudgetDiffRateIncomeNlms2 = cacheWarnRules.warnBudgetDiffRateIncomeNlms2 ? cacheWarnRules.warnBudgetDiffRateIncomeNlms2 : '';

	var warnBudgetDiffRateCostNlms1 = cacheWarnRules.warnBudgetDiffRateCostNlms1 ? cacheWarnRules.warnBudgetDiffRateCostNlms1 : '';
	var warnBudgetDiffRateCostNlms2 = cacheWarnRules.warnBudgetDiffRateCostNlms2 ? cacheWarnRules.warnBudgetDiffRateCostNlms2 : '';

	var warnBudgetDiffRateProfitNlms1 = cacheWarnRules.warnBudgetDiffRateProfitNlms1 ? cacheWarnRules.warnBudgetDiffRateProfitNlms1 : '';
	var warnBudgetDiffRateProfitNlms2 = cacheWarnRules.warnBudgetDiffRateProfitNlms2 ? cacheWarnRules.warnBudgetDiffRateProfitNlms2 : '';

	var warnIoRateIncomeNlms1 = cacheWarnRules.warnIoRateIncomeNlms1 ? cacheWarnRules.warnIoRateIncomeNlms1 : '';
	var warnIoRateIncomeNlms2 = cacheWarnRules.warnIoRateIncomeNlms2 ? cacheWarnRules.warnIoRateIncomeNlms2 : '';

	var warnIoRateCostNlms1 = cacheWarnRules.warnIoRateCostNlms1 ? cacheWarnRules.warnIoRateCostNlms1 : '';
	var warnIoRateCostNlms2 = cacheWarnRules.warnIoRateCostNlms2 ? cacheWarnRules.warnIoRateCostNlms2 : '';

	var warnIoRateProfitNlms1 = cacheWarnRules.warnIoRateProfitNlms1 ? cacheWarnRules.warnIoRateProfitNlms1 : '';
	var warnIoRateProfitNlms2 = cacheWarnRules.warnIoRateProfitNlms2 ? cacheWarnRules.warnIoRateProfitNlms2 : '';

	var warnCostNlms1 = cacheWarnRules.warnCostNlms1 ? cacheWarnRules.warnCostNlms1 : '';
	var warnCostNlms2 = cacheWarnRules.warnCostNlms2 ? cacheWarnRules.warnCostNlms2 : '';

	var warnRuleNlms1, warnRuleNlms2;
	switch (Number(warnRuleType)) {
		case WARN_TYPE_PROFIT_RATE:
			warnRuleNlms1 = warnProfitRateNlms1;
			warnRuleNlms2 = warnProfitRateNlms2;
			break;
		case WARN_TYPE_INCOME_DIFF_RATE:
			warnRuleNlms1 = warnBudgetDiffRateIncomeNlms1;
			warnRuleNlms2 = warnBudgetDiffRateIncomeNlms2;
			break;
		case WARN_TYPE_FEE_COST_DIFF_RATE:
			warnRuleNlms1 = warnBudgetDiffRateCostNlms1;
			warnRuleNlms2 = warnBudgetDiffRateCostNlms2;
			break;
		case WARN_TYPE_PROFIT_DIFF_RATE:
			warnRuleNlms1 = warnBudgetDiffRateProfitNlms1;
			warnRuleNlms2 = warnBudgetDiffRateProfitNlms2;
			break;
		case WARN_TYPE_INCOME_LAST_DIFF_RATE:
			warnRuleNlms1 = warnIoRateIncomeNlms1;
			warnRuleNlms2 = warnIoRateIncomeNlms2;
			break;
		case WARN_TYPE_FEE_COST_LAST_DIFF_RATE:
			warnRuleNlms1 = warnIoRateCostNlms1;
			warnRuleNlms2 = warnIoRateCostNlms2;
			break;
		case WARN_TYPE_PROFIT_LAST_DIFF_RATE:
			warnRuleNlms1 = warnIoRateProfitNlms1;
			warnRuleNlms2 = warnIoRateProfitNlms2;
			break;
		case WARN_TYPE_CASH_COST:
			warnRuleNlms1 = warnCostNlms1;
			warnRuleNlms2 = warnCostNlms2;
			break;
		default:
			break;
	}

	var warnType1Exist = false,
		warnType2Exist = false;

	if (warnRuleNlms1 != '') {
		warnType1Exist = filterNumInRange(warnRuleNlms1, cellValue);
		if (warnType1Exist) {
			return 'warn-orange';
		}
	}

	if (!warnType1Exist && warnRuleNlms2 != '') {
		warnType2Exist = filterNumInRange(warnRuleNlms2, cellValue);
		if (warnType2Exist) {
			return 'warn-red';
		}
	}

	if (!warnType1Exist && !warnType2Exist) return '';
}

/**
 * 区间#号分割
 * @param range
 * @param num
 * @returns {boolean|*}
 */
function filterNumInRange(range, num) {
	range = range.toString();
	num = Number(num);

	var splitSymbol = range.indexOf("#");
	if (splitSymbol > -1) {
		range = range.split('#');
		var checkValidArr = [],
			checkValidItem;
		for (var i = 0; i < range.length; i++) {
			checkValidItem = checkNumInRange(range[i], num) ? 1 : 0;
			checkValidArr.push(checkValidItem);
		}

		return checkValidArr.indexOf(1) > -1;
	}

	return checkNumInRange(range, num);
}

//(a,111)--x<111
//(111,A)--x>111
//(111,222)--111<x<222
//[111,222]--111<=x<=222
/**
 * 数值区间转换成公式
 * @param range
 * @param num
 */
function checkNumInRange(range, num) {
	range = range.toString();
	num = Number(num);

	range = range.replace(" ", "");
	var nPosComma = range.indexOf(",");
	if (nPosComma == -1) {
		mui.toast('区间有误');
		return false;
	}

	var strLen = range.length;
	var nmin = 0,
		nmax = 0;
	var strLeft = range.substring(1, nPosComma);
	if (strLeft == 'a') {
		nmin = Number.NEGATIVE_INFINITY;
	} else {
		nmin = strLeft;
	}

	var strRight = range.substring(nPosComma + 1, strLen - 1);
	if (strRight == 'A') {
		nmax = Number.POSITIVE_INFINITY;
	} else {
		nmax = strRight;
	}

	var b1 = false,
		b2 = false;
	var strLeftSymbol = range.substring(0, 1);
	var strRightSymbol = range.substr(strLen - 1, 1);
	if (strLeftSymbol == '(') {
		b1 = (num > nmin) ? true : false;
	} else if (strLeftSymbol == '[') {
		b1 = (num >= nmin) ? true : false;
	}

	if (strRightSymbol == ')') {
		b2 = (num < nmax) ? true : false;
	} else if (strRightSymbol == ']') {
		b2 = (num <= nmax) ? true : false;
	}

	return b1 && b2;
}

function mjRenderAccountBookList(opt,callback){
	opt = opt || {};
	var singleCallback = opt.singleCallback || undefined;
	var isSingle = false;
	
	mjQueryAllAccountBooks(function(accountBooks) {
		if(accountBooks && accountBooks.length==1){
			isSingle = true;
			var singleId = accountBooks[0].id;
			var singleName = accountBooks[0].name;
			singleCallback && singleCallback(singleId,singleName)
		}
		callback && callback(isSingle,accountBooks);
	});
}
