function renderCreateKpiAttaches() {
  prepareUpload('#btnAddAttach', 'attachWrapper', 'kpi', 0, MJ_URL.KPI_ATTACH_UP,MJ_URL.KPI_ATTACH_DEL,mj.getCompress(),mj.getMultiple());
}
function fnGetKpiAttachUrl(attachId){
	return MJ_URL.KPI_ATTACH_DL+attachId;
}

function fnGetKpiAttachSavePath(attachId, attachExt) {
	return '_downloads/image/' + mj.getId() + '_attach_' + attachId + attachExt;
}

function renderKpiAttaches(userId,year,month) {
  mj.get(MJ_URL.KPI_ATTACH_LIST.mjFormat(userId,year,month), {}, function(d){
		var item;
		var defaultFileImg= "../../@/img/file/file_sm.png";

		for(var i=0;i<d.length;i++){
			item = d[i];

			var isImg = imgFilter.test(item.ext);
			var imgName = item.name;
			var attachExt = imgName.substr(imgName.lastIndexOf('.'));

			if(isImg){
				var loadUrl = fnGetKpiAttachUrl(item.id);
				var relativePath = fnGetKpiAttachSavePath(item.id, attachExt);
				doGetAttach(loadUrl, relativePath, imgName, 'attachWrapper',item.id);
			} else {
				var imgDom = setImgFromLocal(defaultFileImg,imgName,'attachWrapper',item.id);
				imgDom.setAttribute('vi', item.id);
				imgDom.setAttribute('vt', attachExt);

				var img = imgDom.getElementsByTagName('img');
				for (var j=0;j<img.length;j++) {
					img[j].removeAttribute('data-preview-src');
					img[j].removeAttribute('data-preview-group');
				}

				imgDom.addEventListener('tap',function(){
					var attachId = this.getAttribute('vi');
					var attachExt = this.getAttribute('vt');
	
					var relativePath = fnGetKpiAttachSavePath(attachId, attachExt);
					plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
						log("附件已存在,地址:" + relativePath);
						showAttach(relativePath);
			    }, function(e) {
		    		var loadUrl = fnGetKpiAttachUrl(attachId);
		    		mj.download(loadUrl, relativePath, function(succeed) {
							if(succeed) {
								log("附件已下载,地址:" + relativePath);
								showAttach(relativePath);
							}
						});
			    });
				});
			}
		}
	}, function(){});
}

function showAttach(relativePath){
	var imgUrl = 'file://' + plus.io.convertLocalFileSystemURL(relativePath);

	plus.runtime.openFile(imgUrl, {}, function(e) {
		mui.toast("无法打开此文件：" + e.emssage);
	});
}