//服务端最新版本号
var latestServerVersion = '2.5.20042301';

var mjConfs = {};
var CONST_BILL_FILTER_SUPPLIER_SHOW = 10000;
var CONF_BILL_FILTER_SUPPLIER_SHOW = {
	showRanges: [{
		min: '2.1.4.30030701',
		max: 0
	}]
};
mjConfs[CONST_BILL_FILTER_SUPPLIER_SHOW] = CONF_BILL_FILTER_SUPPLIER_SHOW;

var CONST_BILL_FILTER_OWNER_SHOW = 10001;
var CONF_BILL_FILTER_OWNER_SHOW = {
	showRanges: [{
		min: '2.1.4.30030701',
		max: 0
	}]
};
mjConfs[CONST_BILL_FILTER_OWNER_SHOW] = CONF_BILL_FILTER_OWNER_SHOW;

var CONST_BILL_BUDGET_PAY_FOR_SUPPLIER = 10002;
var CONF_BILL_BUDGET_PAY_FOR_SUPPLIER = {
	showRanges: [{
		min: '2.5.20042301',
		max: 0
	}]
};
mjConfs[CONST_BILL_BUDGET_PAY_FOR_SUPPLIER] = CONF_BILL_BUDGET_PAY_FOR_SUPPLIER;

var CONST_BILL_BUDGET_COLLECT_FOR_SUPPLIER = 10003;
var CONF_BILL_BUDGET_COLLECT_FOR_SUPPLIER = {
	showRanges: [{
		min: '2.5.20042301',
		max: 0
	}]
};
mjConfs[CONST_BILL_BUDGET_COLLECT_FOR_SUPPLIER] = CONF_BILL_BUDGET_COLLECT_FOR_SUPPLIER;

var CONST_BILL_SUPER_FOR_MULTI_CURRENCY = 10004;
var CONF_BILL_SUPER_FOR_MULTI_CURRENCY = {
	showRanges: [{
		min: '2.5.20042301',
		max: 0
	}]
};
mjConfs[CONST_BILL_SUPER_FOR_MULTI_CURRENCY] = CONF_BILL_SUPER_FOR_MULTI_CURRENCY;

var CONST_CONSUMER_ACTION_FEATURE_SHOW = 20001;
var CONF_CONSUMER_ACTION_FEATURE_SHOW = {
	showRanges: [{
		min: '2.1.4.30030701',
		max: 0
	}]
};
mjConfs[CONST_CONSUMER_ACTION_FEATURE_SHOW] = CONF_CONSUMER_ACTION_FEATURE_SHOW;


/**
 * 二选一情况下
 * 根据服务端版本获取模块配置,得到布尔值
 * @param moduleId
 * @returns {boolean|*}
 */
function isShowByVersion(moduleId) {
	var serverVersion = mj.getServerVersion();
	if (moduleId && mjConfs.hasOwnProperty(moduleId)) {
		var moduleConf = mjConfs[moduleId];
		return isInRanges(serverVersion, moduleConf.showRanges);
	} else {
		return false;
	}
}

function isInRanges(serverVersion, ranges) {
	if (ranges.length > 1) {
		var checkValidArr = [], checkValidItem;
		for (var i = 0; i < ranges.length; i++) {
			checkValidItem = checkVersionInRange(serverVersion,ranges[i]) ? 1 : 0;
			checkValidArr.push(checkValidItem);
		}

		return checkValidArr.indexOf(1) > -1;
	}
	return checkVersionInRange(serverVersion,ranges[0])
}

function checkVersionInRange(curVersion,range) {
	var rangeMax = range.max;
	var rangeMin = range.min;
	if(rangeMax == 0){
		return mj.isNewVersion(rangeMin,curVersion) >= 0;
	}else{
		return mj.isNewVersion(rangeMin,curVersion) >= 0 && mj.isNewVersion(curVersion,rangeMax) >= 0;
	}
}

/**
 * 多选一情况下
 * 根据版本号跳转不同页面
 * @param targetPage
 * @returns {string}
 */
function getPageByVersion(targetPage){
	var serverVersion = mj.getServerVersion();
	var isServerNewest = mj.isNewVersion(latestServerVersion,serverVersion);
	var prefix;
	if(isServerNewest){
		prefix = '/pages';
	} else {
		prefix = '/' + serverVersion + '-pages';
	}
	return prefix + targetPage;
}
