var MJ_BILL_NAME = {
	BILL_SUPPLIER_PAY: 'supplier-pays',
	BILL_SUPPLIER_ASSET: 'supplier-assets',
	BILL_TRAVEL: 'travels',
	BILL_PREPAY: 'supplier-prepays',
	BILL_REPAYMENT: 'repayments',
	BILL_SUPPLIER_PAY_GOODS: 'supplier-pay-goods',
	BILL_MATERIAL_REQ: 'material-reqs',
	BILL_SALE: 'sales',
	BILL_COLLECTION: 'collections',
	BILL_BANK_DEDUCTION: 'bank-deductions',
	BILL_DEPRECIATION: 'depreciations',
	BILL_ACCRUED: 'accrues',
	BILL_SUPER: 'supers',
	BILL_BUDGET_COLLECT: 'budget-collects',
	BILL_BUDGET_PAY: 'budget-pays',
	BILL_TRANSFER: 'transfers'
};

function getBillNameByType(billType) {
	switch (Number(billType)) {
		case BILL_TYPE_SUPPLIER_PAY:
			return MJ_BILL_NAME.BILL_SUPPLIER_PAY;
		case BILL_TYPE_SUPPLIER_ASSET:
			return MJ_BILL_NAME.BILL_SUPPLIER_ASSET;
		case BILL_TYPE_TRAVEL:
			return MJ_BILL_NAME.BILL_TRAVEL;
		case BILL_TYPE_SUPPLIER_PREPAY:
			return MJ_BILL_NAME.BILL_PREPAY;
		case BILL_TYPE_REPAYMENT:
			return MJ_BILL_NAME.BILL_REPAYMENT;
		case BILL_TYPE_SUPPLIER_PAY_GOODS:
			return MJ_BILL_NAME.BILL_SUPPLIER_PAY_GOODS;
		case BILL_TYPE_MATERIAL_REQ:
			return MJ_BILL_NAME.BILL_MATERIAL_REQ;
		case BILL_TYPE_SALE:
			return MJ_BILL_NAME.BILL_SALE;
		case BILL_TYPE_COLLECTION:
			return MJ_BILL_NAME.BILL_COLLECTION;
		case BILL_TYPE_BANK_DEDUCTION:
			return MJ_BILL_NAME.BILL_BANK_DEDUCTION;
		case BILL_TYPE_DEPRECIATION:
			return MJ_BILL_NAME.BILL_DEPRECIATION;
		case BILL_TYPE_ACCRUED:
			return MJ_BILL_NAME.BILL_ACCRUED;
		case BILL_TYPE_SUPER:
			return MJ_BILL_NAME.BILL_SUPER;
		case BILL_TYPE_BUDGET_COLLECT:
			return MJ_BILL_NAME.BILL_BUDGET_COLLECT;
		case BILL_TYPE_BUDGET_PAY:
			return MJ_BILL_NAME.BILL_BUDGET_PAY;
		case BILL_TYPE_TRANSFER:
			return MJ_BILL_NAME.BILL_TRANSFER;
		default:
			return '';
	}
}

var BILL_VALID_CLMS = {
	accountId: -1,
	num: '',
	applierName: '',
	status: BILL_STATUS_CREATED,
	expenseBelongInt: 0,
	requireTime: '',
	departmentId: -1,
	owner: -1,
	projectId: -1,
	eaId: -1,
	cashFlowId: -1,
	toCurrencyId: -1,
	cashTime: '',
	collectTime: '',
	carId: -1,
	bizId: -1,
	customerId: -1,
	consumerId: -1,
	startTime: '',
	endTime: '',
	ext1: undefined,
	ext2: undefined,
	haveInvoiceInt: undefined,
	budgetTime: new Date(),
	paperNum: '',
	payTargetInt: -1,
	bizTypeInt: BIZ_TYPE_ALL,
	payTypeInt: -1,
	payCurrencyId: -1,
	receiveId: -1,
	receiveBank: '',
	receiveNum: '',
	receiveAccount: '',
	receiveCode: '',
	expense: 0,
	note: '',
	dm1: '',
	dm2: '',
	dm3: '',
	dm4: '',
	dm5: '',
	dm1Id: -1,
	dm2Id: -1,
	dm3Id: -1,
	dm4Id: -1,
	dm5Id: -1
};

//单据费用详情字段
var BILL_FEE_ALL_CLMS = {
	billDcTypeInt: -1,
	departmentId: -1,
	departmentName: '',
	owner: SELECT_PLEASE,
	ownerName: '',
	projectId: SELECT_PLEASE,
	projectName: '',
	eaId: -1,
	eaName: '',
	cashFlowId: -1,
	cashFlowName: '',
	toCurrencyId: -1,
	toCurrencyName: '',
	cashTime: '',
	collectTime: '',
	supplierId: SELECT_PLEASE,
	customerId: SELECT_PLEASE,
	customerName: '',
	consumerId: SELECT_PLEASE,
	consumerName: '',
	carId: SELECT_PLEASE,
	carNum: '',
	bizId: SELECT_PLEASE,
	bizName: '',
	requireTime: '',
	startTime: '',
	endTime: '',
	startAddr: '',
	endAddr: '',
	budget: '',
	totalBudget: '',
	payCurrencyId:PAY_CURRENCY_LOCAL,
	payCurrencyName:'',
	expense: '',
	taxExpense: '',
	bizRate:'',
	bizExpense:'',
	taxEaId: -1,
	expenseExcludeTax: '',
	contractNum: '',
	invoiceNum: '',
	note: '',
	dm1: '',
	dm2: '',
	dm3: '',
	dm4: '',
	dm5: '',
	dm1Id: -1,
	dm2Id: -1,
	dm3Id: -1,
	dm4Id: -1,
	dm5Id: -1
};

var BILL_CLMS_HEADER = {
	payCurrencyId:false,
	expense: true,
	bizRate:false,
	bizExpense:false,
	taxExpense: false,
	taxEaId: false,
	expenseExcludeTax: false,
	invoiceNum: false,
	contractNum: false,
	note: false,
	dm1: false,
	dm2: false,
	dm3: false,
	dm4: false,
	dm5: false,
	dm1Id: false,
	dm2Id: false,
	dm3Id: false,
	dm4Id: false,
	dm5Id: false,
	billDcTypeInt: false,
	departmentId: false,
	owner: false,
	projectId: false,
	eaId: true,
	cashFlowId: false,
	cashTime: false,
	toCurrencyId: false,
	collectTime: false,
	bizId: false,
	supplierId: false,
	customerId: false,
	consumerId: false,
	carId: false,
	startTime: false,
	endTime: false,
	startAddr: false,
	endAddr: false,
	budget: false,
	totalBudget: false
};

var BILL_DETAIL_POSITION = 'bill';
var BILL_FEE_POSITION = 'fee';
var BILL_PAYINFO_POSITION = 'pay';

/**
 * 供应商过滤
 * @returns {boolean|*}
 */
function showFilterWithSupplier(){
	return isShowByVersion(CONST_BILL_FILTER_SUPPLIER_SHOW);
}

/**
 * 申请人过滤
 * @returns {boolean|*}
 */
function showFilterWithOwner(){
	return isShowByVersion(CONST_BILL_FILTER_OWNER_SHOW);
}

function showFilterWithSupplierOwner(){
	return showFilterWithSupplier() && showFilterWithOwner();
}

//单据详情
function mjQueryBillDetail(billId, callback) {
	setTimeout(function(){
		mj.get(MJ_URL.BILL_API.mjFormat(billId), {}, function(data) {
			callback && callback(data);
		}, function(xhr) {
			showResult(xhr, LOST_NETWORK_CONNECTION);
		});
	},20);
}

//字典配置单据费用详情字段
function mjQueryDictByKey(confKey, callback) {
	mj.get(MJ_URL.DICT_BY_KEY.mjFormat(confKey), {}, function(d) {
		callback && callback(d.data[0]);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//员工关联借款单
function mjQueryUserLoans(params, callback) {
	mj.get(MJ_URL.BILL_F_PAYING_LOANS, params, function(d) {
		callback && callback(d);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//供应商预付款单
function mjQueryCustomerPrepays(params, callback) {
	mj.get(MJ_URL.BILL_F_PAYING_PREPAYS, params, function(d) {
		callback && callback(d);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//单据借款单详情
function queryBillLoans(billId, callback) {
	mj.get(MJ_URL.BILL_F_LOANS.mjFormat(billId), {}, function(data) {
		callback && callback(data);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//单据报销明细详情
function queryBillFees(billId, callback) {
	mj.get(MJ_URL.BILL_F_FEES.mjFormat(billId), {}, function(data) {
		callback && callback(data);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//费用可用预算
function mjQueryBudgetForFee(parameters, callback) {
	mj.get(MJ_URL.BUDGET_B_GET_BUDGET, parameters, function(data) {
		callback && callback(data);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}
//获取可用预算
function getBudgetForFee(feeClms, billFor, refId, eaId, billBudgetTime) {
	var budget = 0;
	var totalBudget = 0;
	var objFeeBudget = document.querySelector('.fee-budget');
	var objFeeTotalBudget = document.querySelector('.fee-total-budget');
	var containTotal = feeClms.totalBudget && feeClms.totalBudget == true;
	if (billBudgetTime == '') {
		return false;
	}

	if (refId > 0 && eaId > 0) {
		var $this = this;
		var parameters = {
			belong: billFor,
			ref: refId,
			ea: eaId,
			budgetTime: billBudgetTime,
			containTotal: containTotal
		};

		mjQueryBudgetForFee(parameters, function(res) {
			if (res.status == SYSTEM_SUCCEED && res.data != undefined) {
				if (res.data.left != undefined) budget = res.data.left;
				if (res.data.total != undefined) totalBudget = res.data.total;

				if (objFeeBudget) objFeeBudget.value = budget ? budget : 0;
				if (objFeeTotalBudget) objFeeTotalBudget.value = totalBudget ? totalBudget : 0;
			}
		});
	}
}
//重置可用预算
function resetBudgetForFee() {
	var budget = 0;
	var totalBudget = 0;
	var objFeeBudget = document.querySelector('.fee-budget');
	var objFeeTotalBudget = document.querySelector('.fee-total-budget');
	if (objFeeBudget) objFeeBudget.value = budget;
	if (objFeeTotalBudget) objFeeTotalBudget.value = totalBudget;
}
//重置会计科目
function resetFeeEa() {
	document.getElementById('feeSelectedEaName').innerText = '';
	currentFee.eaId = -1;
	currentFee.eaName = '';
}
//显示单据详情
function showDetailView(objItem) {
	var billId = objItem.getAttribute('pid');
	var billType = objItem.getAttribute('ptype');
	showBillDetailView('newWebview_Second', billId, billType)
}
//列表列表样式模板
function generateBillList(list) {
	var listHtml = '';
	var listItem;
	var departmentName, ownerName;
	for (var i = 0; i < list.length; i++) {
		listItem = list[i];
		departmentName = list[i].departmentName ? list[i].departmentName : '';
		ownerName = list[i].ownerName ? (': ' + list[i].ownerName) : '';
		var createDate = new Date(listItem.budgetTime).format('yyyy/MM/dd');
		listHtml += '' +
			'<li class="mui-table-view-cell list-item bill-list-item" pid="' + list[i].id + '" pstatus="' + list[i].status +
			'" ptype="' + list[i].billTypeInt + '">' +
			'	<div class="mui-media-body list-wrapper">' +
			'		<div class="list-first-line">' +
			'			<span class="mj-list-title">' + mj.getBillName(list[i].billTypeInt) + '</span>' +
			'			<span class="mj-list-status mui-ellipsis">' + getBillStatus(list[i].status, list[i].billTypeInt) + '</span>' +
			'			<span class="mj-list-expense mj-pull-right">￥' + Number(list[i].expense).toFixed(2) + '</span>' +
			'		</div>' +
			'		<div class="list-second-line">' +
			'			<span class="mj-list-valid mj-list-department mui-ellipsis">' + departmentName + '</span>' +
			'			<span class="mj-list-valid mj-list-owner mui-ellipsis">' + ownerName + '</span>' +
			'		</div>' +
			'		<div class="list-third-line mui-ellipsis">' +
			'			<span class="mj-list-valid">用途：</span>' +
			'			<span class="mj-list-valid mj-list-note">' + (list[i].note ? list[i].note : '') + '</span>' +
			'		</div>' +
			'		<div class="list-fourth-line mui-ellipsis">' +
			'			<span class="mj-list-note mui-ellipsis">' + list[i].num + '</span>' +
			'			<span class="mj-list-valid mj-list-date mui-pull-right">' + createDate + '</span>' +
			'		</div>' +
			'	</div>' +
			'</li>';
	}
	return listHtml;
}

//冲抵借款单模板
//冲抵借款创建页
function generateLoadLoans(list) {
	var listHtml = '';
	var listItem;
	for (var i = 0; i < list.length; i++) {
		listItem = list[i];
		listHtml += '' +
			'<li class="mui-table-view-cell loans-table-view" lid="' + listItem.loanId + '" lrate = "' + listItem.adjustRate +
			'">' +
			'	<div class="mui-input-row mui-checkbox mui-left loans-info">' +
			'		<label>' +
			'			<div class="import-loan-bill-info">' +
			'				<span id="loanNum">' + listItem.loanNum + '</span>' +
			'			</div>' +
			'			<div class="import-loan-bill-info pay-before-wrapper">' +
			'				<span>待还' + (listItem.currencyName ? listItem.currencyName : '') + ':</span>' +
			'				<span id="payBefore" class="pay-before">' + listItem.payBefore + '</span>' +
			'			</div>' +
			'			<div class="import-loan-bill-info mui-ellipsis">' +
			'				<span>借款说明:</span>' +
			'				<span id="loanNote">' + listItem.loanNote + '</span>' +
			'			</div>' +
			'		</label>' +
			'		<input name="loans" value="" type="checkbox" ' + (listItem.selected ? 'checked' : 'disabled') + '>' +
			'	</div>' +
			'	<div class="mj-pull-right paid-wrapper edit-loan-paid">' +
			'		<span id="paid" class="paid">' + Number(listItem.paid).toFixed(2) + '</span>' +
			'		<span class="mui-icon iconfont icon-jihua-bianji-li icon-edit-loan-paid"></span>';
		if (listItem.adjustPaid) {
			listHtml +=
				'		<div class="clr adjust-paid">折:' + Number(listItem.adjustPaid).toFixed(2) + '</div>';
		} else {
			listHtml +=
				'		<div class="clr adjust-paid"></div>';
		}
		listHtml +=
			'	</div>' +
			'</li>';
	}
	listHtml += '';
	return listHtml;
}
//冲抵借款单详情页
function generateBillDetailLoadLoans(list) {
	var listHtml = '';
	var listItem;
	for (var i = 0; i < list.length; i++) {
		listItem = list[i];
		listHtml += '' +
			'<li class="mui-table-view-cell loans-table-view" lid="' + list[i].loanId + '">' +
			'	<div class="loan-detail-info">' +
			'		<div class="import-loan-bill-info">' +
			'			<span id="loanNum">' + list[i].loanNum + '</span>' +
			'			<span class="mj-pull-right bill-color-light">还' + list[i].currencyName + ':' + list[i].paid + '</span>' +
			'		</div>' +
			'		<div class="import-loan-bill-info">' +
			'			<span>待还' + list[i].currencyName + '：</span>' +
			'			<span id="payBefore">' + list[i].payAfter + '</span>' +
			'			<span class="mj-pull-right bill-color-light">汇率:' + list[i].adjustRate + '</span>' +
			'		</div>' +
			'		<div class="import-loan-bill-info loan-bill-detail-info mui-ellipsis">' +
			'			<span>借款说明:</span>' +
			'			<span id="loanNote" class="mui-col-sm-6 mui-col-xs-6 mui-inline mui-text-left mui-ellipsis pd0">' + list[i].loanNote +
			'			</span>' +
			'			<span class="mj-pull-right bill-color-light">折:' + list[i].adjustPaid + '</span>' +
			'		</div>' +
			'	</div>' +
			'</li>';
	}
	listHtml += '';
	return listHtml;
}
//单据费用详情字段的配置
function doGetFeeTableColumnsHeader(feeClms, $feeClms) {
	var clmHtml = '<ul class="mui-table-view">';
	mui.each(feeClms, function(key, val) {
		if (!feeClms[key]) {
			return true;
		}

		switch (key) {
			case 'departmentId':
				clmHtml +=
					'<li id="feeDepartmentCell" class="mui-table-view-cell no-left-table-view-cell fee-detail-department-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span>归属部门</span>' +
					'		<span id="feeSelectedDepartmentName" class="mui-pull-right selected-text fee-department"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'owner':
				clmHtml += '<li id="feeOwnerCell" class="mui-table-view-cell no-left-table-view-cell fee-owner-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">业务员</span>';
						break;
					default:
						clmHtml += '<span class="table-text">归属人</span>';
						break;
				}
				clmHtml += '		<span id="feeSelectedOwnerName" class="mui-pull-right selected-text fee-owner"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'projectId':
				clmHtml += '<li id="feeProjectCell" class="mui-table-view-cell no-left-table-view-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span class="table-text">关联项目</span>' +
					'		<span id="feeSelectedProjectName" class="mui-pull-right selected-text fee-project"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'eaId':
				clmHtml += '<li id="feeEaCell" class="mui-table-view-cell no-left-table-view-cell fee-ea-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';

				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款类型</span>';
						break;
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">收入类型</span>';
						break;
					case BILL_TYPE_SUPPLIER_ASSET:
						clmHtml += '<span class="table-text">资产类型</span>';
						break;
					default:
						clmHtml += '<span class="table-text">会计科目</span>';
						break;
				}
				clmHtml += '		<span id="feeSelectedEaName" class="mui-pull-right selected-text fee-selected-ea fee-ea"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'cashFlowId':
				clmHtml += '<li id="feeCashFlowCell" class="mui-table-view-cell no-left-table-view-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="feeCashFlowText" class="table-text unlinked-text">现金流量项目</span>' +
					'		<span id="feeSelectedCashFlowName" class="mui-pull-right selected-text fee-cash-flow"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'toCurrencyId':
				clmHtml += '<li id="feeCurrencyCell" class="mui-table-view-cell no-left-table-view-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="feeCurrencyText" class="table-text unlinked-text">冲应收币别</span>' +
					'		<span id="feeSelectedCurrencyName" class="mui-pull-right selected-text fee-currency"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'cashTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-time-select">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '	<span class="table-text">银行收款日期</span>';
						break;
					case BILL_TYPE_BANK_DEDUCTION:
					default:
						clmHtml += '	<span class="table-text">扣款日期</th>';
						break;
				}
				clmHtml += '	<span id="feeCashTime" class="mui-pull-right selected-fee-time fee-cash-time"></span>' +
					'</li>';
				break;
			case 'collectTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-collect-time-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
					case BILL_TYPE_BUDGET_COLLECT:
						clmHtml += '	<span id="feeCollectTimeText" class="table-text unlinked-text">预计收款日期</span>';
						break;
					case BILL_TYPE_BUDGET_PAY:
						clmHtml += '	<span id="feeCollectTimeText" class="table-text unlinked-text">预计付款日期</span>';
						break;
					default:
						clmHtml += '	<span id="feeCollectTimeText" class="table-text unlinked-text">实际收款日期</th>';
						break;
				}
				clmHtml += '	<span id="feeCollectTime" class="mui-pull-right selected-fee-collect-time fee-collect-time"></span>' +
					'</li>';
				break;
			case 'bizId':
				clmHtml += '<li id="feeBizCell" class="mui-table-view-cell no-left-table-view-cell fee-biz-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span class="table-text">业务活动</span>' +
					'		<span id="feeSelectedBizName" class="mui-pull-right selected-text fee-biz"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'supplierId':
			case 'customerId':
				clmHtml +=
					'<li id="feeCustomerCell" class="mui-table-view-cell no-left-table-view-cell fee-customer-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款单位</span>';
						break;
					default:
						clmHtml += '<span class="table-text">供应商</span>';
						break;
				}
				clmHtml += '		<span id="feeSelectedCustomerName" class="mui-pull-right selected-text fee-customer"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'consumerId':
				clmHtml +=
					'<li id="feeConsumerCell" class="mui-table-view-cell no-left-table-view-cell fee-consumer-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款单位</span>';
						break;
					default:
						clmHtml += '<span class="table-text">客户</span>';
						break;
				}
				clmHtml += '		<span id="feeSelectedConsumerName" class="mui-pull-right selected-text fee-consumer"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'carId':
				clmHtml += '<li id="feeCarCell" class="mui-table-view-cell no-left-table-view-cell fee-car-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span class="table-text">车辆</span>' +
					'		<span id="feeSelectedCarNum" class="mui-pull-right selected-text fee-car"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'payCurrencyId':
				clmHtml += '<li id="feePayCurrencyIdCell" class="mui-table-view-cell no-left-table-view-cell fee-pay-currency-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span class="table-text">币别</span>' +
					'		<span id="feeSelectedPayCurrencyName" class="mui-pull-right selected-text fee-pay-currency"></span>' +
					'	</a>' +
					'</li>';
				break;
			case 'expense':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">含税收入</span>';
						break;
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款金额</span>';
						break;
					case BILL_TYPE_SUPPLIER_PAY_GOODS:
						clmHtml += '<span class="table-text">付款金额</span>';
						break;
					case BILL_TYPE_SUPER:
						if(checkWindowProperty('billMultiCurrency')){
							clmHtml += '<th class="table-text">原币金额</th>';
						}else{
							clmHtml += '<th class="table-text">报销金额</th>';
						}
						break;
					default:
						clmHtml += '<span class="table-text">报销金额</span>';
						break;
				}

				clmHtml +=
					'	<input id="feeExpense" type="number" class="mui-pull-right bill-table-text fee-expense fee-expense-input" placeholder="" value="">' +
					'</li>';
				break;
			case 'bizRate':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">汇率</span>' +
					'	<input id="feeBizRate" type="number" class="mui-pull-right bill-table-text fee-biz-rate" placeholder="" value="" disabled>' +
					'</li>';
				break;
			case 'bizExpense':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">本位币金额</span>' +
					'	<input id="feeBizExpense" type="number" class="mui-pull-right bill-table-text fee-biz-expense" placeholder="" value="" disabled>' +
					'</li>';
				break;
			case 'taxExpense':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text fee-tax-text">销项税</span>';
						break;
					default:
						clmHtml += '<span class="table-text fee-tax-text">进项税</span>';
						break;
				}

				clmHtml +=
					'	<input id="feeTaxExpense" type="number" class="mui-pull-right bill-table-text fee-taxexpense fee-expense-input" placeholder="" value="">' +
					'</li>' +
					'<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">不含税收入</span>';
						break;
					default:
						clmHtml += '<span class="table-text">不含税金额</span>';
						break;
				}

				clmHtml +=
					'	<input id="feeExpenseExcludeTax" type="number" class="mui-pull-right bill-table-text fee-expense-exclude-tax" placeholder="" value="" disabled>' +
					'</li>';
				break;
			case 'budget':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">科目可用预算</span>' +
					'	<input id="feeBudget" type="number" class="mui-pull-right bill-table-text fee-budget" placeholder="" value="" disabled>' +
					'</li>';
				break;
			case 'totalBudget':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">可用总预算</span>' +
					'	<input id="feeTotalBudget" type="number" class="mui-pull-right bill-table-text fee-total-budget" placeholder="" value="" disabled>' +
					'</li>';
				break;
			case 'contractNum':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">合同号</span>' +
					'	<input id="feeContractNum" type="text" class="mui-pull-right bill-table-text fee-contract-num" placeholder="" value="">' +
					'</li>';
				break;
			case 'invoiceNum':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">发票号</span>' +
					'	<input id="feeInvoiceNume" type="number" class="mui-pull-right bill-table-text fee-invoice-num" placeholder="" value="">' +
					'</li>';
				break;
			case 'note':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell last-table-cell">' +
					'	<span class="table-text">备注</span>' +
					'	<textarea id="feeNote" placeholder="请输入……" class="fee-note"></textarea>' +
					'</li>';
				break;
			case 'startTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-time-select">' +
					'	<span class="table-text">开始时间</span>' +
					'	<span id="feeStartTime" class="mui-pull-right selected-fee-time"></span>' +
					'</li>';
				break;
			case 'endTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-time-select">' +
					'	<span class="table-text">结束时间</span>' +
					'	<span id="feeEndTime" class="mui-pull-right selected-fee-time"></span>' +
					'</li>';
				break;
			case 'startAddr':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">起始地址</span>' +
					'	<input id="feeStartAddr" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
					'</li>';
				break;
			case 'endAddr':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">结束地址</span>' +
					'	<input id="feeEndAddr" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
					'</li>';
				break;
			case 'dm1':
				if (showDm1Input) {
					clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM1) + '</span>' +
						'	<input id="feeDm1" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
						'</li>';
				} else if (showDm1Select) {
					clmHtml += '<li id="feeDm1Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm1-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM1) + '</span>' +
						'		<span id="feeSelectedDm1" class="mui-pull-right selected-text fee-dm1"></span>' +
						'	</a>' +
						'</li>';
				}
				break;
			case 'dm2':
				if (showDm2Input) {
					clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM2) + '</span>' +
						'	<input id="feeDm2" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
						'</li>';
				} else if (showDm2Select) {
					clmHtml += '<li id="feeDm2Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm2-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM2) + '</span>' +
						'		<span id="feeSelectedDm2" class="mui-pull-right selected-text fee-dm2"></span>' +
						'	</a>' +
						'</li>';
				}

				break;
			case 'dm3':
				if (showDm3Input) {
					clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM3) + '</span>' +
						'	<input id="feeDm3" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
						'</li>';
				} else if (showDm3Select) {
					clmHtml += '<li id="feeDm3Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm3-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM3) + '</span>' +
						'		<span id="feeSelectedDm3" class="mui-pull-right selected-text fee-dm3"></span>' +
						'	</a>' +
						'</li>';
				}
				break;
			case 'dm4':
				if (showDm4Input) {
					clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM4) + '</span>' +
						'	<input id="feeDm4" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
						'</li>';
				} else if (showDm4Select) {
					clmHtml += '<li id="feeDm4Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm4-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM4) + '</span>' +
						'		<span id="feeSelectedDm4" class="mui-pull-right selected-text fee-dm4"></span>' +
						'	</a>' +
						'</li>';
				}
				break;
			case 'dm5':
				if (showDm5Input) {
					clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM5) + '</span>' +
						'	<input id="feeDm5" type="text" class="mui-pull-right bill-table-input" placeholder="" value="" >' +
						'</li>';
				} else if (showDm5Select) {
					clmHtml += '<li id="feeDm5Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm5-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM5) + '</span>' +
						'		<span id="feeSelectedDm5" class="mui-pull-right selected-text fee-dm5"></span>' +
						'	</a>' +
						'</li>';
				}
				break;
			default:
				break;
		}
	});
	clmHtml += '</ul>';
	return clmHtml;
}

//贷方信息详情字段
function doGetCrFeeTableColumnsHeader() {
	var clmHtml = '<ul class="mui-table-view">' +
		'	<li id="crFeeEaCell" class="mui-table-view-cell no-left-table-view-cell cr-fee-ea-table-cell">' +
		'		<a class="mui-navigate-right no-spacing-navigate-right">' +
		'			<span class="table-text">会计科目</span>' +
		'			<span id="crFeeSelectedEaName" class="mui-pull-right selected-text cr-fee-selected-ea cr-fee-ea"></span>' +
		'		</a>' +
		'	</li>' +
		'	<li class="mui-table-view-cell no-left-table-view-cell">' +
		'		<span class="table-text">金额</span>' +
		'		<input id="crFeeExpense" type="number" class="mui-pull-right bill-table-text cr-fee-expense cr-fee-expense-input" placeholder="" value="">' +
		'	</li>' +
		'</ul>';
	return clmHtml;
}

//收款款单借方信息字段
function doGetCollectionDrFeeTableColumnsHeader(isCashFlowEnable) {
	var clmHtml = '' +
		'<ul class="mui-table-view">' +
		'	<li id="feeCollectionDrEaCell" class="mui-table-view-cell no-left-table-view-cell cr-fee-ea-table-cell">' +
		'		<a class="mui-navigate-right no-spacing-navigate-right">' +
		'			<span class="table-text">会计科目</span>' +
		'			<span id="feeCollectionSelectedDrEaName" class="mui-pull-right selected-text cr-fee-selected-ea cr-fee-ea"></span>' +
		'		</a>' +
		'	</li>';
	if (isCashFlowEnable) {
		clmHtml +=
			'<li id="feeCollectionDrCashFlowCell" class="mui-table-view-cell no-left-table-view-cell">' +
			'	<a class="mui-navigate-right no-spacing-navigate-right">' +
			'		<span id="feeCollectionDrCashFlowText" class="table-text unlinked-text">现金流量项目</span>' +
			'		<span id="feeCollectionSelectedDrCashFlowName" class="mui-pull-right selected-text fee-cash-flow"></span>' +
			'	</a>' +
			'</li>';
	}
	clmHtml +=
		'<li class="mui-table-view-cell no-left-table-view-cell fee-time-select">' +
		'	<span class="table-text">银行收款日期</span>' +
		'	<span id="feeCollectionDrCashTime" class="mui-pull-right selected-fee-time"></span>' +
		'</li>' +
		'	<li class="mui-table-view-cell no-left-table-view-cell">' +
		'		<span class="table-text">金额</span>' +
		'		<input id="feeCollectionDrFeeExpense" type="number" class="mui-pull-right bill-table-text cr-fee-expense cr-fee-expense-input" placeholder="" value="">' +
		'	</li>' +
		'<li class="mui-table-view-cell no-left-table-view-cell last-table-cell">' +
		'	<span class="table-text">备注</span>' +
		'	<textarea id="feeCollectionDrNote" placeholder="请输入……" class="fee-note"></textarea>' +
		'</li>' +
		'</ul>';
	return clmHtml;
}

function generateCollectionDrFeeBillDetaiTableColumns(fee) {
	var clmHtml = '<ul class="mui-table-view" uid="' + fee.id + '">';
	var changeDrEaString =
		'	<li id="feeCollectionDrEaCell" class="mui-table-view-cell no-left-table-view-cell cr-fee-ea-table-cell">' +
		'		<a class="mui-navigate-right no-spacing-navigate-right">' +
		'			<span class="table-text">会计科目</span>' +
		'			<span id="feeCollectionSelectedDrEaName" class="mui-pull-right selected-text fee-selected-collection-dr-ea fee-ea">' +
		(fee.eaName ? fee.eaName : '') + '</span>' +
		'		</a>' +
		'	</li>';

	var showDrEaString =
		'<li class="mui-table-view-cell no-left-table-view-cell fee-ea-table-cell">' +
		'	<span class="table-text">会计科目</span>' +
		'	<span class="mui-pull-right">' + (fee.eaName ? fee.eaName : '') + '</span>' +
		'</li>';

	if (has_bill_tax_change_permission && canReview) {
		if (BILL_STATUS_REVIEWING == fee.status) {
			clmHtml += changeDrEaString;
		} else {
			clmHtml += showDrEaString;
		}
	} else {
		clmHtml += showDrEaString;
	}


	if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable) {
		var showCashFlowString =
			'<li class="mui-table-view-cell no-left-table-view-cell fee-cash-flow-table-cell">' +
			'	<span class="table-text">现金流量项目</span>' +
			'	<span class="mui-pull-right">' + (fee.cashFlowName ? fee.cashFlowName : '') + '</span>' +
			'</li>';

		var changeCashFlowString =
			'<li id="feeCollectionDrCashFlowCell" class="mui-table-view-cell no-left-table-view-cell">' +
			'	<a class="mui-navigate-right no-spacing-navigate-right">' +
			'		<span id="feeCollectionDrCashFlowText" class="table-text unlinked-text">现金流量项目</span>' +
			'		<span id="feeCollectionSelectedDrCashFlowName" class="mui-pull-right selected-text fee-selected-collection-dr-cash-flow"> ' +
			(fee.cashFlowName ? fee.cashFlowName : '') + '</span>' +
			'	</a>' +
			'</li>';

		var updateCashFlowStringAfterReview =
			'<li id="updateCollectionDrCashFlowCellAfterReview" class="mui-table-view-cell no-left-table-view-cell">' +
			'	<a class="mui-navigate-right no-spacing-navigate-right">' +
			'		<span id="updateCollectionDrCashFlowText" class="table-text">现金流量项目</span>' +
			'		<span class="iconfont icon-faqi-xiangmujihua"></span>' +
			'		<span id="updateCollectionDrSelectedCashFlowName" class="mui-pull-right selected-text">' + (fee.cashFlowName ?
				fee.cashFlowName : '') + '</span>' +
			'	</a>' +
			'</li>';

		switch (Number(fee.status)) {
			case BILL_STATUS_REVIEWING:
				if (has_bill_tax_change_permission && canReview) {
					clmHtml += changeCashFlowString;
				} else {
					clmHtml += showCashFlowString;
				}
				break;
			case BILL_STATUS_APPROVED:
			case BILL_STATUS_PAID:
			case BILL_STATUS_COLLECT:
				if (has_bill_cashflow_permission && fee.cashFlowId > 0) {
					clmHtml += updateCashFlowStringAfterReview;
				} else {
					clmHtml += showCashFlowString;
				}
				break;
			case BILL_STATUS_CANCELLED:
			case BILL_STATUS_CREATED:
			case BILL_STATUS_REJECTED:
			case BILL_STATUS_ABOLISH:
			default:
				clmHtml += showCashFlowString;
				break;
		}
	}

	clmHtml +=
		'<li class="mui-table-view-cell no-left-table-view-cell fee-cash-flow-table-cell">' +
		'	<span class="table-text">银行收款日期</span>' +
		'	<span class="mui-pull-right">' + (fee.cashTime ? new Date(fee.cashTime).format('yyyy-MM-dd') : '') + '</span>' +
		'</li>' +
		'<li class="mui-table-view-cell no-left-table-view-cell">' +
		'	<span class="table-text">金额</span>' +
		'	<span class="mui-pull-right fee-detail-expense">' + (fee.expense ? fee.expense.toFixed(2) : '') + '</span>' +
		'</li>' +
		'<li class="mui-table-view-cell no-left-table-view-cell">' +
		'	<span class="table-text">备注</span>' +
		'	<span class="mui-pull-right">' + (fee.note ? fee.note : '') + '</span>' +
		'</li>';

	return clmHtml;
}

//详情页内容区显示明细模板
function generateBillDetailContentFees(list, $page) {
	var listHtml = '';
	var listItem;
	var curBillType = checkWindowProperty('currentBillType');
	for (var i = 0; i < list.length; i++) {
		listItem = list[i];
		listHtml +=
			'<li class="mui-table-view-cell no-spacing-teble-view-cell fees-table-view" id="fee-item-' + listItem.id + '" vid="' +
			listItem.id + '" style="border-bottom:1px solid #ddd;">' +
			'	<a href="' + $page + '" class="mui-navigate-right no-spacing-navigate-right">' +
			'		<div class="fee-info-detail-wrapper mui-ellipsis">';

		switch (Number(curBillType)) {
			case BILL_TYPE_BUDGET_COLLECT:
			case BILL_TYPE_BUDGET_PAY:
				listHtml +=
					'		<span class="fee-simple-detail-department">' + (listItem.departmentName ? listItem.departmentName : '未选部门') +
					'</span>' +
					'		&#40;<span class="fee-simple-cashflow">' + (listItem.cashFlowName ? listItem.cashFlowName : '未选现金流量项目') +
					'</span>&#41;';
				break;
			case BILL_TYPE_SUPPLIER_PAY_GOODS:
				listHtml +=
					'		<span class="fee-simple-proj">' + (listItem.projectName ? listItem.projectName : (listItem.note ? listItem.note :
						'')) + '</span>';
				break;
			default:
				listHtml +=
					'		<span class="fee-simple-detail-department">' + (listItem.departmentName ? listItem.departmentName : '未选部门') +
					'		</span>' +
					'		&#40;<span id="fee-s-ea-' + listItem.id + '"  class="fee-simple-detail-ea">' + (listItem.eaName ? listItem.eaName :
						'未选科目') + '</span>&#41;';
				break;
		}

		listHtml +=
			'		</div>' +
			'		<span id="fee-s-expense-' + listItem.id + '" class="mj-pull-right fee-simple-detail-expense">' + Number(listItem.expense)
			.toFixed(2) + '</span>' +
			'	</a>' +
			'</li>';
	}
	listHtml += '';
	return listHtml;
}
//借方信息费用详情编辑页
function renderBillFeesForEdit(billId, feeHeaderDictKey) {
	queryBillFees(billId, function(data) {
		var feeList = data;
		var feeItem;
		for (var i = 0; i < feeList.length; i++) {
			feeItem = feeList[i];
			feeMap[feeItem.id] = feeItem;
			if (feeLength < feeItem.id) {
				feeLength = feeItem.id;
			}
		}
		feeLength++;
		generateFeeSummaryListForEdit(data, objFeesList);
	});

	getFeeTableColumnsHeaderForDetail(feeHeaderDictKey, defaultFeeClms,
		function(_feeClms, data) {
			feeClms = _feeClms;
			dms = data;
		},
		function(_feeClms) {
			getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, _feeClms);
		});
}

function generateFeeSummaryListForEdit(feeList, objFeeList) {
	for (var i = 0; i < feeList.length; i++) {
		buildFeeSummaryForEdit(feeList[i], objFeeList);
	}
}

function buildFeeSummaryForEdit(fee, objFeeList) {
	var objFee = document.createElement('div');
	objFee.className = 'fee-item fee-item-' + fee.id;
	objFee.setAttribute("id", 'fee-item-' + fee.id);
	objFee.setAttribute("vid", fee.id);
	var objFeeSummary = '';
	objFeeSummary += '<a href="#feeDetailPage" class="fee-item-link">' +
		'		<div class="fee-info-detail-wrapper mui-ellipsis">';
	if (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_SUPPLIER_PAY_GOODS) {
		objFeeSummary +=
			'		<span id="fee-s-proj-' + fee.id + '" class="fee-simple-proj">' + (fee.projectName ? fee.projectName : (fee.note ?
				fee.note : '')) + '</span>';
	} else {
		objFeeSummary +=
			'		<span id="fee-s-dept-' + fee.id + '" class="fee-simple-department">' + (fee.departmentName ? fee.departmentName :
				'未选部门') + '</span>' +
			'		&#40;<span id="fee-s-ea-' + fee.id + '" class="fee-simple-ea">' + (fee.eaName ? fee.eaName : '未选科目') +
			'			</span>&#41;';
	}
	objFeeSummary +=
		'	</div>' +
		'	<span id="fee-s-expense-' + fee.id + '" class="fee-simple-expense">' + Number(fee.expense).toFixed(2) + '</span>' +
		'</a>' +
		'<span class="mj-pull-right iconfont icon-baoxiaomingxi-jian fee-simple-delete"></span>';
	objFee.innerHTML = objFeeSummary;
	objFee.addEventListener('tap', function() {
		currentFeeId = this.getAttribute("vid");
		currentFee = feeMap[currentFeeId];
		oldScrollHeight = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
		mj.scrollToTop();

		if (window.hasOwnProperty('currentBillType')) {
			switch (currentBillType) {
				case BILL_TYPE_SALE:
					if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
						renderFeeCollectTimeText(billEaTypeInt, currentFee.collectTime, 'feeCollectTimeText', 'feeCollectTime');
					}
					break;
				case BILL_TYPE_COLLECTION:
					if (window.hasOwnProperty('billPayTarget')) {
						renderPayTargetObjSelectForFee(billPayTarget, document.getElementById('feeDetailPage'));
					}
					if (window.hasOwnProperty('isToCurrency') && isToCurrency) {
						renderFeeCurrencyText(currentFee.eaTypeInt, currentFee.toCurrencyName, 'feeCurrencyText',
							'feeSelectedCurrencyName');
					}
					if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
						renderFeeCollectTimeText(currentFee.eaTypeInt, currentFee.collectTime, 'feeCollectTimeText', 'feeCollectTime');
					}
					break;
				default:
					break;
			}
			renderFeeTaxExpense();
		}

		renderFeeUI(currentFee);

		mj.enableBtn(document.getElementById('btnConfirmFees'));
	});

	objFeeList.appendChild(objFee);

	return objFee;
}

function updateFeeSummary(fee) {
	if (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_SUPPLIER_PAY_GOODS) {
		document.getElementById('fee-s-proj-' + fee.id).innerText = (fee.projectName ? fee.projectName : (fee.note ? fee.note :
			''));
	} else {
		document.getElementById('fee-s-dept-' + fee.id).innerText = (fee.departmentName ? fee.departmentName : '未选部门');
		document.getElementById('fee-s-ea-' + fee.id).innerText = (fee.eaName ? fee.eaName : '未选科目');
	}
	document.getElementById('fee-s-expense-' + fee.id).innerText = Number(fee.expense).toFixed(2);
}

function initFee(options) {
	options = options || {};
	var feeHeaderDictKey = options.feeHeaderDictKey;
	var feeDirect = options.feeDirect;
	var feeDetailWrapperShowId = options.feeDetailWrapperShowId;
	var feeListShowId = options.feeListShowId;
	var feePageShowId = options.feePageShowId;
	var btnAddFeeTapId = options.btnAddFeeTapId;
	var btnConfirmFeeTapId = options.btnConfirmFeeTapId;
	var btnBackActionOnHead = options.btnBackAction;

	var objFeeDetailPage = document.getElementById(feePageShowId);
	var $feeList = mui('#' + feeListShowId);
	var $feeDetailPage = mui('#' + feePageShowId);
	var $btnConfirmFees = document.getElementById(btnConfirmFeeTapId);
	var objFeesList = document.getElementById(feeListShowId);

	//明细右上角返回按钮
	document.getElementById(btnBackActionOnHead).addEventListener('tap', function() {
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	//添加费用
	document.querySelector('#' + btnAddFeeTapId).addEventListener('tap', function() {
		currentFeeId = -1;
		currentFee = mui.extend({}, BILL_FEE_ALL_CLMS);
		currentFee.id = currentFeeId;
		oldScrollHeight = document.body.scrollTop;
		mj.scrollToTop();

		if (window.hasOwnProperty('currentBillType')) {
			switch (currentBillType) {
				case BILL_TYPE_SALE:
					if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
						renderFeeCollectTimeText(billEaTypeInt, currentFee.collectTime, 'feeCollectTimeText', 'feeCollectTime');
					}
					break;
				case BILL_TYPE_COLLECTION:
					if (window.hasOwnProperty('billPayTarget')) {
						renderPayTargetObjSelectForFee(billPayTarget, objFeeDetailPage);
					}
					if (window.hasOwnProperty('isToCurrency') && isToCurrency) {
						renderFeeCurrencyText(undefined, undefined, 'feeCurrencyText', 'feeSelectedCurrencyName');
					}
					if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
						renderFeeCollectTimeText(undefined, undefined, 'feeCollectTimeText', 'feeCollectTime');
					}
					break;
				default:
					break;
			}
			renderFeeTaxExpense();
		}

		mj.enableBtn($btnConfirmFees);
		renderFeeUI(currentFee);
	});

	//确认增加报销明细
	$feeDetailPage.on('tap', '#' + btnConfirmFeeTapId, function() {
		var objFeeSelectedDepartmentName = document.getElementById('feeSelectedDepartmentName');
		var objFeeSelectedProjectName = document.getElementById('feeSelectedProjectName');
		var objFeeSelectedOwnerName = document.getElementById('feeSelectedOwnerName');
		var objFeeSelectedEaName = document.getElementById('feeSelectedEaName');
		var objFeeSelectedCashFlowName = document.getElementById('feeSelectedCashFlowName');
		var objFeeSelectedCurrencyName = document.getElementById('feeSelectedCurrencyName');
		var objFeeSelectedBizName = document.getElementById('feeSelectedBizName');
		var objFeeSelectedCustomerName = document.getElementById('feeSelectedCustomerName');
		var objFeeSelectedConsumerName = document.getElementById('feeSelectedConsumerName');
		var objFeeSelectedCarNum = document.getElementById('feeSelectedCarNum');

		var objFeeCashTime = document.getElementById('feeCashTime');
		var objFeeCollectTime = document.getElementById('feeCollectTime');
		var objFeeStartTime = document.getElementById('feeStartTime');
		var objFeeEndTime = document.getElementById('feeEndTime');
		var objFeeStartAddr = document.getElementById('feeStartAddr');
		var objFeeEndAddr = document.getElementById('feeEndAddr');

		var objFeeDm1 = document.getElementById('feeDm1');
		var objFeeDm2 = document.getElementById('feeDm2');
		var objFeeDm3 = document.getElementById('feeDm3');
		var objFeeDm4 = document.getElementById('feeDm4');
		var objFeeDm5 = document.getElementById('feeDm5');

		var objFeeSelectedDm1 = document.getElementById('feeSelectedDm1');
		var objFeeSelectedDm2 = document.getElementById('feeSelectedDm2');
		var objFeeSelectedDm3 = document.getElementById('feeSelectedDm3');
		var objFeeSelectedDm4 = document.getElementById('feeSelectedDm4');
		var objFeeSelectedDm5 = document.getElementById('feeSelectedDm5');

		var objFeeBudget = document.getElementById('feeBudget');
		var objFeeTotalBudget = document.getElementById('feeTotalBudget');
		var objFeeExpense = document.getElementById('feeExpense');
		var objFeeTaxExpense = document.getElementById('feeTaxExpense');
		var objFeeExpenseExcludeTax = document.getElementById('feeExpenseExcludeTax');

		var objFeeContractNum = document.getElementById('feeContractNum');
		var objFeeInvoiceNume = document.getElementById('feeInvoiceNume');

		var objFeeNote = document.getElementById('feeNote');

		var expense = objFeeExpense.value;

		var departmentName = objFeeSelectedDepartmentName ? objFeeSelectedDepartmentName.innerText : '';
		var budget = objFeeBudget ? objFeeBudget.value : 0;
		var totalBudget = objFeeTotalBudget ? objFeeTotalBudget.value : 0;
		var taxExpense = objFeeTaxExpense ? objFeeTaxExpense.value : 0;
		var expenseExcludeTax = Number(expense - taxExpense);
		var contractNum = objFeeContractNum ? objFeeContractNum.value : '';
		var invoiceNum = objFeeInvoiceNume ? objFeeInvoiceNume.value : '';
		var note = objFeeNote ? objFeeNote.value : '';
		var eaName = objFeeSelectedEaName ? objFeeSelectedEaName.innerText : '';
		var cashFlowName = objFeeSelectedCashFlowName ? objFeeSelectedCashFlowName.innerText : '';
		var currencyName = objFeeSelectedCurrencyName ? objFeeSelectedCurrencyName.innerText : '';
		var startTime = objFeeStartTime ? objFeeStartTime.innerText : '';
		var endTime = objFeeEndTime ? objFeeEndTime.innerText : '';
		var cashTime = objFeeCashTime ? objFeeCashTime.innerText : '';
		var collectTime = objFeeCollectTime ? objFeeCollectTime.innerText : '';
		var startAddr = objFeeStartAddr ? objFeeStartAddr.value : '';
		var endAddr = objFeeEndAddr ? objFeeEndAddr.value : '';
		var dm1 = showDm1Input ? (objFeeDm1 ? objFeeDm1.value : '') : (objFeeSelectedDm1 ? objFeeSelectedDm1.innerText : '');
		var dm2 = showDm2Input ? (objFeeDm2 ? objFeeDm2.value : '') : (objFeeSelectedDm2 ? objFeeSelectedDm2.innerText : '');
		var dm3 = showDm3Input ? (objFeeDm3 ? objFeeDm3.value : '') : (objFeeSelectedDm3 ? objFeeSelectedDm3.innerText : '');
		var dm4 = showDm4Input ? (objFeeDm4 ? objFeeDm4.value : '') : (objFeeSelectedDm4 ? objFeeSelectedDm4.innerText : '');
		var dm5 = showDm5Input ? (objFeeDm5 ? objFeeDm5.value : '') : (objFeeSelectedDm5 ? objFeeSelectedDm5.innerText : '');

		//添加或更新费用对象
		var newFee = {
			id: feeId,
			budget: budget,
			totalBudget: totalBudget,
			expense: expense,
			taxExpense: taxExpense,
			expenseExcludeTax: expenseExcludeTax,
			contractNum: contractNum,
			invoiceNum: invoiceNum,
			note: note,
			departmentName: departmentName,
			eaName: eaName,
			cashFlowName: cashFlowName,
			currencyName: currencyName,
			cashTime: cashTime,
			collectTime: collectTime,
			startTime: startTime,
			endTime: endTime,
			startAddr: startAddr,
			endAddr: endAddr,
			dm1: dm1,
			dm2: dm2,
			dm3: dm3,
			dm4: dm4,
			dm5: dm5
		};
		currentFee = mui.extend(currentFee, newFee);
		mj.disableBtn($btnConfirmFees);

		var feeId;
		if (currentFeeId == -1) {
			feeId = feeLength++;
			currentFee.id = feeId;
			buildFeeSummaryForEdit(currentFee, objFeesList);
		} else {
			feeId = currentFeeId;
			currentFee.id = feeId;

			updateFeeSummary(currentFee);
		}

		feeMap[feeId] = currentFee;

		calcBillExpenseTotal(currentBillType);

		//关闭报销明细弹窗
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	//删除报销明细
	$feeList.on('tap', '.fee-simple-delete', function() {
		var objFee = this.parentNode;
		var deleteId = this.parentNode.getAttribute('vid');
		mui.confirm('确认删除该明细？', '删除明细', ['确认', '取消'], function(e) {
			if (e.index == 0) {
				if (objFee) {
					objFee.parentNode.removeChild(objFee);
					objFee = null;
				}

				delete feeMap[deleteId];

				calcBillExpenseTotal(currentBillType);
			}
		});
	});

	//获取费用列
	getFeeTableColumnsHeaderForCreate(feeHeaderDictKey, defaultFeeClms, document.getElementById(feeDetailWrapperShowId),
		function(_feeClms) {
			feeClms = _feeClms;
			initFeeEvents(feeClms);
		},
		function(_feeClms) {
			getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, _feeClms);
		});
}

function initFeeEvents(feeClms) {
	if (feeClms.departmentId) {
		var hasSpecial = false;
		switch (currentBillType) {
			case BILL_TYPE_SALE:
			case BILL_TYPE_COLLECTION:
				hasSpecial = true;
				break;
			default:
				hasSpecial = false;
				break;
		}

		initAllDepartmentBook({
			departmentTapId: 'feeDepartmentCell',
			departmentShowId: 'feeSelectedDepartmentName',
			title: '请选择归属部门',
			showAll: false,
			hasSpecial: hasSpecial,
			splitByAccount: true,
			accountId: billAccount,
			splitByOwn: true
		}, function(selected) {
			//重置归属人
			if (feeClms.owner) {
				document.getElementById('feeSelectedOwnerName').innerText = '';
				currentFee.owner = -2;
				currentFee.ownerName = '';

			}

			//重置业务活动
			if (feeClms.bizId) {
				document.getElementById('feeSelectedBizName').innerText = '';
				currentFee.bizId = -2;
				currentFee.bizName = '';
			}

			currentFee.departmentId = selected.id;
			currentFee.departmentName = selected.name;

			setTimeout(function() {
				if ((feeClms.budget || feeClms.totalBudget) && billFor != EXPENSE_BELONG_PROJECT) {
					resetBudgetForFee();
				}
				if (currentBillType != BILL_TYPE_SUPPLIER_ASSET && currentBillType != BILL_TYPE_SALE && currentBillType !=
					BILL_TYPE_COLLECTION) {
					if (feeClms.eaId && billFor != EXPENSE_BELONG_PROJECT) {
						resetFeeEa();
					}
				}
			}, 100);
		});
	}

	if (feeClms.owner) {
		initUserBookForBillFee();
	}

	if (feeClms.projectId) {
		initWorkProjectBookByPermissionForFin({
			projectTapId: 'feeProjectCell',
			projectShowId: 'feeSelectedProjectName',
			title: '请选择项目',
			showAll: false,
			hasSpecial: true,
			splitByAccount: true,
			accountId: billAccount
		}, function(selected) {
			currentFee.projectId = selected.id;
			currentFee.projectName = selected.name;
			setTimeout(function() {
				if ((feeClms.budget || feeClms.totalBudget) && billFor == EXPENSE_BELONG_PROJECT) {
					resetBudgetForFee();
				}
				if (currentBillType != BILL_TYPE_SUPPLIER_ASSET && currentBillType != BILL_TYPE_SALE && currentBillType !=
					BILL_TYPE_COLLECTION) {
					if (feeClms.eaId && billFor == EXPENSE_BELONG_PROJECT) {
						resetFeeEa();
					}
				}
			}, 50);
		})
	}

	if (feeClms.eaId) {
		switch (currentBillType) {
			case BILL_TYPE_COLLECTION:
				initCollectionCrBookForBillFee();
				break;
			case BILL_TYPE_SALE:
				initSaleCrBookForBillFee();
				break;
			case BILL_TYPE_SUPPLIER_ASSET:
				initAssetBookForBillFee();
				break;
			default:
				initEaBookForBillFee();
				break;
		}
	}

	if (feeClms.toCurrencyId) {
		initToCurrencyBookForBillFee();
	}

	if (feeClms.bizId) {
		initBizBookForBillFee();
	}

	if (feeClms.customerId || feeClms.supplierId) {
		initSupplierBookForBillFee();
	}

	if (feeClms.consumerId) {
		initConsumerBookForBillFee();
	}

	if (feeClms.carId) {
		initCarBookForBillFee();
	}

	if (feeClms.cashTime || feeClms.startTime || feeClms.endTime) {
		initFeeDayDtPicker();
	}

	if (feeClms.collectTime) {
		initCollectTimeDtPicker();
	}

	if (feeClms.dm1 && showDm1Select) {
		initDmBookForBillFee({
			dmTapId: 'feeDm1Cell',
			dmShowId: 'feeSelectedDm1',
			dmTitle: mj.getDict(BILL_FEE_DM1),
			dms: dm1s
		}, function(selected) {
			currentFee.dm1Id = selected.id;
			currentFee.dm1 = selected.name;
		});
	}

	if (feeClms.dm2 && showDm2Select) {
		initDmBookForBillFee({
			dmTapId: 'feeDm2Cell',
			dmShowId: 'feeSelectedDm2',
			dmTitle: mj.getDict(BILL_FEE_DM2),
			dms: dm2s
		}, function(selected) {
			currentFee.dm2Id = selected.id;
			currentFee.dm2 = selected.name;
		});
	}

	if (feeClms.dm3 && showDm3Select) {
		initDmBookForBillFee({
			dmTapId: 'feeDm3Cell',
			dmShowId: 'feeSelectedDm3',
			dmTitle: mj.getDict(BILL_FEE_DM3),
			dms: dm3s
		}, function(selected) {
			currentFee.dm3Id = selected.id;
			currentFee.dm3 = selected.name;
		});
	}

	if (feeClms.dm4 && showDm4Select) {
		initDmBookForBillFee({
			dmTapId: 'feeDm4Cell',
			dmShowId: 'feeSelectedDm4',
			dmTitle: mj.getDict(BILL_FEE_DM4),
			dms: dm4s
		}, function(selected) {
			currentFee.dm4Id = selected.id;
			currentFee.dm4 = selected.name;
		});
	}

	if (feeClms.dm5 && showDm5Select) {
		initDmBookForBillFee({
			dmTapId: 'feeDm5Cell',
			dmShowId: 'feeSelectedDm5',
			dmTitle: mj.getDict(BILL_FEE_DM5),
			dms: dm5s
		}, function(selected) {
			currentFee.dm5Id = selected.id;
			currentFee.dm5 = selected.name;
		});
	}

	//不含税金额
	if (feeClms.taxExpense) {
		mui('#feeDetailPage').on('input', '#feeExpense', function() {
			currentFee.expense = document.getElementById('feeExpense').value;
			currentFee.taxExpense = document.getElementById('feeTaxExpense').value;
			currentFee.expenseExcludeTax = currentFee.expense - currentFee.taxExpense;
			document.getElementById('feeExpenseExcludeTax').value = currentFee.expenseExcludeTax.toFixed(2);
		});

		mui('#feeDetailPage').on('input', '#feeTaxExpense', function() {
			currentFee.taxExpense = document.getElementById('feeTaxExpense').value;
			currentFee.expenseExcludeTax = currentFee.expense - currentFee.taxExpense;
			document.getElementById('feeExpenseExcludeTax').value = currentFee.expenseExcludeTax.toFixed(2);
		});
	}
}

function renderFeeUI(fee) {
	var objFeeSelectedDepartmentName = document.getElementById('feeSelectedDepartmentName');
	var objFeeSelectedProjectName = document.getElementById('feeSelectedProjectName');
	var objFeeSelectedOwnerName = document.getElementById('feeSelectedOwnerName');
	var objFeeSelectedEaName = document.getElementById('feeSelectedEaName');
	var objFeeSelectedCashFlowName = document.getElementById('feeSelectedCashFlowName');
	var objFeeSelectedCurrencyName = document.getElementById('feeSelectedCurrencyName');
	var objFeeSelectedBizName = document.getElementById('feeSelectedBizName');
	var objFeeSelectedCustomerName = document.getElementById('feeSelectedCustomerName');
	var objFeeSelectedConsumerName = document.getElementById('feeSelectedConsumerName');
	var objFeeSelectedCarNum = document.getElementById('feeSelectedCarNum');

	var objFeeCashTime = document.getElementById('feeCashTime');
	var objFeeCollectTime = document.getElementById('feeCollectTime');
	var objFeeStartTime = document.getElementById('feeStartTime');
	var objFeeEndTime = document.getElementById('feeEndTime');
	var objFeeStartAddr = document.getElementById('feeStartAddr');
	var objFeeEndAddr = document.getElementById('feeEndAddr');

	var objFeeBudget = document.getElementById('feeBudget');
	var objFeeTotalBudget = document.getElementById('feeTotalBudget');
	var objFeeExpense = document.getElementById('feeExpense');
	var objFeeTaxExpense = document.getElementById('feeTaxExpense');
	var objFeeExpenseExcludeTax = document.getElementById('feeExpenseExcludeTax');

	var objFeeContractNum = document.getElementById('feeContractNum');
	var objFeeInvoiceNume = document.getElementById('feeInvoiceNume');

	var objFeeNote = document.getElementById('feeNote');

	var objFeeDm1 = document.getElementById('feeDm1');
	var objFeeDm2 = document.getElementById('feeDm2');
	var objFeeDm3 = document.getElementById('feeDm3');
	var objFeeDm4 = document.getElementById('feeDm4');
	var objFeeDm5 = document.getElementById('feeDm5');

	var objSelectedDm1 = document.getElementById('feeSelectedDm1');
	var objSelectedDm2 = document.getElementById('feeSelectedDm2');
	var objSelectedDm3 = document.getElementById('feeSelectedDm3');
	var objSelectedDm4 = document.getElementById('feeSelectedDm4');
	var objSelectedDm5 = document.getElementById('feeSelectedDm5');

	objFeeSelectedDepartmentName && (objFeeSelectedDepartmentName.innerText = fee.departmentName ? fee.departmentName : '');
	objFeeSelectedProjectName && (objFeeSelectedProjectName.innerText = fee.projectName ? fee.projectName : '');
	objFeeSelectedOwnerName && (objFeeSelectedOwnerName.innerText = fee.ownerName ? fee.ownerName : '');
	objFeeSelectedEaName && (objFeeSelectedEaName.innerText = fee.eaName ? fee.eaName : '');
	objFeeSelectedCashFlowName && (objFeeSelectedCashFlowName.innerText = fee.cashFlowName ? fee.cashFlowName : '');
	objFeeSelectedCurrencyName && (objFeeSelectedCurrencyName.innerText = fee.toCurrencyName ? fee.toCurrencyName : '');
	objFeeSelectedBizName && (objFeeSelectedBizName.innerText = fee.bizName ? fee.bizName : '');
	objFeeSelectedCustomerName && (objFeeSelectedCustomerName.innerText = fee.customerName ? fee.customerName : '');
	objFeeSelectedConsumerName && (objFeeSelectedConsumerName.innerText = fee.consumerName ? fee.consumerName : '');
	objFeeSelectedCarNum && (objFeeSelectedCarNum.innerText = fee.carNum ? fee.carNum : '');

	objFeeCashTime && (objFeeCashTime.innerText = fee.cashTime ? new Date(fee.cashTime).format('yyyy-MM-dd') : '');
	objFeeCollectTime && (objFeeCollectTime.innerText = fee.collectTime ? new Date(fee.collectTime).format('yyyy-MM-dd') :
		'');
	objFeeStartTime && (objFeeStartTime.innerText = fee.startTime ? new Date(fee.startTime).format('yyyy-MM-dd') : '');
	objFeeEndTime && (objFeeEndTime.innerText = fee.endTime ? (new Date(fee.endTime)).format('yyyy-MM-dd') : '');
	objFeeStartAddr && (objFeeStartAddr.value = fee.startAddr ? fee.startAddr : '');
	objFeeEndAddr && (objFeeEndAddr.value = fee.endAddr ? fee.endAddr : '');

	objFeeBudget && (objFeeBudget.value = fee.budget);
	objFeeTotalBudget && (objFeeTotalBudget.value = fee.totalBudget);
	objFeeExpense && (objFeeExpense.value = fee.expense);
	objFeeTaxExpense && (objFeeTaxExpense.value = fee.taxExpense);
	objFeeExpenseExcludeTax && (objFeeExpenseExcludeTax.value = fee.expenseExcludeTax);

	objFeeContractNum && (objFeeContractNum.value = fee.contractNum);
	objFeeInvoiceNume && (objFeeInvoiceNume.value = fee.invoiceNum);

	objFeeNote && (objFeeNote.value = fee.note);
	objFeeDm1 && (objFeeDm1.value = fee.dm1 ? fee.dm1 : '');
	objFeeDm2 && (objFeeDm2.value = fee.dm2 ? fee.dm2 : '');
	objFeeDm3 && (objFeeDm3.value = fee.dm3 ? fee.dm3 : '');
	objFeeDm4 && (objFeeDm4.value = fee.dm4 ? fee.dm4 : '');
	objFeeDm5 && (objFeeDm5.value = fee.dm5 ? fee.dm5 : '');

	objSelectedDm1 && (objSelectedDm1.innerText = fee.dm1 ? fee.dm1 : '');
	objSelectedDm2 && (objSelectedDm2.innerText = fee.dm2 ? fee.dm2 : '');
	objSelectedDm3 && (objSelectedDm3.innerText = fee.dm3 ? fee.dm3 : '');
	objSelectedDm4 && (objSelectedDm4.innerText = fee.dm4 ? fee.dm4 : '');
	objSelectedDm5 && (objSelectedDm5.innerText = fee.dm5 ? fee.dm5 : '');
}

//报销明细详细显示模板
function generateBillDetailFeeTableColumns(feeClms, fee) {
	var clmHtml = '<ul class="mui-table-view" uid="' + fee.id + '">';
	mui.each(feeClms, function(key, val) {
		if (!feeClms[key]) {
			return true;
		}

		switch (key) {
			case 'billDcTypeInt':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					' 	<span>借/贷</span>' +
					'	<span class="mui-pull-right">' + (fee.billDcTypeInt ? BillDcTypeEnum[fee.billDcTypeInt] : '') + '</span>' +
					'</li>';
				break;
			case 'departmentId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					' 	<span>归属部门</span>' +
					'	<span class="mui-pull-right">' + (fee.departmentName ? fee.departmentName : '') + '</span>' +
					'</li>';
				break;
			case 'owner':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-owner-table-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">业务员</span>';
						break;
					default:
						clmHtml += '<span class="table-text">归属人</span>';
						break;
				}
				clmHtml += '	<span class="mui-pull-right">' + (fee.ownerName ? fee.ownerName : '') + '</span>' +
					'</li>';
				break;
			case 'projectId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">关联项目</span>' +
					'	<span class="mui-pull-right">' + (fee.projectName ? fee.projectName : '') + '</span>' +
					'</li>';
				break;
			case 'eaId':
				var changeEaString =
					'<li id="feeEaCell" class="mui-table-view-cell no-left-table-view-cell fee-ea-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						changeEaString += '<span class="table-text">收款类型</span>';
						break;
					case BILL_TYPE_SALE:
						changeEaString += '		<span class="table-text">收入类型</span>';
						break;
					case BILL_TYPE_SUPPLIER_ASSET:
						changeEaString += '		<span class="table-text">资产类型</span>';
						break;
					default:
						changeEaString += '		<span class="table-text">会计科目</span>';
						break;
				}
				changeEaString += '		<span id="feeSelectedEaName" class="mui-pull-right selected-text fee-selected-ea fee-ea">' +
					(fee.eaName ? fee.eaName : '') + '</span>' +
					'	</a>' +
					'</li>';
				var showEaString =
					'<li class="mui-table-view-cell no-left-table-view-cell fee-ea-table-cell">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						showEaString += '<span class="table-text">收款类型</span>';;
						break;
					case BILL_TYPE_SALE:
						showEaString += '		<span class="table-text">收入类型</span>';
						break;
					case BILL_TYPE_SUPPLIER_ASSET:
						showEaString += '		<span class="table-text">资产类型</span>';
						break;
					default:
						showEaString += '		<span class="table-text">会计科目</span>';
						break;
				}

				showEaString += '	<span class="mui-pull-right">' + (fee.eaName ? fee.eaName : '') + '</span>' +
					'</li>';
				if (has_bill_tax_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeEaString;
					} else {
						clmHtml += showEaString;
					}
				} else {
					clmHtml += showEaString;
				}

				break;
			case 'cashFlowId':
				var showCashFlowString =
					'<li class="mui-table-view-cell no-left-table-view-cell fee-cash-flow-table-cell">' +
					'	<span class="table-text">现金流量项目</span>' +
					'	<span class="mui-pull-right">' + (fee.cashFlowName ? fee.cashFlowName : '') + '</span>' +
					'</li>';

				var checkCashFlowLink = currentBillType && currentBillType == BILL_TYPE_BANK_DEDUCTION ? '' : 'unlinked-text';
				var changeCashFlowString =
					'<li id="feeCashFlowCell" class="mui-table-view-cell no-left-table-view-cell fee-review-cash-flow-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="feeCashFlowText" class="table-text ' + checkCashFlowLink + ' ">现金流量项目</span>' +
					'		<span id="feeSelectedCashFlowName" class="mui-pull-right selected-text fee-selected-cash-flow">' + (fee.cashFlowName ?
						fee.cashFlowName : '') + '</span>' +
					'	</a>' +
					'</li>';

				var updateCashFlowStringAfterReview =
					'<li id="updateCashFlowCellAfterReview" class="mui-table-view-cell no-left-table-view-cell fee-after-review-cash-flow-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="updateCashFlowText" class="table-text">现金流量项目</span>' +
					'		<span class="iconfont icon-faqi-xiangmujihua"></span>' +
					'		<span id="updateSelectedCashFlowName" class="mui-pull-right selected-text fee-after-review-selected-cash-flow">' +
					(fee.cashFlowName ? fee.cashFlowName : '') + '</span>' +
					'	</a>' +
					'</li>';

				switch (Number(fee.status)) {
					case BILL_STATUS_REVIEWING:
						var checkCashFlowChangePer = ((window.hasOwnProperty('checkChangeCashFlowPer') && checkChangeCashFlowPer) ||
							has_bill_tax_change_permission);
						if (checkCashFlowChangePer && canReview) {
							clmHtml += changeCashFlowString;
						} else {
							clmHtml += showCashFlowString;
						}
						break;
					case BILL_STATUS_APPROVED:
					case BILL_STATUS_PAID:
					case BILL_STATUS_COLLECT:
						if (has_bill_cashflow_permission && fee.cashFlowId > 0) {
							clmHtml += updateCashFlowStringAfterReview;
						} else {
							clmHtml += showCashFlowString;
						}
						break;
					case BILL_STATUS_CANCELLED:
					case BILL_STATUS_CREATED:
					case BILL_STATUS_REJECTED:
					case BILL_STATUS_ABOLISH:
					default:
						clmHtml += showCashFlowString;
						break;
				}
				break;
			case 'toCurrencyId':
				var showCurrencyString =
					'<li class="mui-table-view-cell no-left-table-view-cell fee-currency-table-cell">' +
					'	<span class="table-text">冲应收币别</span>' +
					'	<span class="mui-pull-right">' + (fee.toCurrencyName ? fee.toCurrencyName : '') + '</span>' +
					'</li>';

				var changeCurrencyString =
					'<li id="feeCurrencyCell" class="mui-table-view-cell no-left-table-view-cell fee-review-currency-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="feeCurrencyText" class="table-text unlinked-text">冲应收币别</span>' +
					'		<span id="feeSelectedCurrencyName" class="mui-pull-right selected-text fee-selected-currency">' + (fee.toCurrencyName ?
						fee.toCurrencyName : '') + '</span>' +
					'	</a>' +
					'</li>';

				var updateCurrencyStringAfterReview =
					'<li id="updateCurrencyCellAfterReview" class="mui-table-view-cell no-left-table-view-cell fee-review-currency-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">' +
					'		<span id="updateCurrencyText" class="table-text">冲应收币别</span>' +
					'		<span class="iconfont icon-money"></span>' +
					'		<span id="updateSelectedCurrencyName" class="mui-pull-right selected-text">' + (fee.toCurrencyName ? fee.toCurrencyName :
						'') + '</span>' +
					'	</a>' +
					'</li>';

				switch (Number(fee.status)) {
					case BILL_STATUS_REVIEWING:
						if (has_bill_tax_change_permission && canReview) {
							clmHtml += changeCurrencyString;
						} else {
							clmHtml += showCurrencyString;
						}
						break;
					case BILL_STATUS_APPROVED:
					case BILL_STATUS_PAID:
					case BILL_STATUS_COLLECT:
						if (has_bill_recv_permission && fee.toCurrencyId >= 0) {
							clmHtml += updateCurrencyStringAfterReview;
						} else {
							clmHtml += showCurrencyString;
						}
						break;
					case BILL_STATUS_CANCELLED:
					case BILL_STATUS_CREATED:
					case BILL_STATUS_REJECTED:
					case BILL_STATUS_ABOLISH:
					default:
						clmHtml += showCurrencyString;
						break;
				}
				break;
			case 'cashTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">银行收款日期</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								clmHtml += '<span class="table-text">银行收款日期</span>';
							} else {
								clmHtml += '<span class="table-text">银行扣款日期</span>';
							}
						}
						break;
					case BILL_TYPE_BANK_DEDUCTION:
					default:
						clmHtml += '<span class="table-text">扣款日期</span>';
						break;
				}

				clmHtml += '	<span class="mui-pull-right">' + (fee.cashTime ? new Date(fee.cashTime).format('yyyy-MM-dd') : '') +
					'</span>' +
					'</li>';
				break;
			case 'collectTime':

				var collectTimeCellTextString = '';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
					case BILL_TYPE_BUDGET_COLLECT:
						collectTimeCellTextString += '<span id="feeCollectTimeText" class="table-text unlinked-text">预计收款日期</span>';
						break;
					case BILL_TYPE_BUDGET_PAY:
						collectTimeCellTextString += '<span id="feeCollectTimeText" class="table-text unlinked-text">预计付款日期</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								collectTimeCellTextString += '<span id="feeCollectTimeText" class="table-text unlinked-text">预计收款日期</span>';
							} else {
								collectTimeCellTextString += '<span id="feeCollectTimeText" class="table-text unlinked-text">实际收款日期</span>';
							}
						}
						break;
					case BILL_TYPE_COLLECTION:
					default:
						collectTimeCellTextString +=
							'<span id="feeCollectTimeText" class="table-text unlinked-text">实际收款日期</span></span>';
						break;
				}

				if (has_bill_recv_permission) {
					switch (Number(fee.status)) {
						case BILL_STATUS_APPROVED:
						case BILL_STATUS_PAID:
						case BILL_STATUS_COLLECT:
							if (fee.collectTime) collectTimeCellTextString += '<span class="iconfont icon-riqi"></span>';
							break;
						default:
							break;
					}
				}

				var changeCollectTimeString =
					'<li id="feeCollectTimeCell" class="mui-table-view-cell no-left-table-view-cell fee-collect-time-cell">' +
					collectTimeCellTextString +
					'	<span id="feeCollectTime" class="mui-pull-right selected-fee-collect-time fee-collect-time">' + (fee.collectTime ?
						new Date(fee.collectTime).format('yyyy-MM-dd') : '') + '</span>' +
					'</li>';

				var showCollectTimeString = '<li class="mui-table-view-cell no-left-table-view-cell">' +
					collectTimeCellTextString +
					'	<span class="mui-pull-right">' + (fee.collectTime ? new Date(fee.collectTime).format('yyyy-MM-dd') : '') +
					'</span>' +
					'</li>';

				switch (Number(fee.status)) {
					case BILL_STATUS_REVIEWING:
						if (has_bill_tax_change_permission && canReview) {
							clmHtml += changeCollectTimeString;
						} else {
							clmHtml += showCollectTimeString;
						}
						break;
					case BILL_STATUS_APPROVED:
					case BILL_STATUS_PAID:
					case BILL_STATUS_COLLECT:
						if (has_bill_recv_permission && fee.collectTime) {
							clmHtml += changeCollectTimeString;
						} else {
							clmHtml += showCollectTimeString;
						}
						break;
					case BILL_STATUS_CANCELLED:
					case BILL_STATUS_CREATED:
					case BILL_STATUS_REJECTED:
					case BILL_STATUS_ABOLISH:
					default:
						clmHtml += showCollectTimeString;
						break;
				}

				break;
			case 'bizId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-biz-table-cell">' +
					'	<span class="table-text">业务活动</span>' +
					'	<span class="mui-pull-right">' + (fee.bizName ? fee.bizName : '') + '</span>' +
					'</li>';
				break;
			case 'supplierId':
			case 'customerId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-customer-table-cell">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款单位</span>';
						break;
					default:
						clmHtml += '		<span class="table-text">供应商</span>';
						break;
				}
				clmHtml +=
					'	<span class="mui-pull-right">' + (fee.customerName ? fee.customerName : '') + '</span>' +
					'</li>';
				break;
			case 'consumerId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-consumer-table-cell">';
				switch (currentBillType) {
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款单位</span>';
						break;
					default:
						clmHtml += '<span class="table-text">客户</span>';
						break;
				}
				clmHtml +=
					'	<span class="mui-pull-right">' + (fee.consumerName ? fee.consumerName : '') + '</span>' +
					'</li>';
				break;
			case 'carId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-car-table-cell">' +
					'	<span class="table-text">车辆</span>' +
					'	<span class="mui-pull-right">' + (fee.carNum ? fee.carNum : '') + '</span>' +
					'</li>';
				break;
			case 'payCurrencyId':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-pay-currency-table-cell">' +
					'	<span class="table-text">币别</span>' +
					'	<span class="mui-pull-right">' + (fee.payCurrencyName ? fee.payCurrencyName : '') + '</span>' +
					'</li>';
				break;
			case 'expense':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						clmHtml += '<span class="table-text">含税收入</span>';
						break;
					case BILL_TYPE_COLLECTION:
						clmHtml += '<span class="table-text">收款金额</span>';
						break;
					case BILL_TYPE_SUPPLIER_PAY_GOODS:
						clmHtml += '<span class="table-text">付款金额</span>';
						break;
					case BILL_TYPE_SUPER:
						if(checkWindowProperty('billMultiCurrency')){
							clmHtml += '<th class="table-text">原币金额</th>';
						}else{
							clmHtml += '<th class="table-text">报销金额</th>';
						}
						break;
					default:
						clmHtml += '<span class="table-text">报销金额</span>';
						break;
				}

				var showExpenseString =
					'	<span class="mui-pull-right fee-detail-expense">' + fee.expense.toFixed(2) + '</span>' +
					'</li>';

				var changeExpenseString =
					'	<input id="feeExpense" type="number" class="mui-pull-right bill-table-text fee-expense fee-expense-input" placeholder="" value="' +
					fee.expense.toFixed(2) + '">' +
					'</li>';

				switch (Number(fee.status)) {
					case BILL_STATUS_REVIEWING:
						if (window.hasOwnProperty('checkChangeExpensePer') && checkChangeExpensePer && canReview) {
							clmHtml += changeExpenseString;
						} else {
							clmHtml += showExpenseString;
						}
						break;
					default:
						clmHtml += showExpenseString;
						break;
				}

				break;
			case 'bizRate':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-pay-biz-rate-cell">' +
					'	<span class="table-text">汇率</span>' +
					'	<span class="mui-pull-right">' + (fee.bizRate ? fee.bizRate : '') + '</span>' +
					'</li>';
				break;
			case 'bizExpense':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell fee-pay-biz-expense-cell">' +
					'	<span class="table-text">本位币金额</span>' +
					'	<span class="mui-pull-right">' + (fee.bizExpense ? fee.bizExpense.toFixed(2) : '') + '</span>' +
					'</li>';
				break;
			case 'taxExpense':
				var checkTaxEnable = false;
				switch (currentBillType) {
				  case BILL_TYPE_SUPER:
					checkTaxEnable = (fee.payCurrencyId == PAY_CURRENCY_LOCAL);
					break;
				  default:
					checkTaxEnable = (checkWindowProperty('billPayCurrency') == PAY_CURRENCY_LOCAL);
					break;
				}
				var checkTaxLink = checkTaxEnable ? '' : 'unlinked-text';
				var checkTaxInput = checkTaxEnable ? '' : 'disabled';
				var changeTaxString = '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						changeTaxString += '<span class="table-text '+checkTaxLink+'">销项税</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								changeTaxString += '<span class="table-text '+checkTaxLink+'">进项税</span>';
							} else {
								changeTaxString += '<span class="table-text '+checkTaxLink+'">销项税</span>';
							}
						}
						break;
					default:
						changeTaxString += '<span class="table-text '+checkTaxLink+'">进项税</span>';
						break;
				}

				changeTaxString +=
					'<input id="feeTaxExpense" type="number" style="padding-right:0" class="mui-pull-right bill-table-text fee-taxexpense fee-expense-input" placeholder="" value="' +
					fee.taxExpense.toFixed(2) + '" '+checkTaxInput+'>' +
					'</li>' +
					'<li class="mui-table-view-cell no-left-table-view-cell">';
				if (BILL_TYPE_SALE == currentBillType) {
					changeTaxString += '<span class="table-text">不含税收入</span>';
				} else {
					changeTaxString += '<span class="table-text">不含税金额</span>';
				}
				changeTaxString += '<span id="feeExpenseExcludeTax" class="mui-pull-right">' + fee.expenseExcludeTax.toFixed(2) +
					'</span>' +
					'</li>';
				var showTaxString = '<li class="mui-table-view-cell no-left-table-view-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						showTaxString += '<span class="table-text">销项税</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								showTaxString += '<span class="table-text">进项税</span>';
							} else {
								showTaxString += '<span class="table-text">销项税</span>';
							}
						}
						break;
					default:
						showTaxString += '<span class="table-text">进项税</span>';
						break;
				}

				showTaxString += '<span class="mui-pull-right">' + fee.taxExpense.toFixed(2) + '</span>' +
					'</li>' +
					'<li class="mui-table-view-cell no-left-table-view-cell">';
				if (BILL_TYPE_SALE == currentBillType) {
					showTaxString += '<span class="table-text">不含税收入</span>';
				} else {
					showTaxString += '<span class="table-text">不含税金额</span>';
				}
				showTaxString += '	<span class="mui-pull-right">' + fee.expenseExcludeTax.toFixed(2) + '</span>' +
					'</li>';
				if (has_bill_tax_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeTaxString;
					} else {
						clmHtml += showTaxString;
					}
				} else {
					clmHtml += showTaxString;
				}
				break;
			case 'taxEaId':
				var showTaxEaString = '<li class="mui-table-view-cell no-left-table-view-cell fee-tax-ea-table-cell">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						showTaxEaString += '<span class="table-text">销项税科目</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								showTaxEaString += '<span class="table-text">进项税科目</span>';
							} else {
								showTaxEaString += '<span class="table-text">销项税科目</span>';
							}
						}
						break;
					default:
						showTaxEaString += '<span class="table-text">进项税科目</span>';
						break;
				}

				showTaxEaString += '<span class="mui-pull-right">' + (fee.taxEaName ? fee.taxEaName : '') + '</span>' +
					'</li>';
					
				var checkTaxEaEnable = false;
				var taxEaIdName = '';
				switch (currentBillType) {
					case BILL_TYPE_SUPER:
						checkTaxEaEnable = (fee.payCurrencyId == PAY_CURRENCY_LOCAL);
						break;
					default:
						checkTaxEaEnable = (checkWindowProperty('billPayCurrency') == PAY_CURRENCY_LOCAL);
						break;
				}
				if(checkTaxEaEnable) taxEaIdName = 'feeTaxEaCell';
				var checkTaxEaLink = checkTaxEaEnable ? '' : 'unlinked-text';
				var changeTaxEaString =
					'<li id="'+taxEaIdName+'" class="mui-table-view-cell no-left-table-view-cell fee-tax-ea-table-cell">' +
					'	<a class="mui-navigate-right no-spacing-navigate-right">';
				switch (currentBillType) {
					case BILL_TYPE_SALE:
						changeTaxEaString += '		<span class="table-text '+checkTaxEaLink+'">销项税科目</span>';
						break;
					case BILL_TYPE_SUPER:
						if (window.hasOwnProperty('currentBillDc')) {
							if (currentBillDc == BILL_DC_DR) {
								changeTaxEaString += '		<span class="table-text '+checkTaxEaLink+'">进项税科目</span>';
							} else {
								changeTaxEaString += '		<span class="table-text '+checkTaxEaLink+'">销项税科目</span>';
							}
						}
						break;
					default:
						changeTaxEaString += '		<span class="table-text '+checkTaxEaLink+'">进项税科目</span>';
						break;
				}

				changeTaxEaString += '		<span id="feeSelectedTaxEaName" class="mui-pull-right selected-text fee-tax-ea">' + (fee.taxEaName ?
						fee.taxEaName : '') + '</span>' +
					'	</a>' +
					'</li>';

				if (has_bill_tax_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeTaxEaString;
					} else {
						clmHtml += showTaxEaString;
					}
				} else {
					clmHtml += showTaxEaString;
				}
				break;
			case 'budget':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">科目可用预算</span>' +
					'	<input type="number" class="mui-pull-right bill-table-text fee-budget" placeholder="" value="' + (fee.budget ?
						Number(fee.budget).toFixed(2) : '') + '" disabled>' +
					'</li>';
				break;
			case 'totalBudget':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">可用总预算</span>' +
					'	<input type="number" class="mui-pull-right bill-table-text fee-total-budget" placeholder="" value="' + (fee.totalBudget ?
						Number(fee.totalBudget).toFixed(2) : '') + '" disabled>' +
					'</li>';
				break;
			case 'contractNum':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">合同号</span>' +
					'	<span class="mui-pull-right">' + (fee.contractNum ? fee.contractNum : '') + '</span>' +
					'</li>';
				break;
			case 'invoiceNum':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">发票号</span>' +
					'	<span class="mui-pull-right">' + (fee.invoiceNum ? fee.invoiceNum : '') + '</span>' +
					'</li>';
				break;
			case 'note':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">备注</span>' +
					'	<span class="mui-pull-right">' + (fee.note ? fee.note : '') + '</span>' +
					'</li>';
				break;
			case 'startTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">开始时间</span>' +
					'	<span class="mui-pull-right">' + (fee.startTime ? (new Date(fee.startTime)).format('yyyy-MM-dd') : '') +
					'</span>' +
					'</li>';
				break;
			case 'endTime':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">结束时间</span>' +
					'	<span class="mui-pull-right">' + (fee.endTime ? (new Date(fee.endTime)).format('yyyy-MM-dd') : '') + '</span>' +
					'</li>';
				break;
			case 'startAddr':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">起始地址</span>' +
					'	<span class="mui-pull-right">' + (fee.startAddr ? fee.startAddr : '') + '</span>' +
					'</li>';
				break;
			case 'endAddr':
				clmHtml += '<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">结束地址</span>' +
					'	<span class="mui-pull-right">' + (fee.endAddr ? fee.endAddr : '') + '</span>' +
					'</li>';
				break;
			case 'dm1':
				var changeDmString = '';
				if (showDm1Input) {
					changeDmString +=
						'<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM1) + '</span>' +
						'	<input id="feeDm1" type="text" class="mui-pull-right bill-table-input dm" placeholder="" value="' + (fee.dm1 ?
							fee.dm1 : '') + '">' +
						'</li>';
				} else if (showDm1Select) {
					changeDmString +=
						'<li id="feeDm1Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm1-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM1) + '</span>' +
						'		<span id="feeSelectedDm1" class="mui-pull-right selected-text fee-selected-dm fee-dm1">' + (fee.dm1 ? fee.dm1 :
							'') + '</span>' +
						'	</a>' +
						'</li>';
				}

				var showDmString =
					'<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">' + mj.getDict(BILL_FEE_DM1) + '</span>' +
					'	<span class="mui-pull-right">' + (fee.dm1 ? fee.dm1 : '') + '</span>' +
					'</li>';
				if (has_bill_dm1_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeDmString;
					} else {
						clmHtml += showDmString;
					}
				} else {
					clmHtml += showDmString;
				}
				break;
			case 'dm2':
				var changeDmString = '';
				if (showDm2Input) {
					changeDmString +=
						'<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM2) + '</span>' +
						'	<input id="feeDm2" type="text" class="mui-pull-right bill-table-input dm" placeholder="" value="' + (fee.dm2 ?
							fee.dm2 : '') + '">' +
						'</li>';
				} else if (showDm2Select) {
					changeDmString +=
						'<li id="feeDm2Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm2-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM2) + '</span>' +
						'		<span id="feeSelectedDm2" class="mui-pull-right selected-text fee-selected-dm fee-dm2">' + (fee.dm2 ? fee.dm2 :
							'') + '</span>' +
						'	</a>' +
						'</li>';
				}

				var showDmString =
					'<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">' + mj.getDict(BILL_FEE_DM2) + '</span>' +
					'	<span class="mui-pull-right">' + (fee.dm2 ? fee.dm2 : '') + '</span>' +
					'</li>';
				if (has_bill_dm2_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeDmString;
					} else {
						clmHtml += showDmString;
					}
				} else {
					clmHtml += showDmString;
				}
				break;
			case 'dm3':
				var changeDmString = '';
				if (showDm3Input) {
					changeDmString +=
						'<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM3) + '</span>' +
						'	<input id="feeDm3" type="text" class="mui-pull-right bill-table-input dm" placeholder="" value="' + (fee.dm3 ?
							fee.dm3 : '') + '">' +
						'</li>';
				} else if (showDm3Select) {
					changeDmString +=
						'<li id="feeDm3Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm3-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM3) + '</span>' +
						'		<span id="feeSelectedDm3" class="mui-pull-right selected-text fee-selected-dm fee-dm3">' + (fee.dm3 ? fee.dm3 :
							'') + '</span>' +
						'	</a>' +
						'</li>';
				}

				var showDmString =
					'<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">' + mj.getDict(BILL_FEE_DM3) + '</span>' +
					'	<span class="mui-pull-right">' + (fee.dm3 ? fee.dm3 : '') + '</span>' +
					'</li>';
				if (has_bill_dm3_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeDmString;
					} else {
						clmHtml += showDmString;
					}
				} else {
					clmHtml += showDmString;
				}
				break;
			case 'dm4':
				var changeDmString = '';
				if (showDm4Input) {
					changeDmString +=
						'<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM4) + '</span>' +
						'	<input id="feeDm4" type="text" class="mui-pull-right bill-table-input dm" placeholder="" value="' + (fee.dm4 ?
							fee.dm4 : '') + '">' +
						'</li>';
				} else if (showDm4Select) {
					changeDmString +=
						'<li id="feeDm4Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm4-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM4) + '</span>' +
						'		<span id="feeSelectedDm4" class="mui-pull-right selected-text fee-selected-dm fee-dm4">' + (fee.dm4 ? fee.dm4 :
							'') + '</span>' +
						'	</a>' +
						'</li>';
				}

				var showDmString =
					'<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">' + mj.getDict(BILL_FEE_DM4) + '</span>' +
					'	<span class="mui-pull-right">' + (fee.dm4 ? fee.dm4 : '') + '</span>' +
					'</li>';
				if (has_bill_dm4_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeDmString;
					} else {
						clmHtml += showDmString;
					}
				} else {
					clmHtml += showDmString;
				}
				break;
			case 'dm5':
				var changeDmString = '';
				if (showDm5Input) {
					changeDmString +=
						'<li class="mui-table-view-cell no-left-table-view-cell">' +
						'	<span class="table-text">' + mj.getDict(BILL_FEE_DM5) + '</span>' +
						'	<input id="feeDm5" type="text" class="mui-pull-right bill-table-input dm" placeholder="" value="' + (fee.dm5 ?
							fee.dm5 : '') + '">' +
						'</li>';
				} else if (showDm5Select) {
					changeDmString +=
						'<li id="feeDm5Cell" class="mui-table-view-cell no-left-table-view-cell fee-dm5-table-cell">' +
						'	<a class="mui-navigate-right no-spacing-navigate-right">' +
						'		<span class="table-text">' + mj.getDict(BILL_FEE_DM5) + '</span>' +
						'		<span id="feeSelectedDm5" class="mui-pull-right selected-text fee-selected-dm fee-dm5">' + (fee.dm5 ? fee.dm5 :
							'') + '</span>' +
						'	</a>' +
						'</li>';
				}

				var showDmString =
					'<li class="mui-table-view-cell no-left-table-view-cell">' +
					'	<span class="table-text">' + mj.getDict(BILL_FEE_DM5) + '</span>' +
					'	<span class="mui-pull-right">' + (fee.dm5 ? fee.dm5 : '') + '</span>' +
					'</li>';
				if (has_bill_dm5_change_permission && canReview) {
					if (BILL_STATUS_REVIEWING == fee.status) {
						clmHtml += changeDmString;
					} else {
						clmHtml += showDmString;
					}
				} else {
					clmHtml += showDmString;
				}
				break;
			default:
				break;
		}
	});
	clmHtml += '</ul>';
	return clmHtml;
}

//贷方信息详情字段
function doGetCrFeeTableColumnsHeader() {
	var clmHtml = '<ul class="mui-table-view">' +
		'	<li id="crFeeEaCell" class="mui-table-view-cell no-left-table-view-cell cr-fee-ea-table-cell">' +
		'		<a class="mui-navigate-right no-spacing-navigate-right">' +
		'			<span class="table-text">会计科目</span>' +
		'			<span id="crFeeSelectedEaName" class="mui-pull-right selected-text cr-fee-selected-ea cr-fee-ea"></span>' +
		'		</a>' +
		'	</li>' +
		'	<li class="mui-table-view-cell no-left-table-view-cell">' +
		'		<span class="table-text">金额</span>' +
		'		<input id="crFeeExpense" type="number" class="mui-pull-right bill-table-text cr-fee-expense cr-fee-expense-input" placeholder="" value="">' +
		'	</li>' +
		'</ul>';
	return clmHtml;
}

function getCrFeeTableColumnsHeaderForCreate($feeClms, callback) {
	$feeClms.innerHTML = doGetCrFeeTableColumnsHeader();
	callback && callback($feeClms);
}

//贷方信息模板
function generateBillDetailContentCrFees(list) {
	var listHtml = '';
	for (var i = 0; i < list.length; i++) {
		listHtml += '<li class="mui-table-view-cell">' +
			'<div>' +
			'	<span class="table-text">' + list[i].eaName + '</span>' +
			'	<span class="mj-pull-right">' + list[i].expense.toFixed(2) + '</span>' +
			'</div>';
		if (showCrAccount) {
			listHtml +=
				'	<div class="table-text cr-account-text">' + (list[i].departmentName ? list[i].departmentName : '') + '</div>' +
				'	<div class="table-text cr-account-text">' + (list[i].ownerName ? list[i].ownerName : '') + '</div>' +
				'	<div class="table-text cr-account-text">' + (list[i].customerName ? list[i].customerName : '') + '</div>' +
				'	<div class="table-text cr-account-text">' + (list[i].consumerName ? list[i].consumerName : '') + '</div>';
		}
		listHtml += '</li>';
	}
	return listHtml;
}

//贷方信息编辑页
function renderFinBillFeesForEdit(billId, feeHeaderDictKey) {
	queryBillFees(billId, function(fees) {
		var crFees = [],
			drFees = [];
		var crFeeItem, drFeeItem;
		var totalCrExpense = 0;

		mui.each(fees, function(index, fee) {
			if (BILL_DC_CR == fee.billDcTypeInt) {
				totalCrExpense += fee.expense;
				crFees.push(fee);
			} else {
				drFees.push(fee);
			}
		});

		document.getElementById('crTotalExpense').value = totalCrExpense.toFixed(2);
		document.getElementById('crTotalExpenseCapital').innerText = (totalCrExpense.toFixed(2) + '').toCapitalMoney();

		for (var drItem = 0; drItem < drFees.length; drItem++) {
			drFeeItem = drFees[drItem];
			feeMap[drFeeItem.id] = drFeeItem;
			if (feeLength < drFeeItem.id) {
				feeLength = drFeeItem.id;
			}
		}
		feeLength++;
		generateFeeSummaryListForEdit(drFees, objFeesList);

		for (var crItem = 0; crItem < crFees.length; crItem++) {
			crFeeItem = crFees[crItem];
			crFeeMap[crFeeItem.id] = crFeeItem;
			if (crFeeLength < crFeeItem.id) {
				crFeeLength = crFeeItem.id;
			}
		}
		crFeeLength++;
		generateCrFeeSummaryListForEdit(crFees, objCrFeesList);

	});

	getFeeTableColumnsHeaderForDetail(feeHeaderDictKey, defaultFeeClms,
		function(_feeClms, data) {
			feeClms = _feeClms;
			dms = data;
		},
		function(_feeClms) {
			getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, _feeClms);
		});
}

function generateCrFeeSummaryListForEdit(crFeeList, objCrFeeList) {
	for (var i = 0; i < crFeeList.length; i++) {
		buildCrFeeSummaryForEdit(crFeeList[i], objCrFeeList);
	}
}

function buildCrFeeSummaryForEdit(crFee, objCrFeeList) {
	var objCrFee = document.createElement('div');
	objCrFee.className = 'fee-item fee-item-' + crFee.id;
	objCrFee.setAttribute("id", 'cr-fee-item-' + crFee.id);
	objCrFee.setAttribute("vid", crFee.id);
	objCrFee.innerHTML = '' +
		'<a href="#crFeeDetailPage" class="fee-item-link">' +
		'		<div class="fee-info-detail-wrapper mui-ellipsis">' +
		'		<span id="cr-fee-s-ea-' + crFee.id + '" class="fee-simple-ea">' + (crFee.eaName ? crFee.eaName : '未选科目') +
		'</span>' +
		'	</div>' +
		'	<span id="cr-fee-s-expense-' + crFee.id + '" class="fee-simple-expense">' + Number(crFee.expense).toFixed(2) +
		'</span>' +
		'</a>' +
		'<span class="mj-pull-right iconfont icon-baoxiaomingxi-jian cr-fee-simple-delete"></span>';

	objCrFee.addEventListener('tap', function() {
		crCurrentFeeId = this.getAttribute("vid");
		crCurrentFee = crFeeMap[crCurrentFeeId];
		oldScrollHeight = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
		mj.scrollToTop();

		renderCrFeeUI(crCurrentFee);

		mj.enableBtn(document.getElementById('btnConfirmCrFees'));
	});

	objCrFeeList.appendChild(objCrFee);

	return objCrFee;
}

function updateCrFeeSummary(crFee) {
	document.getElementById('cr-fee-s-ea-' + crFee.id).innerText = (crFee.eaName ? crFee.eaName : '未选科目');
	document.getElementById('cr-fee-s-expense-' + crFee.id).innerText = Number(crFee.expense).toFixed(2);
}

function renderCrFeeUI(crFee) {
	var objCrFeeSelectedEaName = document.getElementById('crFeeSelectedEaName');
	var objCrFeeExpense = document.getElementById('crFeeExpense');

	objCrFeeSelectedEaName && (objCrFeeSelectedEaName.innerText = crFee.eaName ? crFee.eaName : '');
	objCrFeeExpense && (objCrFeeExpense.value = crFee.expense);
}

function initCrFee(options) {
	options = options || {};
	var crfeeListShowId = options.crfeeListShowId;
	var crfeePageShowId = options.crfeePageShowId;
	var btnAddCrFeeTapId = options.btnAddCrFeeTapId;
	var btnConfirmCrFeeTapId = options.btnConfirmCrFeeTapId;
	var crfeeDetailWrapperShowId = options.crfeeDetailWrapperShowId;
	var btnBackActionOnHead = options.btnBackAction;

	var objCrFeeDetailPage = document.getElementById(crfeePageShowId);
	var $crFeeList = mui('#' + crfeeListShowId);
	var $crFeeDetailPage = mui('#' + crfeePageShowId);
	var $btnConfirmCrFees = document.getElementById(btnConfirmCrFeeTapId);

	//明细右上角返回按钮
	document.getElementById(btnBackActionOnHead).addEventListener('tap', function() {
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(crfeePageShowId);
	});
	//添加贷方信息
	document.querySelector('#' + btnAddCrFeeTapId).addEventListener('tap', function() {
		crCurrentFeeId = -1;
		oldScrollHeight = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
		mj.scrollToTop();
		crCurrentFee = {
			id: crCurrentFeeId,
			eaId: -1,
			eaName: '',
			expense: ''
		};
		mj.enableBtn($btnConfirmCrFees);
		renderCrFeeUI(crCurrentFee);
	});
	//增加贷方明细
	$crFeeDetailPage.on('tap', '#' + btnConfirmCrFeeTapId, function() {
		var objCrFeeSelectedEaName = document.getElementById('crFeeSelectedEaName');
		var objCrFeeExpense = document.getElementById('crFeeExpense');

		var crExpense = objCrFeeExpense.value;
		var crEaName = (objCrFeeSelectedEaName ? objCrFeeSelectedEaName.innerText : '');

		//添加或更新费用对象
		var crFeeId;
		var newCrFee = {
			id: crFeeId,
			eaName: crEaName,
			expense: crExpense
		};

		crCurrentFee = mui.extend(crCurrentFee, newCrFee);
		mj.disableBtn($btnConfirmCrFees);

		if (crCurrentFeeId == -1) {
			crFeeId = crFeeLength++;
			crCurrentFee.id = crFeeId;

			buildCrFeeSummaryForEdit(crCurrentFee, objCrFeesList);
		} else {
			crFeeId = crCurrentFeeId;
			crCurrentFee.id = crFeeId;

			updateCrFeeSummary(crCurrentFee);
		}

		crFeeMap[crFeeId] = crCurrentFee;
		calcBillExpenseTotalForCrFeeDetails(currentBillType);

		//关闭贷方信息弹窗
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(crfeePageShowId);
	});
	//删除贷方明细
	$crFeeList.on('tap', '.cr-fee-simple-delete', function() {
		var objCrFee = this.parentNode;
		var deleteId = this.parentNode.getAttribute('vid');
		mui.confirm('确认删除该明细？', '删除贷方明细', ['确认', '取消'], function(e) {
			if (e.index == 0) {
				if (objCrFee) {
					objCrFee.parentNode.removeChild(objCrFee);
					objCrFee = null;
				}

				delete crFeeMap[deleteId];

				calcBillExpenseTotalForCrFeeDetails(currentBillType);
			}
		});
	});

	getCrFeeTableColumnsHeaderForCreate(document.getElementById(crfeeDetailWrapperShowId), function() {
		initCrFeeEvents({
			crfeePageShowId: crfeePageShowId
		});
	});
}

function initCrFeeEvents(options) {
	options = options || {};
	var crfeePageShowId = options.crfeePageShowId;

	initMaterialReqCrBookForBillFee();

	mui('#' + crfeePageShowId).on('input', '#crFeeExpense', function() {
		crCurrentFee.expense = document.getElementById('crFeeExpense').value;
	});
}

//收款单单据明细
function generateBillDetailContentCollectionDrFees(list) {
	var listHtml = '';
	for (var i = 0; i < list.length; i++) {
		listHtml += '<li class="mui-table-view-cell fees-table-view"  vid="' + list[i].id + '">' +
			'<a href="#customFeeDetailPage" class="mui-navigate-right no-spacing-navigate-right">' +
			'	<div class="fee-info-detail-wrapper mui-ellipsis">' +
			'		<span class="table-text fee-simple-detail-ea fee-s-collection-dr-ea-' + list[i].id + '">' + list[i].eaName +
			'</span>' +
			'	</div>' +
			'	<span class="mj-pull-right fee-simple-detail-expense">' + list[i].expense.toFixed(2) + '</span>' +
			'	</a>' +
			'</li>';
	}
	return listHtml;
}

function generateCustomFeeSummaryListForEdit(feeList, objCustomFeeList) {
	for (var i = 0; i < feeList.length; i++) {
		buildCustomFeeSummaryForEdit(feeList[i], objCustomFeeList);
	}
}

function buildCustomFeeSummaryForEdit(customFee, objCustomFeeList) {
	var objCustomFee = document.createElement('div');
	objCustomFee.className = 'fee-item fee-item-' + customFee.id;
	objCustomFee.setAttribute("id", 'custom-fee-item-' + customFee.id);
	objCustomFee.setAttribute("vid", customFee.id);
	objCustomFee.innerHTML = '<a href="#customFeeDetailPage" class="fee-item-link">' +
		'		<div class="fee-info-detail-wrapper mui-ellipsis">' +
		'		<span id="custom-fee-s-ea-' + customFee.id + '" class="fee-simple-ea">' + (customFee.eaName ? customFee.eaName :
			'未选科目') + '</span>' +
		'	</div>' +
		'	<span id="custom-fee-s-expense-' + customFee.id + '" class="fee-simple-expense">' + Number(customFee.expense).toFixed(
			2) + '</span>' +
		'</a>' +
		'<span class="mj-pull-right iconfont icon-baoxiaomingxi-jian fee-simple-delete"></span>';

	objCustomFee.addEventListener('tap', function() {
		currentCustomFeeId = this.getAttribute("vid");
		currentCustomFee = customFeeMap[currentCustomFeeId];
		oldScrollHeight = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
		mj.scrollToTop();
		renderCollectionDrFeeUI(currentCustomFee);
		if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable) {
			renderCashFlowText(currentCustomFee.eaTypeInt, currentCustomFee.cashFlowName, 'feeCollectionDrCashFlowText',
				'feeCollectionSelectedDrCashFlowName');
		}

		mj.enableBtn(document.getElementById('btnConfirmCustomFees'));
	});

	objCustomFeeList.appendChild(objCustomFee);

	return objCustomFee;
}

function updateCustomFeeSummary(customFee) {
	document.getElementById('custom-fee-s-ea-' + customFee.id).innerText = (customFee.eaName ? customFee.eaName : '未选科目');
	document.getElementById('custom-fee-s-expense-' + customFee.id).innerText = Number(customFee.expense).toFixed(2);
}

function renderCollectionDrFeeUI(fee) {
	var objFeeSelectedCollectionDrEaName = document.getElementById('feeCollectionSelectedDrEaName');
	var objFeeSelectedCollectionDrCashFlowName = document.getElementById('feeCollectionSelectedDrCashFlowName');
	var objCollectionDrFeeCashTime = document.getElementById('feeCollectionDrCashTime');
	var objCollectionDrFeeExpense = document.getElementById('feeCollectionDrFeeExpense');
	var objCollectionDrFeeNote = document.getElementById('feeCollectionDrNote');

	objFeeSelectedCollectionDrEaName && (objFeeSelectedCollectionDrEaName.innerText = fee.eaName ? fee.eaName : '');
	objFeeSelectedCollectionDrCashFlowName && (objFeeSelectedCollectionDrCashFlowName.innerText = fee.cashFlowName ? fee.cashFlowName :
		'');
	objCollectionDrFeeCashTime && (objCollectionDrFeeCashTime.innerText = fee.cashTime ? new Date(fee.cashTime).format(
		'yyyy-MM-dd') : '');
	objCollectionDrFeeExpense && (objCollectionDrFeeExpense.value = fee.expense ? fee.expense : '');
	objCollectionDrFeeNote && (objCollectionDrFeeNote.value = fee.note ? fee.note : '');
}

//收款单借方明细
function initCollectionClmsFee(options) {
	options = options || {};
	var isCashFlowEnable = options.isCashFlowEnable || false;
	var feeDetailWrapperShowId = options.feeDetailWrapperShowId;
	var feeListShowId = options.feeListShowId;
	var feePageShowId = options.feePageShowId;
	var btnAddFeeTapId = options.btnAddFeeTapId;
	var btnConfirmFeeTapId = options.btnConfirmFeeTapId;
	var btnBackActionOnHead = options.btnBackAction;

	var objFeeDetailWrapper = document.getElementById(feeDetailWrapperShowId);
	var objFeeDetailPage = document.getElementById(feePageShowId);
	var $feeList = mui('#' + feeListShowId);
	var $feeDetailPage = mui('#' + feePageShowId);
	var objBtnConfirmFees = document.getElementById(btnConfirmFeeTapId);
	var objFeesList = document.getElementById(feeListShowId);

	//明细右上角返回按钮
	document.getElementById(btnBackActionOnHead).addEventListener('tap', function() {
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	document.querySelector('#' + btnAddFeeTapId).addEventListener('tap', function() {
		currentCustomFeeId = -1;
		currentCustomFee = mui.extend({}, BILL_FEE_ALL_CLMS);
		currentCustomFee.id = currentCustomFeeId;
		oldScrollHeight = document.body.scrollTop
		mj.scrollToTop();
		renderCollectionDrFeeUI(currentCustomFee);
		mj.enableBtn(objBtnConfirmFees);
	});

	//确认增加
	$feeDetailPage.on('tap', '#' + btnConfirmFeeTapId, function() {
		var objFeeSelectedEaName = document.getElementById('feeCollectionSelectedDrEaName');
		var objFeeSelectedCashFlowName = document.getElementById('feeCollectionSelectedDrCashFlowName');
		var objFeeCashTime = document.getElementById('feeCollectionDrCashTime');
		var objFeeExpense = document.getElementById('feeCollectionDrFeeExpense');
		var objFeeNote = document.getElementById('feeCollectionDrNote');

		var expense = objFeeExpense.value;
		var note = objFeeNote ? objFeeNote.value : '';
		var eaName = objFeeSelectedEaName ? objFeeSelectedEaName.innerText : '';
		var cashFlowName = objFeeSelectedCashFlowName ? objFeeSelectedCashFlowName.innerText : '';
		var cashTime = objFeeCashTime ? objFeeCashTime.innerText : '';

		//添加或更新费用对象
		var newFee = {
			id: feeId,
			expense: expense,
			note: note,
			eaName: eaName,
			cashTime: cashTime,
			cashFlowName: cashFlowName
		};

		mj.disableBtn(objBtnConfirmFees);
		var feeId;

		currentCustomFee = mui.extend(currentCustomFee, newFee);
		if (currentCustomFeeId == -1) {
			feeId = customFeeLength++;
			currentCustomFee.id = feeId;

			buildCustomFeeSummaryForEdit(currentCustomFee, objFeesList);
		} else {
			feeId = currentCustomFeeId;
			currentCustomFee.id = feeId;

			updateCustomFeeSummary(currentCustomFee);
		}

		customFeeMap[feeId] = currentCustomFee;

		calcBillExpenseTotalForCustomFeeDetails();

		//关闭报销明细弹窗
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	//删除
	$feeList.on('tap', '.fee-simple-delete', function() {
		var objFee = this.parentNode;
		var deleteId = this.parentNode.getAttribute('vid');
		mui.confirm('确认删除该明细？', '删除明细', ['确认', '取消'], function(e) {
			if (e.index == 0) {
				if (objFee) {
					objFee.parentNode.removeChild(objFee);
					objFee = null;
				}

				delete customFeeMap[deleteId];

				calcBillExpenseTotalForCustomFeeDetails();
			}
		});
	});

	//渲染费用列
	objFeeDetailWrapper.innerHTML = doGetCollectionDrFeeTableColumnsHeader(isCashFlowEnable);
	initCollectionDrBookForBillFee(feePageShowId);
	initCashFlowBookForFee({
		cashFlowItem: [CASH_FLOW_ITEM_OPERATE_IN, CASH_FLOW_ITEM_INVEST_IN, CASH_FLOW_ITEM_FIN_IN,
			CASH_FLOW_ITEM_TRANSFER_IN
		],
		feePageShowId: feePageShowId,
		feeTapCellId: 'feeCollectionDrCashFlowCell',
		feeCahsFlowShowId: 'feeCollectionSelectedDrCashFlowName',
		checkStatus: function() {
			return false;
		}
	}, function(selected) {
		currentCustomFee.cashFlowId = selected.id;
		currentCustomFee.cashFlowName = selected.name;
	});
	initFeeDayDtPicker();
}

//审批流程模板
function getBillProcessTemplateList(bill) {
	var listHtml =
		'<div class="bill-show-operate-vertical process_vertical">' +
		'	<h1 class="bill-show-operate-title bill-show-operate-text process_tit process_text">' + getBillStatus(bill.status,
			bill.billTypeInt) +
		'	</h1>' +
		'	<table>' +
		'		<tbody>';
	var listItem;
	mui.each(bill.processes, function(index, item) {
		listItem = item;
		var finishTime = '';
		var finishTimeMinute = '';
		if (listItem.finishTime) {
			var tmpFinishTime = listItem.finishTime.toDate();
			finishTime = tmpFinishTime.format('yyyy-MM-dd');
			finishTimeMinute = tmpFinishTime.format('hh:mm');
		}
		listHtml += '<tr>' +
			'	<td class="right_td ' + listItem.statusClass + '">' +
			'		<div class="date bill-show-operate-text process_text">' + finishTime +
			'			<span class="bill-show-operate-detail process_detail">' + finishTimeMinute + '</span> ' +
			'		</div>' +
			'		<div class="right_box">' +
			'			<div class="display-name">' +
			'				<span>' + listItem.displayName + '</span>' +
			'				<span>(' + WfResultEnum[listItem.result] + ')</span>' +
			'			</div>' +
			'			<div class="name">' +
			'				<span>操作人：</span>' +
			'				<span>' + listItem.operatorName + '</span>' +
			'			</div>' +
			'		</div>' +
			'	</td>' +
			'</tr>';
	});

	listHtml += '</tbody></table></div>'
	return listHtml;
}

//操作记录模板
function getBillActionTemplateList(bill) {
	var listHtml =
		'<div class="bill-show-operate-vertical">' +
		'	<table>' +
		'		<tbody>';
	var listItem;
	mui.each(bill.actions, function(index, item) {
		listItem = item;
		var createDate = '';
		var createDateMinute = '';
		if (listItem.createDate) {
			var tmpCreateDate = new Date(listItem.createDate);
			createDate = tmpCreateDate.format('yyyy-MM-dd');
			createDateMinute = tmpCreateDate.format('hh:mm');
		}
		if (listItem.action == ACTION_BILL_ADJUST) {
			return true;
		}
		listHtml += '<tr>' +
			'	<td class="right_td">' +
			'		<div class="date bill-show-operate-text">' + createDate + '<span class="operater-time-text">' +
			createDateMinute + '</span> ' +
			'		</div>' +
			'		<div class="right_box">' +
			'			<div class="state">' +
			'				<div>' + mjShowBillActionNew(item, bill.bill) + '</div>' +
			'			</div>' +
			'			<div class="name">' +
			'				<span>操作人：</span>' +
			'				<span>' + listItem.userName + '</span>' +
			'				<span>(' + mjShowAction(listItem.action) + ')</span>' +
			'			</div>' +
			'		</div>' +
			'	</td>' +
			'</tr>';
	});
	listHtml += '</tbody></table></div>'
	return listHtml;
}

//回复列表模板
function generateBillReplyList(list) {
	var listHtml = '';
	for (var i = 0; i < list.length; i++) {
		listHtml += generateBillReplyItem(list[i]);
	}
	return listHtml;
}

function generateBillReplyItem(listItem) {
	var createTime = new Date(listItem.createDate).format('yyyy-MM-dd hh:mm');
	var listHtml = '';
	listHtml += '<li class="mui-table-view-cell">' +
		'		<div>' +
		'			<div class="adapt-column-div">' +
		'				<span class="hr-list-text-mini-size hr-list-light-color">' + listItem.senderName + '</span>' +
		'			</div>' +
		'			<span class="fixed-column-div">' +
		'				<span class="hr-list-text-mini-size hr-list-light-color">' + createTime + '</span>' +
		'			</span>' +
		'		</div>' +
		'		<div class="hr-list-second-line">' +
		'				<span>' + listItem.note + '</span>' +
		'		</div>' +
		'</li>';
	return listHtml;
}

function renderBillProcess($container, billId, bill) {
	mj.get(MJ_URL.BILL_F_PROCESS.mjFormat(billId), {}, function(d) {
			mui.each(d, function(index, item) {
				switch (item.status) {
					case WF_STATUS_MID_PROCESSING:
						item.statusClass = 'pending';
						break;
					case WF_STATUS_MID_PASS:
						item.statusClass = 'pass';
						break;
					case WF_STATUS_REFUSE:
						item.statusClass = 'refuse';
						break;
					case WF_STATUS_COMPLETE_PROCESSING:
						item.statusClass = 'complete';
						break;
					case WF_STATUS_COMPLETE_PASS:
						item.statusClass = 'complete_ok';
						break;
					default:
						item.statusClass = '';
						break;
				}
			});
			bill.processes = d;
			$container.innerHTML = getBillProcessTemplateList(bill)
		},
		function() {}
	);
}

//action
function renderBillActions($container, billId, billType) {
	mj.get(MJ_URL.BILL_F_ACTIONS.mjFormat(billId), {}, function(d) {
			var billActions = {
				actions: d,
				bill: {
					billId: billId,
					billType: billType
				}
			};
			$container.innerHTML = getBillActionTemplateList(billActions);
		},
		function() {}
	);
}

function mjShowAction(actionCode) {
	if (actionCode && mjActions.hasOwnProperty(actionCode)) {
		return mjActions[actionCode];
	} else {
		return '未知操作';
	}
}

function mjShowBillActionNew(action, bill) {
	var str = '';
	if (ACTION_BILL_CREATE == action.action || ACTION_BILL_MEND == action.action || ACTION_BILL_CREATE_UPLOAD == action.action) {
		return str;
	}

	var curData = action.curData;
	if (!curData) return str;

	if (!curData.startWith('{') || !curData.endWith('}')) {
		return '<span class="action-data-item">' + curData + '</span>';
	}

	var obj;
	try {
		obj = mui.parseJSON(action.curData);
	} catch (e) {
		return '<span class="action-data-item">' + curData + '</span>';
	}

	switch (action.action) {
		case ACTION_CAR_BILL_MONTH_RENT:
			str += '<span class="action-data-item">租金:' + obj['fee'] + '元</span>';
			break;

		case ACTION_BILL_ACCRUED_OFF:
			str += '<span class="action-data-item">关联单据</span>';
			break;

		case ACTION_BILL_PAY:
			str += '<span class="action-data-item">付款日期:' + new Date(obj['payTime']).format('yyyy-MM-dd') + '</span>';
			break;

		case ACTION_BILL_COLLECT:
			str += '<span class="action-data-item">收款日期:' + new Date(obj['payTime']).format('yyyy-MM-dd') + '</span>';
			break;

		case ACTION_BILL_CARRY_OVER:
			str += '<span class="action-data-item">结转日期:' + new Date(obj['carryOverTime']).format('yyyy-MM-dd') + '</span>';
			mui.each(obj['billCrs'], function(index, item) {
				str += '<span class="action-data-item">' + item.eaName + ':' + item.expense.toFixed(2) + '</span>';
			});
			break;

		default:
			mui.each(obj, function(index, item) {
				switch (index) {
					case 'note':
						str += '<span class="action-data-item">备注:' + obj[index] + '</span>';
						break;
					case 'rejectReason':
						str += '<span class="action-data-item">备注:' + obj[index] + '</span>';
						break;
					case 'rent':
						str += '<span class="action-data-item">租金:' + obj[index] + '元</span>';
						break;
					case 'startMileage':
						str += '<span class="action-data-item">起始里程:' + obj[index] + '公里</span>';
						break;
					case 'endMileage':
						str += '<span class="action-data-item">结束里程:' + obj[index] + '公里</span>';
						break;
					case 'receiveBank':
						if (obj[index] != '') str += '<span class="action-data-item">收款银行:' + obj[index] + '</span>';
						break;
					case 'receiveNum':
						if (obj[index] != '') str += '<span class="action-data-item">银行账号:' + obj[index] + '</span>';
						break;
					case 'haveInvoiceInt':
						str += '<span class="action-data-item">有无发票:' + HaveInvoiceStatusPool[obj[index]] + '</span>';
						break;
					case 'collectTime':
						if (obj[index] != '') str += '<span class="action-data-item">' + new Date(obj[index]).format('yyyy-MM-dd') +
							'</span>';
						break;
					default:
						break;
				}
			});
			break;
	}
	return str;
}

//发票
function generateBillInvoiceItem(listItem) {
	return '<div class="mui-table-view bill-invoice-item bill-invoice-item-' + listItem.id + '" iid="' + listItem.id +
		'" inum="' + listItem.invoiceNum + '">' +
		'	<div class="hr-list-block hr-list-item">' +
		'		<div class="hr-list-block-info">' +
		'			<div class="hr-list-first-line">' +
		'				<div class="hr-list-first-left">' +
		'					<span class="hr-list-name">发票代码:' + listItem.code + '</span>' +
		'				</div>' +
		'				<span class="hr-list-text-mini-size hr-list-right hr-list-bold">' +
		'					<span class="hr-list-right-icon"></span>' + listItem.expense +
		'				</span>' +
		'			</div>' +
		'			<div class="hr-list-second-line hr-list-light-color">' +
		'				<span class="hr-list-text-size">发票号码:' + listItem.invoiceNum + '</span>' +
		'			</div>' +
		'			<div class="hr-list-third-line hr-list-light-color">' +
		'				<span class="hr-list-text-block">' +
		'					<span>' + InvoiceTypeEnum[listItem.invoiceType] + '</span>' +
		'				</span>' +
		'			</div>' +
		'		</div>' +
		'	</div>' +
		'</div>';
}

function generateBillInvoiceList(list) {
	var listHtml = '';
	for (var i = 0; i < list.length; i++) {
		var listItem = list[i];
		listHtml += generateBillInvoiceItem(listItem);
	}
	return listHtml;
}

function splitDateStr(dateStr) {
	var year = dateStr.substr(0, 4);
	var month = dateStr.substr(4, 2);
	var day = dateStr.substr(6, 2);
	if (!year || !month || !day) {
		return '';
	}
	return year + '-' + month + '-' + day;
}

function getCheckCodeLastStr(checkCodeStr) {
	if (!checkCodeStr || checkCodeStr == '' || checkCodeStr.length < 6) {
		return '';
	}
	var lastStr = checkCodeStr.substring(checkCodeStr.length - 6);
	return lastStr;
}

function showInvoiceScanView(successCallback) {
	pushInVoiceScanWebView({
		noCache: true,
		callback: function(result) {
			successCallback && successCallback(result);
		},
		cancelCallback: function() {

		}
	});
}

function resetInvoiceUIForCreate() {
	curBillInvoiceType = -1;
	document.getElementById('addInvoiceTypeSelect').innerText = '';
	document.getElementById('addInvoiceCode').value = '';
	document.getElementById('addInvoiceNum').value = '';
	document.getElementById('addInvoiceCheckCode').value = '';
	document.getElementById('addSellerName').value = '';
	document.getElementById('addInvoiceBuyerName').value = '';
	document.getElementById('addInvoiceBuyerNum').value = '';
	document.getElementById('addInvoiceTime').innerText = '';
	document.getElementById('addExpenseExcludeTax').value = '';
	document.getElementById('addExpense').value = '';
}

function renderScanInvoiceUI(invoiceData) {
	if (invoiceData) {
		document.getElementById('addInvoiceTypeSelect').innerText = InvoiceTypeEnum[invoiceData.invoiceType];
		document.getElementById('addInvoiceCode').value = invoiceData.code;
		document.getElementById('addInvoiceNum').value = invoiceData.invoiceNum;
		document.getElementById('addInvoiceCheckCode').value = invoiceData.checkCode;
		document.getElementById('addInvoiceTime').innerText = invoiceData.invoiceTime;
		document.getElementById('addExpenseExcludeTax').value = invoiceData.expenseExcludeTax;
	}
}

function renderBillInvoice(options, callback) {
	var billId = options.billId || -1;
	var billStatus = options.billStatus || BILL_STATUS_CREATED;
	var billApplier = options.billApplier || -1;
	var containerId = options.containerId;
	var objContainer = document.getElementById(containerId);
	var getInvoiceList = options.getInvoiceList || false;
	var addSuccessCallback = options.addSuccessCallback || undefined;

	//获取详情
	if (getInvoiceList) {
		mj.get(MJ_URL.INVOICE_API, {
			billId: billId
		}, function(o) {
			if (o && o.status == SYSTEM_SUCCEED) {
				var invoiceList = o.data;
				var listHtml = generateBillInvoiceList(invoiceList);
				objContainer.innerHTML = objContainer.innerHTML + listHtml;
				if (checkWindowProperty('billInvoiceMap')) {
					var contactUserItem;
					for (var i = 0; i < invoiceList.length; i++) {
						billInvoiceMap[invoiceList[i].id] = invoiceList[i];
					}
				}
				callback && callback();
			} else {
				mui.toast(LOST_NETWORK_CONNECTION);
			}
		}, function(xhr) {
			showResult(xhr, LOST_NETWORK_CONNECTION);
		});
	}

	//新建发票
	var canInvoiceAction = (billStatus == BILL_STATUS_CREATED || billStatus == BILL_STATUS_REVIEWING || billStatus == BILL_STATUS_REJECTED);
	if (canInvoiceAction) {
		//手动录入
		document.getElementById('btnCreateInvoice').style.display = 'block';
		document.getElementById('btnCreateInvoice').addEventListener("tap", function(e) {
			resetInvoiceUIForCreate();
			if (checkWindowProperty('oldScrollHeight') >= 0) oldScrollHeight = document.body.scrollTop ? document.body.scrollTop :
				document.documentElement.scrollTop;
			mj.scrollToTop();
			mj.showModal('addInvoiceModal');
		});
		//扫描
		document.getElementById('btnScanInvoice').style.display = 'block';
		document.getElementById('btnScanInvoice').addEventListener("tap", function(e) {
			resetInvoiceUIForCreate();
			var invoiceData = {};
			if (checkWindowProperty('oldScrollHeight') >= 0) oldScrollHeight = document.body.scrollTop ? document.body.scrollTop :
				document.documentElement.scrollTop;
			showInvoiceScanView(function(result) {
				if (result) {
					curBillInvoiceType = result.type;
					invoiceData.invoiceType = curBillInvoiceType;
					invoiceData.creatorId = mj.getId();
					invoiceData.invoiceNum = result.num;
					invoiceData.code = result.code;
					invoiceData.expenseExcludeTax = result.expenseExcludeTax;
					invoiceData.invoiceTime = result.time != '' ? splitDateStr(result.time) : '';
					invoiceData.checkCode = result.checkCode != '' ? getCheckCodeLastStr(result.checkCode) : '';
					mj.scrollToTop();
					mj.showModal('addInvoiceModal');
					renderScanInvoiceUI(invoiceData);
				}
			});
		});

		initBillInvoiceForCreate({
			billId: billId
		}, function(invoiceItem) {
			if (addSuccessCallback) addSuccessCallback && addSuccessCallback(invoiceItem);
		});
	}

	//查看详情
	var curInvoiceId = -1;
	mui('#' + containerId).on('tap', '.bill-invoice-item', function(e) {
		e.detail.gesture.preventDefault();
		if (checkWindowProperty('oldScrollHeight') >= 0) oldScrollHeight = document.body.scrollTop ? document.body.scrollTop :
			document.documentElement.scrollTop;
		curInvoiceId = this.getAttribute('iid');
		mj.scrollToTop();
		mj.showModal('detailInvoiceModal');
		if (billInvoiceMap[curInvoiceId].creatorId == mj.getId() && canInvoiceAction) {
			document.getElementById('btnUnlinkInvoiceItemWrapper').style.display = 'block';
		}
		initInvoiceDetailUI(billInvoiceMap[curInvoiceId]);
	});

	//返回单据页面
	mui('#detailInvoiceModal').on('tap', '#btnCloseDetailInvoiceModal', function(e) {
		if (checkWindowProperty('oldScrollHeight') >= 0) mj.fixScrollTop(oldScrollHeight);
	});

	//移除发票关联
	if (canInvoiceAction) {
		var objBtnUnlinkInvoiceItem = document.getElementById('btnUnlinkInvoiceItem');
		if(!objBtnUnlinkInvoiceItem)  return false;
		objBtnUnlinkInvoiceItem.addEventListener('tap', function(e) {
			suspendEventBub(e);
			var unlinkBill = (billId == -1);
			doActionUnLinkInvoice(unlinkBill, curInvoiceId, function() {
				delete billInvoiceMap[curInvoiceId];
				mj.hideModal('detailInvoiceModal');
				if (checkWindowProperty('oldScrollHeight') >= 0) mj.fixScrollTop(oldScrollHeight);
				document.querySelector('.bill-invoice-item-' + curInvoiceId).remove();
			});
		});
	}
}

function initBillInvoiceForCreate(options, callback) {
	options = options || {};
	var billId = options.billId || -1;
	var invoiceTypeInt = -1;
	var invoiceTypeName = '';

	document.getElementById('btnCancelAddInvoice').addEventListener('tap', function() {
		mj.hideModal('addInvoiceModal');
		if (checkWindowProperty('oldScrollHeight') >= 0) mj.fixScrollTop(oldScrollHeight);
	});

	initInvoiceTypeBook({
		invoiceTypeTapId: 'addInvoiceTypeCell',
		invoiceTypeShowId: 'addInvoiceTypeSelect'
	}, function(selected) {
		invoiceTypeInt = selected.id;
		invoiceTypeName = selected.name;
	});

	initFeeDayDp('#addInvoiceTimeCell', '#addInvoiceTime');

	mui('#addInvoiceModal').on('tap', '#btnAddInvoice', function() {
		var objInvoiceTypeSelect = document.getElementById('addInvoiceTypeSelect');
		var objInvoiceCode = document.getElementById('addInvoiceCode');
		var objInvoiceNum = document.getElementById('addInvoiceNum');
		var objCheckCode = document.getElementById('addInvoiceCheckCode');
		var objSellerName = document.getElementById('addSellerName');
		var objBuyerName = document.getElementById('addInvoiceBuyerName');
		var objBuyerNum = document.getElementById('addInvoiceBuyerNum');
		var objInvoiceTime = document.getElementById('addInvoiceTime');
		var objExpenseExcludeTax = document.getElementById('addExpenseExcludeTax');
		var objExpense = document.getElementById('addExpense');

		var code = objInvoiceCode ? objInvoiceCode.value : '';
		var num = objInvoiceNum ? objInvoiceNum.value : '';
		var checkCode = objCheckCode ? objCheckCode.value : '';
		var sellerName = objSellerName ? objSellerName.value : '';
		var buyerName = objBuyerName ? objBuyerName.value : '';
		var buyerNum = objBuyerNum ? objBuyerNum.value : '';
		var invoiceTime = objInvoiceTime ? objInvoiceTime.innerText : '';
		var expenseExcludeTax = objExpenseExcludeTax ? objExpenseExcludeTax.value : '';
		var expense = objExpense ? objExpense.value : '';

		invoiceTypeInt = invoiceTypeInt != -1 ? invoiceTypeInt : (checkWindowProperty('curBillInvoiceType') != -1 ?
			checkWindowProperty('curBillInvoiceType') : -1);

		var newInvoice = {
			billId: billId,
			invoiceType: invoiceTypeInt,
			invoiceTypeName: invoiceTypeName,
			code: code,
			invoiceNum: num,
			checkCode: checkCode,
			sellerName: sellerName,
			buyerName: buyerName,
			buyerNum: buyerNum,
			invoiceTime: invoiceTime,
			expenseExcludeTax: expenseExcludeTax,
			expense: expense
		};

		var valid = false;
		valid = checkInvoiceModal(newInvoice, ['invoiceType', 'code', 'invoiceNum', 'expense']);
		if (!valid) {
			return false;
		}

		mj.fixAfterInput();

		doActionSaveInvoice(newInvoice, function(resData) {
			mj.hideModal('addInvoiceModal');
			invoiceTypeInt = -1;
			invoiceTypeName = '';
			if (objInvoiceTypeSelect) objInvoiceTypeSelect.innerText = '';
			if (objInvoiceCode) objInvoiceCode.value = '';
			if (objInvoiceNum) objInvoiceNum.value = '';
			if (objCheckCode) objCheckCode.value = '';
			if (objSellerName) objSellerName.value = '';
			if (objBuyerName) objBuyerName.value = '';
			if (objBuyerNum) objBuyerNum.value = '';
			if (objInvoiceTime) objInvoiceTime.innerText = '';
			if (objExpenseExcludeTax) objExpenseExcludeTax.value = '';
			if (objExpense) objExpense.value = '';
			if (checkWindowProperty('oldScrollHeight') >= 0) mj.fixScrollTop(oldScrollHeight);
			newInvoice.id = resData.id;
			newInvoice.opType = INVOICE_OP_TYPE_IMPORT_APP;
			newInvoice.creatorId = mj.getId();
			callback && callback(newInvoice);
		});
	});
}

function initInvoiceDetailUI(data) {
	var nullTip = '[无录入]';
	var objInvoiceType = document.getElementById('detailInvoiceType');
	var objInvoiceCode = document.getElementById('detailInvoiceCode');
	var objInvoiceNum = document.getElementById('detailInvoiceNum');
	var objCheckCode = document.getElementById('detailInvoiceCheckCode');
	var objSellerName = document.getElementById('detailSellerName');
	var objBuyerName = document.getElementById('detailInvoiceBuyerName');
	var objBuyerNum = document.getElementById('detailInvoiceBuyerNum');
	var objInvoiceTime = document.getElementById('detailInvoiceTime');
	var objExpenseExcludeTax = document.getElementById('detailExpenseExcludeTax');
	var objExpense = document.getElementById('detailExpense');

	objInvoiceType && (objInvoiceType.innerText = data.invoiceType ? InvoiceTypeEnum[data.invoiceType] : nullTip);
	objInvoiceCode && (objInvoiceCode.innerText = data.code ? data.code : nullTip);
	objInvoiceNum && (objInvoiceNum.innerText = data.invoiceNum ? data.invoiceNum : nullTip);
	objCheckCode && (objCheckCode.innerText = data.checkCode ? data.checkCode : nullTip);
	objSellerName && (objSellerName.innerText = data.sellerName ? data.sellerName : nullTip);
	objBuyerName && (objBuyerName.innerText = data.buyerName ? data.buyerName : nullTip);
	objBuyerNum && (objBuyerNum.innerText = data.buyerNum ? data.buyerNum : nullTip);
	objInvoiceTime && (objInvoiceTime.innerText = data.invoiceTime ? new Date(data.invoiceTime).format('yyyy-MM-dd') :
		nullTip);
	objExpenseExcludeTax && (objExpenseExcludeTax.innerText = data.expenseExcludeTax ? data.expenseExcludeTax : nullTip);
	objExpense && (objExpense.innerText = data.expense ? data.expense : nullTip);
}

function initInvoiceTypeBook(options, callback) {
	options = options || {};
	var invoiceTypes = [];
	var invoiceTypeTapId = options.invoiceTypeTapId || '';
	var invoiceTypeShowId = options.invoiceTypeShowId || '';

	mui.each(InvoiceTypeEnum, function(index, item) {
		invoiceTypes.push({
			id: index,
			name: item
		});
	});


	document.getElementById(invoiceTypeTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'INVOICE_TYPE',
			title: '请选择发票类型',
			param: {},
			showInvoiceTypes: invoiceTypes,
			callback: function(selected) {
				if (invoiceTypeShowId) document.getElementById(invoiceTypeShowId).innerText = selected.name;
				callback && callback(selected);
			}
		});
	});
}

function checkInvoiceModal(postData, postItem) {
	var valid = true;
	var validMsg = '';
	mui.each(postItem, function(index, item) {
		switch (item) {
			case 'invoiceType':
				if (postData[item] == -1) {
					valid = false;
					validMsg = '请选择发票类型';
					return false;
				}
				break;
			case 'code':
				if (postData[item] == '') {
					valid = false;
					validMsg = '请填写发票代码';
					return false;
				}
				break;
			case 'invoiceNum':
				if (postData[item] == '') {
					valid = false;
					validMsg = '请填写发票号码';
					return false;
				}
				break;
			case 'expense':
				if (postData[item] == '') {
					valid = false;
					validMsg = '请填写价税合计';
					return false;
				}
				break;
			default:
				break;
		}
	});
	if (!valid) {
		mui.toast(validMsg);
	}
	return valid;
}

function doActionSaveInvoice(postData, callback) {
	mj.showLoading();
	mj.post(MJ_URL.INVOICE_A_CREATE, postData, function(res) {
		if (res && res.status == SYSTEM_SUCCEED) {
			mui.toast('保存发票成功');
			callback && callback(res.data);
		} else {
			showFromCode(res.status);
		}
		mj.hideLoading();
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
		mj.hideLoading();
	});
}

function doActionDeleteInvoice(invoiceId, callback) {
	mj.confirm({
		msg: '确认删除此发票？'
	}, function() {
		mj.showLoading();
		mj.post(MJ_URL.INVOICE_A_DELETE.mjFormat(invoiceId), {}, function(res) {
			if (res && res.status == SYSTEM_SUCCEED) {
				mui.toast('删除发票成功');
				callback && callback();
			} else {
				showFromCode(res.status);
			}
			mj.hideLoading();
		}, function(xhr) {
			showResult(xhr, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		});
	});
}

function doActionUnLinkInvoice(unlinkBill, invoiceId, callback) {
	mj.confirm({
		msg: '确认移除此发票与单据的关联？'
	}, function() {
		if (unlinkBill) {
			mui.toast('取消发票关联成功');
			callback && callback();
			return;
		}
		mj.showLoading();
		mj.post(MJ_URL.INVOICE_A_UNLINK.mjFormat(invoiceId), {}, function(res) {
			if (res && res.status == SYSTEM_SUCCEED) {
				mui.toast('取消发票关联成功');
				callback && callback();
			} else {
				showFromCode(res.status);
			}
			mj.hideLoading();
		}, function(xhr) {
			showResult(xhr, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		});
	});
}


//金额大写
function bindInputChangeEvent(input, callback) {
	if ("\v" == "v") {
		input.onpropertychange = function(e) {
			callback(e);
		};
	} else {
		input.addEventListener("input", function(e) {
			callback(e);
		}, false);
	}
}

function getBillFeeHeaders(clmArr) {
	var feeHeaders = mui.extend({}, BILL_CLMS_HEADER);
	mui.each(clmArr, function(key, val) {
		feeHeaders[val] = true;
	});
	return feeHeaders;
}

function getFeeHeader(confKey, defaultFeeClms, callback, fnFix) {
	mj.get(MJ_URL.DICT_BY_FEE_CREATE.mjFormat(confKey), {}, function(data) {
		var headers = data.dict;
		var dms = data.dms;
		headers = headers.replace('，', ',');
		headers = headers.split(',');
		var feeClms = mui.extend({}, defaultFeeClms);
		mui.each(headers, function(key, val) {
			if (val && val != '' && defaultFeeClms.hasOwnProperty(val)) {
				feeClms[val] = true;
			}
		});
		fnFix && fnFix(feeClms);
		callback && callback(feeClms, dms);
	});
}
//创建页表头
function getFeeTableColumnsHeaderForCreate(feeKey, defaultFeeClms, $feeClms, callback, fnFix) {
	var clmHtml;
	getFeeHeader(feeKey, defaultFeeClms, function(feeClms, data) {
		if (feeClms.dm1) {
			getBillConfFeeDms('dm1', data, function(showInput, showSelect, feeDms) {
				showDm1Input = showInput;
				showDm1Select = showSelect;
				dm1s = feeDms;
			});
		}

		if (feeClms.dm2) {
			getBillConfFeeDms('dm2', data, function(showInput, showSelect, feeDms) {
				showDm2Input = showInput;
				showDm2Select = showSelect;
				dm2s = feeDms;
			});
		}

		if (feeClms.dm3) {
			getBillConfFeeDms('dm3', data, function(showInput, showSelect, feeDms) {
				showDm3Input = showInput;
				showDm3Select = showSelect;
				dm3s = feeDms;
			});
		}

		if (feeClms.dm4) {
			getBillConfFeeDms('dm4', data, function(showInput, showSelect, feeDms) {
				showDm4Input = showInput;
				showDm4Select = showSelect;
				dm4s = feeDms;
			});
		}

		if (feeClms.dm5) {
			getBillConfFeeDms('dm5', data, function(showInput, showSelect, feeDms) {
				showDm5Input = showInput;
				showDm5Select = showSelect;
				dm5s = feeDms;
			});
		}

		setTimeout(function() {
			clmHtml = doGetFeeTableColumnsHeader(feeClms, $feeClms);
			$feeClms.innerHTML = clmHtml;
			callback && callback(feeClms);
		}, 100);

	}, fnFix);
}
//详情页表头
function getFeeTableColumnsHeaderForDetail(feeKey, defaultFeeClms, callback, fnFix) {
	getFeeHeader(feeKey, defaultFeeClms, function(feeClms, dms) {
		callback && callback(feeClms, dms);
	}, fnFix);
}
//费用列特定显示与不显示(销售单只有客户,收款单没有客户没有供应商,其他单据均可配)
function getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, feeClms) {
	//单据明细多币别
	if(checkWindowProperty('billMultiCurrency')) {
		feeClms.payCurrencyId = true;
		feeClms.bizExpense = true;
	}else{
		feeClms.payCurrencyId = false;
		feeClms.bizRate = false;
		feeClms.bizExpense = false;
	}

	switch (feeHeaderDictKey) {
		case DICT_TRAVEL_BILL_HEADER:
		case DICT_SUPPLIER_PAY_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.owner = true;
			feeClms.cashFlowId = false;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			feeClms.collectTime = false;
			break;
		case DICT_BANK_DEDUCTION_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.cashTime = true;
			feeClms.toCurrencyId = false;
			feeClms.collectTime = false;
			if (window.hasOwnProperty('isCashFlowEnable')) {
				feeClms.cashFlowId = isCashFlowEnable;
			} else {
				feeClms.cashFlowId = false;
			}
			break;
		case DICT_DEPRECIATION_BILL_HEADER:
		case DICT_ACCRUED_BILL_HEADER:
		case DICT_MATERIAL_REQ_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.taxExpense = false;
			feeClms.cashFlowId = false;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			feeClms.collectTime = false;
			break;
		case DICT_SUPER_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.note = true;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = true;
			if (window.hasOwnProperty('isCashFlowEnable')) {
				feeClms.cashFlowId = isCashFlowEnable;
			} else {
				feeClms.cashFlowId = false;
			}
			if (window.hasOwnProperty('isRecvEnable')) {
				feeClms.collectTime = isRecvEnable;
			} else {
				feeClms.collectTime = false;
			}
			break;
		case DICT_SUPPLIER_ASSET_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.budget = false;
			feeClms.totalBudget = false;
			feeClms.cashFlowId = false;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			feeClms.collectTime = false;
			break;
		case DICT_SALE_BILL_HEADER:
			feeClms.departmentId = true;
			feeClms.owner = true;
			feeClms.consumerId = true;
			feeClms.taxExpense = true;
			feeClms.note = true;
			feeClms.supplierId = false;
			feeClms.customerId = false;
			feeClms.bizId = false;
			feeClms.budget = false;
			feeClms.totalBudget = false;
			feeClms.cashFlowId = false;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			if (window.hasOwnProperty('isRecvEnable')) {
				feeClms.collectTime = isRecvEnable;
			} else {
				feeClms.collectTime = false;
			}
			break;
		case DICT_COLLECTION_BILL_HEADER:
			feeClms.note = true;
			feeClms.supplierId = false;
			feeClms.customerId = true;
			feeClms.consumerId = true;
			feeClms.bizId = false;
			feeClms.taxExpense = false;
			feeClms.taxEaId = false;
			feeClms.budget = false;
			feeClms.totalBudget = false;
			feeClms.cashFlowId = false;
			feeClms.cashTime = false;
			if (window.hasOwnProperty('isToCurrency')) {
				feeClms.toCurrencyId = isToCurrency;
			} else {
				feeClms.toCurrencyId = false;
			}
			if (window.hasOwnProperty('isRecvEnable')) {
				feeClms.collectTime = isRecvEnable;
			} else {
				feeClms.collectTime = false;
			}
			break;
		case DICT_SUPPLIER_PAY_GOODS_BILL_HEADER:
			feeClms.note = true;
			feeClms.departmentId = false;
			feeClms.owner = false;
			feeClms.eaId = false;
			feeClms.supplierId = false;
			feeClms.customerId = false;
			feeClms.consumerId = false;
			feeClms.taxExpense = false;
			feeClms.budget = false;
			feeClms.totalBudget = false;
			feeClms.taxEaId = false;
			feeClms.cashFlowId = false;
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			feeClms.collectTime = false;
			break;
		case DICT_TRANSFER_BILL_HEADER:
			feeClms.billDcTypeInt = true;
			feeClms.departmentId = true;
			feeClms.projectId = true;
			feeClms.taxExpense = false;
			feeClms.taxEaId = false;
			if (window.hasOwnProperty('isCashFlowEnable')) {
				feeClms.cashFlowId = isCashFlowEnable;
			} else {
				feeClms.cashFlowId = false;
			}
			feeClms.toCurrencyId = false;
			feeClms.cashTime = false;
			feeClms.collectTime = false;
			break;
		default:
			break;
	}
	if (!feeClms.taxExpense) {
		feeClms.taxEaId = false;
	}
}

function buildFeeDetail(feeClms, data, $feeClms, fee) {
	var clmHtml;
	if (feeClms.dm1) {
		getBillConfFeeDms('dm1', data, function(showInput, showSelect, feeDms) {
			showDm1Input = showInput;
			showDm1Select = showSelect;
			dm1s = feeDms;
		});
	}

	if (feeClms.dm2) {
		getBillConfFeeDms('dm2', data, function(showInput, showSelect, feeDms) {
			showDm2Input = showInput;
			showDm2Select = showSelect;
			dm2s = feeDms;
		});
	}

	if (feeClms.dm3) {
		getBillConfFeeDms('dm3', data, function(showInput, showSelect, feeDms) {
			showDm3Input = showInput;
			showDm3Select = showSelect;
			dm3s = feeDms;
		});
	}

	if (feeClms.dm4) {
		getBillConfFeeDms('dm4', data, function(showInput, showSelect, feeDms) {
			showDm4Input = showInput;
			showDm4Select = showSelect;
			dm4s = feeDms;
		});
	}

	if (feeClms.dm5) {
		getBillConfFeeDms('dm5', data, function(showInput, showSelect, feeDms) {
			showDm5Input = showInput;
			showDm5Select = showSelect;
			dm5s = feeDms;
		});
	}
	setTimeout(function() {
		clmHtml = generateBillDetailFeeTableColumns(feeClms, fee);
		$feeClms.innerHTML = clmHtml;
		if (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_COLLECTION) {
			if (window.hasOwnProperty('billPayTarget')) {
				renderPayTargetObjSelectForFee(billPayTarget, $feeClms);
			}
		}
	}, 100);
}

function checkFinDmChangePer(check, callback) {
	has_bill_dm_change_permission = check.hasDmPermission;
	has_bill_dm1_change_permission = check.hasDm1Permission == undefined ? has_bill_dm_change_permission : check.hasDm1Permission;
	has_bill_dm2_change_permission = check.hasDm2Permission == undefined ? has_bill_dm_change_permission : check.hasDm2Permission;
	has_bill_dm3_change_permission = check.hasDm3Permission == undefined ? has_bill_dm_change_permission : check.hasDm3Permission;
	has_bill_dm4_change_permission = check.hasDm4Permission == undefined ? has_bill_dm_change_permission : check.hasDm4Permission;
	has_bill_dm5_change_permission = check.hasDm5Permission == undefined ? has_bill_dm_change_permission : check.hasDm5Permission;
	var checkChangePer = has_bill_dm1_change_permission || has_bill_dm2_change_permission ||
		has_bill_dm3_change_permission || has_bill_dm4_change_permission || has_bill_dm5_change_permission;
	callback && callback(checkChangePer);
}

function checkFinPermission(bill, callback) {
	switch (Number(bill.status)) {
		case BILL_STATUS_REVIEWING:
		case BILL_STATUS_APPROVED:
		case BILL_STATUS_PAID:
		case BILL_STATUS_COLLECT:
			mj.get(MJ_URL.BILL_A_FIN_CHECK_PERM.mjFormat(bill.departmentId), {}, function(d) {
				callback && callback(d);
			}, function() {
				callback && callback(false);
			});
			break;
		default:
			callback && callback(false);
			break;
	}
}

function checkReviewAction(bill, billId, billType, callback) {
	if (BILL_STATUS_REVIEWING != bill.status) {
		callback && callback(false);
		return false;
	}

	var billTypeName = getBillNameByType(billType);
	var billRecallUrl = MJ_URL.BILL_A_RECALL.mjFormat(billTypeName, billId);
	var billRejectUrl = MJ_URL.BILL_A_REJECT.mjFormat(billTypeName, billId);
	var billApproveUrl = MJ_URL.BILL_A_APPROVE.mjFormat(billTypeName, billId)

	mj.get(MJ_URL.BILL_A_CHECK_REVIEW.mjFormat(billId), {}, function(d) {
		if (SYSTEM_SUCCEED == d.status) {

			//撤回单据
			if (bill.currentStepIndex == 1 && bill.applier == mj.getId()) {
				renderBillDetailBtnGroup({
					canRecall: true,
					canApprove: true,
					canReject: true
				});

				bindBillActionRecall(billRecallUrl, {}, document.getElementById('btnRecall'), function() {
					mj.refreshViewOfMine();
					mj.backAndRefresh();
				});
			} else {
				renderBillDetailBtnGroup({
					canRecall: false,
					canApprove: true,
					canReject: true
				});
			}

			//拒绝单据
			document.getElementById('btnReject').addEventListener('tap', function(e) {
				suspendEventBub(e);
				e.detail.gesture.preventDefault();

				var postData = {};
				mj.prompt({
					msg: '拒绝单据'
				}, function(e) {
					postData = {
						stateNote: e.value
					}
					mj.confirm({
						msg: '确认拒绝此单据？'
					}, function() {
						doBillActionReject(billRejectUrl, postData, this, function() {
							mj.refreshViewOfMine();
							mj.backAndRefresh();
						});
					})
				});
			});

			//通过单据
			document.getElementById('btnApprove').addEventListener('tap', function(e) {
				suspendEventBub(e);
				doBillActionApprove(billApproveUrl, billType, this, function() {
					mj.refreshViewOfMine();
					mj.backAndRefresh();
				});
			});

			callback && callback(true, d.changeMoney == 'Y');

		} else {

			//撤回单据
			document.querySelector('#reviewBtns').style.display = 'block';
			if (bill.currentStepIndex == 1 && bill.applier == mj.getId()) {
				renderBillDetailBtnGroup({
					canRecall: true,
					canApprove: false,
					canReject: false
				});

				bindBillActionRecall(billRecallUrl, {}, document.getElementById('btnRecall'), function() {
					mj.refreshViewOfMine();
					mj.backAndRefresh();
				});
			}

			callback && callback(false);
		}
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
		callback && callback(false);
	});
}

function checkEditAction(bill, billType, callback) {
	var billTypeName = getBillNameByType(billType);
	var billUploadUrl = MJ_URL.BILL_A_UP.mjFormat(billTypeName, billId);
	var billDeleteUrl = MJ_URL.BILL_A_DEL.mjFormat(billTypeName, billId);

	//未上报状态
	if (mj.getId() == bill.applier && BILL_STATUS_CREATED == bill.status) {
		document.getElementById('editBtns').style.display = 'block';
		document.getElementById('editBtns').classList.remove('bill-status-rejected');
		document.getElementById('editBtns').classList.add('bill-status-create');
		document.getElementById('btnUpload').style.display = 'block';
		//上报单据
		document.getElementById('btnUpload').addEventListener('tap', function(e) {
			suspendEventBub(e);

			doBillActionUpload(billUploadUrl, {}, this, function() {
				mj.reload(true);
			});
		});
	}

	//已拒绝状态
	if (mj.getId() == bill.applier && BILL_STATUS_REJECTED == bill.status) {
		document.getElementById('editBtns').classList.remove('bill-status-create');
		document.getElementById('editBtns').classList.add('bill-status-rejected');
	}

	//删除单据
	if (mj.getId() == bill.applier && (BILL_STATUS_CREATED == bill.status || BILL_STATUS_REJECTED == bill.status)) {
		document.getElementById('editBtns').style.display = 'block';
		document.getElementById('btnDelete').addEventListener('tap', function(e) {
			suspendEventBub(e);

			mj.confirm({
				msg: '确认删除此单据？'
			}, function() {
				doBillActionDelete(billDeleteUrl, {}, this, function() {
					mj.hideLoading();
					mj.backAndRefresh();
				});
			})
		});

		//编辑单据
		switch (Number(billType)) {
			case BILL_TYPE_SUPPLIER_PAY:
			case BILL_TYPE_SUPPLIER_PREPAY:
			case BILL_TYPE_COLLECTION:
			case BILL_TYPE_MATERIAL_REQ:
			case BILL_TYPE_REPAYMENT:
			case BILL_TYPE_SALE:
			case BILL_TYPE_SUPPLIER_ASSET:
			case BILL_TYPE_SUPPLIER_PAY_GOODS:
			case BILL_TYPE_TRAVEL:
				document.getElementById('btnEdit').addEventListener('tap', function() {
					showEditViewFromDetail(billId, doShowBillEditView(billType));
				});
				break;
			case BILL_TYPE_ACCRUED:
			case BILL_TYPE_BANK_DEDUCTION:
			case BILL_TYPE_DEPRECIATION:
			case BILL_TYPE_SUPER:
			case BILL_TYPE_BUDGET_COLLECT:
			case BILL_TYPE_BUDGET_PAY:
			case BILL_TYPE_TRANSFER:
			default:
				break;
		}
	}
}

//单据审核修改单据明细
function checkFeeMapApproveInfo(feeMap, feeClms, callback) {
	var subBillId, subBill;
	var subBills = [];
	var checkReviewChangeCondition = window.hasOwnProperty('checkReviewChangePer') && checkReviewChangePer;
	for (var key in feeMap) {
		subBillId = feeMap[key].id;
		subBill = {
			billId: subBillId
		};

		if (has_bill_tax_change_permission || checkReviewChangeCondition) {
			if (feeClms.expense) {
				subBill.expense = feeMap[key].expense;
			}

			if (feeClms.taxExpense) {
				subBill.taxExpense = feeMap[key].taxExpense;
			}

			if (feeClms.taxEaId) {
				subBill.taxEaId = feeMap[key].taxEaId;
			}

			if (feeClms.eaId) {
				subBill.eaId = feeMap[key].eaId;
			}

			if (feeClms.cashFlowId && window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable) {
				subBill.cashFlowId = feeMap[key].cashFlowId;
			}

			if (feeClms.toCurrencyId && window.hasOwnProperty('isToCurrency') && isToCurrency) {
				subBill.toCurrencyId = feeMap[key].toCurrencyId;
			}

			if (feeClms.collectTime && window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
				subBill.collectTime = feeMap[key].collectTime;
			}

			if (feeClms.budget) {
				subBill.budget = feeMap[key].budget;
			}
		}

		if (has_bill_dm1_change_permission) {
			if (feeMap[key].hasOwnProperty('dm1')) subBill.dm1 = feeMap[key].dm1;
			if (feeMap[key].hasOwnProperty('dm1Id')) subBill.dm1Id = feeMap[key].dm1Id;
		}

		if (has_bill_dm2_change_permission) {
			if (feeMap[key].hasOwnProperty('dm2')) subBill.dm2 = feeMap[key].dm2;
			if (feeMap[key].hasOwnProperty('dm2Id')) subBill.dm2Id = feeMap[key].dm2Id;
		}

		if (has_bill_dm3_change_permission) {
			if (feeMap[key].hasOwnProperty('dm3')) subBill.dm3 = feeMap[key].dm3;
			if (feeMap[key].hasOwnProperty('dm3Id')) subBill.dm3Id = feeMap[key].dm3Id;
		}

		if (has_bill_dm4_change_permission) {
			if (feeMap[key].hasOwnProperty('dm4')) subBill.dm4 = feeMap[key].dm4;
			if (feeMap[key].hasOwnProperty('dm4Id')) subBill.dm4Id = feeMap[key].dm4Id;
		}

		if (has_bill_dm5_change_permission) {
			if (feeMap[key].hasOwnProperty('dm5')) subBill.dm5 = feeMap[key].dm5;
			if (feeMap[key].hasOwnProperty('dm5Id')) subBill.dm5Id = feeMap[key].dm5Id;
		}

		subBills.push(subBill);
	}

	callback && callback(subBills);
}

function checkApproveInfo() {
	var postData = {};
	checkFeeMapApproveInfo(feeMap, feeClms, function(subBills) {
		postData.subBills = subBills;

		if (window.hasOwnProperty('billBizTypeInt')) {
			postData.bizTypeInt = billBizTypeInt;
		}
	});

	return postData;
}

//验证单据信息
function checkBillModel(postData, postItem, billFor, billType) {
	var billValid = true;
	var validMsg = '';
	mui.each(postItem, function(index, item) {
		switch (item) {
			case 'eaId':
				if (!(postData[item] > 0)) {
					billValid = false;
					switch (billType) {
						case BILL_TYPE_SUPPLIER_PREPAY:
							validMsg = '请选择预付类型';
							break;
						case BILL_TYPE_SUPPLIER_PAY_GOODS:
							validMsg = '请选择应付类型';
							break;
						case BILL_TYPE_SALE:
							validMsg = '请选择借方科目';
							break;
						default:
							validMsg = '请选择单据科目';
							break;
					}
					return false;
				}
				break;
			case 'cashFlowId':
				if (!(postData[item] > 0)) {
					if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable && billEaTypeInt && billEaTypeInt ==
						EA_TYPE_ASSET_CASH) {
						billValid = false;
						validMsg = '请选择现金流量项目';
						return false;
					}
				}
				break;
			case 'departmentId':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = '请选择申请部门';
					return false;
				}
				break;
			case 'owner':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = '请选择申请人';
					return false;
				}
				break;
			case 'payTypeInt':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = billType && billType == BILL_TYPE_REPAYMENT ? '请选择还款方式' : '请选择支付方式';
					return false;
				}
				break;
			case 'payCurrencyId':
				if (!(postData[item] >= 0)) {
					billValid = false;
					validMsg = '请选择币别';
					return false;
				}
				break;
			case 'projectId':
				if (billFor == EXPENSE_BELONG_PROJECT && !(postData[item] > 0)) {
					billValid = false;
					validMsg = '请选择项目';
					return false;
				}
				break;
			case 'payTargetInt':
				if (!(postData[item] > 0)) {
					billValid = false;
					if (billType) {
						switch (billType) {
							case BILL_TYPE_COLLECTION:
								validMsg = '请选择收款对象';
								break;
							case BILL_TYPE_REPAYMENT:
								validMsg = '请选择还款对象';
								break;
							default:
								validMsg = '请选择付款对象';
								break;
						}
					}
					return false;
				}
				break;
			case 'supplierId':
			case 'customerId':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = '请选择供应商';
					return false;
				}
				break;
			case 'consumerId':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = '请选择客户';
					return false;
				}
				break;
			case 'receiveId':
				if (!(postData[item] > 0)) {
					billValid = false;
					validMsg = billType && billType == BILL_TYPE_BANK_DEDUCTION ? '请选择公司付款帐号' : '请选择银行账号';
					return false;
				}
				break;
			case 'receiveNum':
				if (postData[item] == '') {
					billValid = false;
					validMsg = billType && billType == BILL_TYPE_BANK_DEDUCTION ? '请选择公司付款帐号' : '请选择银行账号';
					return false;
				}
				break;
			case 'budgetTime':
				if (postData[item] == '') {
					billValid = false;
					validMsg = '请输入填单日期';
					return false;
				}
				break;
			case 'requireTime':
				if (postData[item] == '') {
					billValid = false;
					validMsg = '请输入需求日期';
					return false;
				}
				break;
			case 'endTime':
				if (postData[item] == '') {
					billValid = false;
					validMsg = '请输入预计报销日期';
					return false;
				}
				break;
			case 'expense':
				if (postData[item] == '' || isNaN(postData[item])) {
					billValid = false;
					validMsg = '请输入正确的金额';
					return false;
				}
				break;
			case 'note':
				if (postData[item] == '') {
					billValid = false;
					validMsg = '请输入摘要';
					return false;
				}
				break;
			case 'paperNum':
				if (postData[item] == '' || isNaN(postData[item])) {
					billValid = false;
					validMsg = '请输入附票据张数';
					return false;
				}
				break;
			default:
				break;
		}
	});
	if (!billValid) {
		mui.toast(validMsg);
	}
	return billValid;
}
//验证费用详情信息
function checkFeeModels(checkFeeClms, subBills, feeDirect) {
	var feeValid = true;
	var validMsg = '';
	var directMsg = '';
	switch (currentBillType) {
		case BILL_TYPE_TRANSFER:
			if (feeDirect == BILL_DC_CR) {
				directMsg = '付款方';
			} else {
				directMsg = '收款方';
			}
			break;
		case BILL_TYPE_SUPER:
		case BILL_TYPE_COLLECTION:
			if (feeDirect == BILL_DC_CR) {
				directMsg = '贷方';
			} else {
				directMsg = '借方';
			}
			break;
		default:
			directMsg = '费用';
			break;
	}
	mui.each(subBills, function(index, item) {
		mui.each(item, function(index0, item0) {
			switch (index0) {
				case 'departmentId':
					if (checkFeeClms[index0]) {
						switch (currentBillType) {
							case BILL_TYPE_COLLECTION:
							case BILL_TYPE_SALE:
								if (!(item[index0] > -2)) {
									log(item[index0])
									feeValid = false;
									validMsg = '请选择{0}详情：归属部门'.mjFormat(directMsg);
									return false;
								}
								break;
							default:
								if (!(item[index0] > 0)) {
									feeValid = false;
									validMsg = '请选择{0}详情：归属部门'.mjFormat(directMsg);
									return false;
								}
								break;
						}
					}
					break;
				case 'eaId':
					if (checkFeeClms[index0]) {

						if (!(item[index0] > 0)) {
							feeValid = false;
							switch (currentBillType) {
								case BILL_TYPE_COLLECTION:
									validMsg = '请选择{0}详情：收款类型'.mjFormat(directMsg);
									break;
								case BILL_TYPE_SUPPLIER_ASSET:
									validMsg = '请选择{0}详情：资产类型'.mjFormat(directMsg);
									break;
								case BILL_TYPE_SALE:
									validMsg = '请选择{0}详情：收入类型'.mjFormat(directMsg);
									break;
								default:
									validMsg = '请选择{0}详情：会计科目'.mjFormat(directMsg);
									break;
							}
							return false;
						}
					}
					break;
				case 'cashFlowId':
					if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable) {
						if (checkFeeClms[index0] && (item['eaTypeInt'] == EA_TYPE_ASSET_CASH)) {
							if (!(item[index0] >= 0)) {
								feeValid = false;
								validMsg = '请选择{0}详情：现金流量项目'.mjFormat(directMsg);
								return false;
							}
						}
					}
					break;
				case 'toCurrencyId':
					if (window.hasOwnProperty('isToCurrency') && isToCurrency) {
						if (checkFeeClms[index0] && (item['eaTypeInt'] == EA_TYPE_ASSET_RECV)) {
							if (!(item[index0] >= 0)) {
								feeValid = false;
								validMsg = '请选择{0}详情：冲应收币别'.mjFormat(directMsg);
								return false;
							}
						}
					}
					break;
				case 'owner':
					if (checkFeeClms[index0]) {
						if (!(item[index0] > -2)) {
							feeValid = false;
							switch (currentBillType) {
								case BILL_TYPE_SALE:
									validMsg = '请选择{0}详情：业务员'.mjFormat(directMsg);
									break;
								default:
									validMsg = '请选择{0}详情：归属人'.mjFormat(directMsg);
									break;
							}
							return false;
						}
					}
					break;
				case 'projectId':
					if (checkFeeClms[index0]) {
						if (!(item[index0] > -2)) {
							feeValid = false;
							validMsg = '请选择{0}详情：关联项目'.mjFormat(directMsg);
							return false;
						}
					}
					break;
				case 'bizId':
					if (checkFeeClms[index0]) {
						if (!(item[index0] > -2)) {
							feeValid = false;
							validMsg = '请选择{0}详情：业务活动'.mjFormat(directMsg);
							return false;
						}
					}
					break;
				case 'supplierId':
				case 'customerId':
					if (checkFeeClms[index0]) {
						switch (currentBillType) {
							case BILL_TYPE_COLLECTION:
								if (window.hasOwnProperty('billPayTarget') && billPayTarget == PAY_TARGET_SUPPLIER) {
									if (!(item[index0] > -2)) {
										feeValid = false;
										validMsg = '请选择{0}详情：收款单位'.mjFormat(directMsg);
										return false;
									}
								}
								break;
							default:
								if (!(item[index0] > -2)) {
									feeValid = false;
									validMsg = '请选择{0}详情：供应商'.mjFormat(directMsg);
									return false;
								}
								break;
						}
					}
					break;
				case 'consumerId':
					if (checkFeeClms[index0]) {
						switch (currentBillType) {
							case BILL_TYPE_COLLECTION:
								if (window.hasOwnProperty('billPayTarget') && billPayTarget == PAY_TARGET_CONSUMER) {
									if (!(item[index0] > -2)) {
										feeValid = false;
										validMsg = '请选择{0}详情：收款单位'.mjFormat(directMsg);
										return false;
									}
								}
								break;
							default:
								if (!(item[index0] > -2)) {
									feeValid = false;
									validMsg = '请选择{0}详情：客户'.mjFormat(directMsg);
									return false;
								}
								break;
						}
					}
					break;
				case 'carId':
					if (checkFeeClms[index0]) {
						if (!(item[index0] > -2)) {
							feeValid = false;
							validMsg = '请选择{0}详情：车辆'.mjFormat(directMsg);
							return false;
						}
					}
					break;
				case 'cashTime':
					if (checkFeeClms[index0]) {
						if (item[index0] == '') {
							feeValid = false;
							switch (currentBillType) {
								case BILL_TYPE_COLLECTION:
									validMsg = '请选择{0}详情：银行收款日期'.mjFormat(directMsg);
									break;
								default:
									validMsg = '请选择{0}详情：扣款日期'.mjFormat(directMsg);
									break;
							}
							return false;
						}
					}
					break;
				case 'expense':
					if (checkFeeClms[index0]) {
						if (Number(item[index0]) == 0) {
							feeValid = false;
							switch (currentBillType) {
								case BILL_TYPE_SALE:
									validMsg = '请选择{0}详情：含税收入'.mjFormat(directMsg);
									break;
								case BILL_TYPE_COLLECTION:
									validMsg = '请选择{0}详情：收款金额'.mjFormat(directMsg);
									break;
								case BILL_TYPE_SUPPLIER_PAY_GOODS:
									validMsg = '请选择{0}详情：付款金额'.mjFormat(directMsg);
									break;
								default:
									validMsg = '请选择{0}详情：报销金额'.mjFormat(directMsg);
									break;
							}
							return false;
						}
					}
					break;
				default:
					break;
			}

			if (checkFeeClms['startTime'] && checkFeeClms['endTime'] && item['startTime'] && item['endTime']) {
				var startTime = new Date(item['startTime']).format('yyyy-MM-dd');
				var endTime = new Date(item['endTime']).format('yyyy-MM-dd');
				if (startTime && endTime && !validateDateRange(startTime, endTime)) {
					feeValid = false;
					validMsg = '请检查{0}详情:起止时间有误'.mjFormat(directMsg);
					return false;
				}
			}

			if (checkFeeClms['collectTime']) {
				var checkCondition = true;
				var msg = '';
				if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
					switch (currentBillType) {
						case BILL_TYPE_SALE:
							checkCondition = billEaTypeInt == EA_TYPE_ASSET_RECV;
							msg = '预计收款日期';
							break;
						case BILL_TYPE_COLLECTION:
						case BILL_TYPE_SUPER:
						default:
							checkCondition = (item['eaTypeInt'] == EA_TYPE_ASSET_RECV) || checkWindowProperty(
								'checkFeeCollectTimeEnable');
							if (feeDirect == BILL_DC_CR) {
								msg = '实际收款日期';
							} else {
								msg = '预计收款日期';
							}
							break;
					}
					if (checkFeeClms['collectTime'] && checkCondition) {
						if ((!item['collectTime']) || (item['collectTime'] == '')) {
							feeValid = false;
							validMsg = '请选择{0}详情：'.mjFormat(directMsg) + msg;
							return false;
						}
					}
				}
			}
		});
	});

	if (!feeValid) {
		mui.toast(validMsg);
	}

	return feeValid;

}

//验证贷方信息
function checkCrFeeModels(subCrs) {
	var crFeeValid = true;
	var validMsg = '';
	mui.each(subCrs, function(index, item) {
		mui.each(item, function(index0, item0) {
			switch (index0) {
				case 'eaId':
					if (!(item[index0] > 0)) {
						crFeeValid = false;
						validMsg = '请选择贷方费用详情：会计科目';
						return false;
					}
					break;
				case 'expense':
					if (Number(item[index0]) == 0) {
						crFeeValid = false;
						validMsg = '请选择贷方费用详情：金额';
						return false;
					}
					break;
				default:
					break;
			}
		});
	});

	if (!crFeeValid) {
		mui.toast(validMsg);
	}

	return crFeeValid;
}

//关联借款单的还款金额输入框
function initLoanInput(currentBillType) {
	var $loansList = mui('#loansList')
	var $loansWrapper = mui('#loansWrapper');
	$loansList.on('tap', '.mui-checkbox', function() {
		if (!(this.parentNode.querySelector('.paid').innerText > 0)) {
			mj.alert('借款单还款金额必须大于0才能被选中');
		}
	});

	$loansList.on('change', 'input[name="loans"]', function() {
		calcBillExpenseTotal(currentBillType);
	});

	$loansWrapper.on('tap', '.edit-loan-paid', function(e) {
		e.detail.gesture.preventDefault();
		var paidElem = this.querySelector('.paid');
		var adjustPaidElem = this.querySelector('.adjust-paid');
		var payBeforeValue = Number(this.parentNode.querySelector('.pay-before').innerText);
		var payCurrencyRate = Number(this.parentNode.getAttribute('lrate'));
		var checkBoxElem = this.parentNode.querySelector('input[name="loans"]');
		var convertPay = 0;
		mui.prompt('请输入还款金额：<br>汇率:' + payCurrencyRate, '', '', ['取消', '确定'], function(e) {
			if (e.index == 1) {
				var inputPaid = e.value;
				if (!(inputPaid > 0)) {
					mui.toast('还款金额输入有误');
					return false;
				}
				if (inputPaid > payBeforeValue) {
					mui.toast('还款金额不能大于借款金额');
					return false;
				}
				inputPaid = Number(inputPaid).toFixed(2);
				convertPay = inputPaid * payCurrencyRate;
				paidElem.innerText = inputPaid;
				adjustPaidElem.innerText = '折:' + Number(convertPay).toFixed(2);
				checkBoxElem.removeAttribute('disabled');
				checkBoxElem.checked = true;
				calcBillExpenseTotal(currentBillType);
			}
		}, 'div');
		document.querySelector('.mui-popup-input input').type = 'number';
	});
}

function changeLoanHandler(parameters, callback) {
	parameters = parameters || {};
	var loanWrapperId = parameters.loansShowId;
	var currentBillType = parameters.currentBillType;
	var billFor = parameters.billFor;
	var budgetTime = parameters.budgetTime;
	var account = parameters.accountId;
	var owner = parameters.userId;
	var payCurrency = parameters.payCurrencyId;

	resetLoans(currentBillType);

	if (owner == -1 || payCurrency == -1) {
		return;
	}

	var params = {
		userId: owner,
		budgetTime: new Date(budgetTime).format('yyyy-MM-dd'),
		billFor: billFor,
		accountId: account,
		payCurrencyId: payCurrency
	};
	mjQueryUserLoans(params, function(data) {
		document.getElementById(loanWrapperId).innerHTML = generateLoadLoans(data);
		callback && callback();
	});
}

//供应商预付款单
function changePrepayHandler(parameters, callback) {
	parameters = parameters || {};
	var prepayWrapperId = parameters.loansShowId;
	var currentBillType = parameters.currentBillType;
	var billFor = parameters.billFor;
	var budgetTime = parameters.budgetTime;
	var account = parameters.accountId;
	var owner = parameters.userId;
	var customer = parameters.supplierId;
	var consumer = parameters.consumerId;
	var payCurrency = parameters.payCurrencyId;

	resetLoans(currentBillType);

	if (owner == -1 || payCurrency == -1 || (customer == -1 && consumer == -1)) {
		return;
	}

	var params = {
		budgetTime: new Date(budgetTime).format('yyyy-MM-dd'),
		userId: owner,
		billFor: billFor,
		accountId: account,
		supplierId: customer,
		consumerId: consumer,
		payCurrencyId: payCurrency
	};

	mjQueryCustomerPrepays(params, function(data) {
		document.getElementById(prepayWrapperId).innerHTML = generateLoadLoans(data);
		callback && callback();
	});
}

//更新冲抵借款单
function changeMergeBillLoanHandler(opt, callback) {
	opt = opt || {};
	var loansShowId = opt.loansShowId;
	var currentBillType = opt.currentBillType;
	var budgetTime = opt.budgetTime;
	var billFor = opt.billFor;
	var account = opt.account;
	var payTarget = opt.payTarget;
	var payCurrency = opt.payCurrency;
	var owner = opt.owner;
	var customer = opt.customer;
	var consumer = opt.consumer;

	if (!budgetTime || budgetTime == '') {
		resetLoans(currentBillType);
		return;
	}

	switch (Number(payTarget)) {
		case PAY_TARGET_USER:
			resetLoans(currentBillType);
			changeLoanHandler({
				loansShowId: loansShowId,
				currentBillType: currentBillType,
				budgetTime: budgetTime,
				billFor: billFor,
				accountId: account,
				userId: owner,
				payCurrencyId: payCurrency
			}, callback);
			break;

		case PAY_TARGET_SUPPLIER:
		case PAY_TARGET_CONSUMER:
			resetLoans(currentBillType);
			changePrepayHandler({
				loansShowId: loansShowId,
				currentBillType: currentBillType,
				budgetTime: budgetTime,
				billFor: billFor,
				accountId: account,
				userId: owner,
				supplierId: customer,
				consumerId: consumer,
				payCurrencyId: payCurrency
			}, callback);
			break;

		default:
			resetLoans(currentBillType);
			break;
	}
}

//重置冲抵借款单信息
function resetLoans(currentBillType) {
	document.getElementById('loansList').innerHTML = '';
	mui('#loansWrapper input[name="loans"]').each(function(index) {
		this.checked = false;
	});
	calcBillExpenseTotal(currentBillType);
}

function queryBillLoansForEdit(billId, callback) {
	mj.get(MJ_URL.BILL_F_EDIT_LOANS.mjFormat(billId), {}, function(d) {
		callback && callback(d);
	}, function() {});
}

function queryBillPrepaysForEdit(billId, callback) {
	mj.get(MJ_URL.BILL_F_EDIT_PREPAYS.mjFormat(billId), {}, function(d) {
		callback && callback(d);
	}, function() {});
}

function queryMergeBillLoansForEditHandler(payTarget, billId, callback) {
	switch (Number(payTarget)) {
		case PAY_TARGET_USER:
			queryBillLoansForEdit(billId, callback);
			break;
		case PAY_TARGET_SUPPLIER:
		case PAY_TARGET_CONSUMER:
			queryBillPrepaysForEdit(billId, callback);
			break;
		default:
			callback && callback();
			return;
	}
}

//计算应付款和总金额
function calcBillExpenseTotal(currentBillType) {
	switch (currentBillType) {
		case BILL_TYPE_REPAYMENT:
			calcBillExpenseTotalForRepayment();
			break;
		case BILL_TYPE_MATERIAL_REQ:
		case BILL_TYPE_SALE:
		case BILL_TYPE_COLLECTION:
		case BILL_TYPE_SUPPLIER_PAY_GOODS:
		case BILL_TYPE_BUDGET_COLLECT:
		case BILL_TYPE_BUDGET_PAY:
			calcBillExpenseTotalForFeeDetails();
			break;
		default:
			calcBillExpenseTotalNormal();
			break;
	}
}

function calcBillExpenseTotalNormal() {
	//计算借款金额总数
	var feeTotal = 0,
		loanTotal = 0;
	var feeItem;
	for (var key in feeMap) {
		feeItem = feeMap[key];
		feeTotal += Number(feeItem.expense);
	}

	mui('#loansWrapper input[name="loans"]').each(function(index) {
		if (this.checked) {
			loanTotal += Number(this.parentNode.nextElementSibling.querySelector('.adjust-paid').innerText.replace(/[^\d.]/g,
				""));
		}
	});
	document.getElementById('totalExpense').value = Number(feeTotal).toFixed(2);
	document.getElementById('totalExpenseCapital').innerText = Number(feeTotal).toFixed(2).toCapitalMoney();
	document.getElementById('totalPaid').innerText = (feeTotal - loanTotal).toFixed(2);
}

function calcBillExpenseTotalForRepayment() {
	var loanTotal = 0;
	mui('#loansWrapper input[name="loans"]').each(function(index) {
		if (this.checked) {
			loanTotal += Number(this.parentNode.nextElementSibling.querySelector('.adjust-paid').innerText.replace(/[^\d.]/g,
				""));
		}
	});

	document.getElementById('totalExpense').value = Number(loanTotal).toFixed(2);
	document.getElementById('totalExpenseCapital').innerText = Number(loanTotal).toFixed(2).toCapitalMoney();
}

function calcBillExpenseTotalForFeeDetails() {
	var feeTotal = 0;
	var feeItem;
	for (var key in feeMap) {
		feeItem = feeMap[key];
		feeTotal += Number(feeItem.expense);
	}
	document.getElementById('totalExpense').value = Number(feeTotal).toFixed(2);
	document.getElementById('totalExpenseCapital').innerText = Number(feeTotal).toFixed(2).toCapitalMoney();
}

function calcBillExpenseTotalForCrFeeDetails() {
	var crFeeTotal = 0;
	var crFeeItem;
	for (var key in crFeeMap) {
		crFeeItem = crFeeMap[key];
		crFeeTotal += Number(crFeeItem.expense);
	}

	document.getElementById('crTotalExpense').value = Number(crFeeTotal).toFixed(2);
	document.getElementById('crTotalExpenseCapital').innerText = Number(crFeeTotal).toFixed(2).toCapitalMoney();
}

function calcBillExpenseTotalForCustomFeeDetails() {
	var customFeeTotal = 0;
	var customFeeItem;
	for (var key in customFeeMap) {
		customFeeItem = customFeeMap[key];
		customFeeTotal += Number(customFeeItem.expense);
	}

	document.getElementById('totalCustomExpense').value = Number(customFeeTotal).toFixed(2);
	document.getElementById('totalCustomExpenseCapital').innerText = Number(customFeeTotal).toFixed(2).toCapitalMoney();
}

//单据详情页操作
function doBillAction(url, param, callback, fail) {
	mj.post(url, param, function(collection, response, options) {
		callback && callback(response);
	}, function(xhr, type, e) {
		fail && fail(xhr);
	});
}

//详情页按钮
function renderBillDetailBtnGroup(opt) {
	opt = opt || {};
	var canRecall = opt.canRecall || false;
	var canApprove = opt.canApprove || false;
	var canReject = opt.canReject || false;
	if (canRecall && !canApprove && !canReject) {
		document.querySelector('#btnRecall').style.display = 'block';
		document.querySelector('#btnRecall').style.width = '100%';
	} else if (!canRecall && canApprove && canReject) {
		document.querySelector('#btnReject').style.display = 'block';
		document.querySelector('#btnApprove').style.display = 'block';
		document.querySelector('#btnReject').style.width = '50%';
		document.querySelector('#btnApprove').style.width = '50%';
	} else if (canRecall && canApprove && canReject) {
		document.querySelector('#btnReject').style.display = 'block';
		document.querySelector('#btnApprove').style.display = 'block';
		document.querySelector('#btnRecall').style.display = 'block';
		document.querySelector('#btnReject').style.width = '33.33%';
		document.querySelector('#btnApprove').style.width = '33.33%';
		document.querySelector('#btnRecall').style.width = '33.33%';
	}
}

//撤回单据
function bindBillActionRecall(url, data, $btn, callback) {
	$btn.addEventListener('tap', function(e) {
		suspendEventBub(e);

		mj.confirm({
			msg: '确认撤回此单据？'
		}, function() {
			mj.showLoading();
			mj.disableBtn($btn);
			doBillAction(url, data,
				function(response) {
					mui.toast('单据已撤回');
					mj.hideLoading();
					callback && callback();
				},
				function(response) {
					showResult(response, LOST_NETWORK_CONNECTION);
					mj.hideLoading();
				}
			);
		});
	})
}

//通过单据
function doBillActionApprove(url, billType, $btn, callback) {
	mj.showLoading();
	mj.disableBtn($btn);

	var postData = {};
	switch (Number(billType)) {
		case BILL_TYPE_SUPER:
			postData = checkSuperBillApproveInfo();
			break;
		case BILL_TYPE_SUPPLIER_PAY_GOODS:
			postData = checkApproveInfo();
			postData.eaId = selectedEaId;
			break;
		case BILL_TYPE_SUPPLIER_PREPAY:
			postData = {
				eaId: selectedEaId,
				expense: document.getElementById('totalExpenseInput').value
			}
			break;
		case BILL_TYPE_COLLECTION:
			postData = checkCollectionBillApproveInfo();
			break;
		case BILL_TYPE_REPAYMENT:
			postData = {};
			break;
		case BILL_TYPE_SALE:
			postData.eaId = selectedDrEaId;
			if (isCashFlowEnable) {
				if (billEaTypeInt && billEaTypeInt == EA_TYPE_ASSET_CASH && selectedCashFlow == -1) {
					mui.toast('请选择现金流量项目');
					return false;
				}

				postData.cashFlowId = selectedCashFlow;
				postData.cashFlowName = selectedCashFlowName;
			}
			checkFeeMapApproveInfo(feeMap, feeClms, function(subCrs) {
				postData.subCrs = subCrs;
			});
			break;
		case BILL_TYPE_TRANSFER:
			postData = checkTransferBillApproveInfo();
			break;
		default:
			postData = checkApproveInfo();
			break;
	}

	var objBillPaperNumReview = document.getElementById('billPaperNumInput');
	if (objBillPaperNumReview) {
		postData.paperNum = objBillPaperNumReview.value;
	}

	doBillAction(url, postData,
		function(response) {
			mui.toast('单据已通过');
			mj.hideLoading();
			mj.backAndRefresh();
			callback && callback();
		},
		function(response) {
			mj.enableBtn($btn);
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

//保存单据
function doBillActionCreate(btnSave, btnSaveAndUpload, postData, billType) {
	var invoiceIds = [];
	if (checkWindowProperty('billInvoiceMap')) {
		for (var key in billInvoiceMap) {
			invoiceIds.push(billInvoiceMap[key].id);
		}
	}
	postData.invoices = invoiceIds;
	var billTypeName = getBillNameByType(billType);
	var url = MJ_URL.BILL_API.mjFormat(billTypeName);
	mj.disableBtn(btnSave);
	mj.disableBtn(btnSaveAndUpload);
	mj.post(url, postData, function() {
		mui.toast(mj.getBillName(billType) + '申请成功');
		mj.backWithoutCustomize();
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
		mj.hideLoading();
		mj.enableBtn(btnSave);
		mj.enableBtn(btnSaveAndUpload);
	});
}

//更新单据
function doBillActionUpdate(btnSave, btnSaveAndUpload, postData, billId, billType) {
	var billTypeName = getBillNameByType(billType);
	var url = MJ_URL.BILL_A_UPDATE.mjFormat(billTypeName, billId);
	mj.disableBtn(btnSave);
	mj.disableBtn(btnSaveAndUpload);
	mj.post(url, postData, function() {
		mui.toast(mj.getBillName(billType) + '更新成功');
		mj.refreshViewOfMine();
		mj.backAndRefreshWithoutCustomize();
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
		mj.hideLoading();
		mj.enableBtn(btnSave);
		mj.enableBtn(btnSaveAndUpload);
	});
}

//拒绝单据
function doBillActionReject(url, data, $btn, callback) {
	mj.showLoading();
	doBillAction(url, data,
		function(response) {
			mui.toast('单据已拒绝');
			mj.hideLoading();
			mj.backAndRefresh();
			callback && callback();
		},
		function(response) {
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

//单据上报
function doBillActionUpload(url, data, $btn, callback) {
	mj.showLoading();
	mj.disableBtn($btn);
	doBillAction(url, data,
		function(response) {
			mui.toast('单据已提交');
			mj.hideLoading();
			mj.backAndRefresh();
			callback && callback();
		},
		function(response) {
			mj.enableBtn($btn);
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

//单据删除
function doBillActionDelete(url, data, $btn, callback) {
	mj.showLoading();
	doBillAction(url, data,
		function(response) {
			mui.toast('单据已删除');
			mj.refreshViewOfMine();
			mj.backAndRefresh();
			callback && callback();
		},
		function(response) {
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

//修改现金流量项目
function doBillActionUpdateCashFlowAfterReview(billId, cashFlowPosition, curChangeId, newCashFlowId, callback) {
	var postUrl = '';
	var billTypeName = getBillNameByType(currentBillType);
	switch (cashFlowPosition) {
		case BILL_DETAIL_POSITION:
			postUrl = MJ_URL.BILL_A_BILL_CASH_FLOW.mjFormat(billTypeName, billId);
			break;
		case BILL_FEE_POSITION:
			postUrl = MJ_URL.BILL_A_FEE_CASH_FLOW.mjFormat(billTypeName, billId, curChangeId);
			break;
		case BILL_PAYINFO_POSITION:
			postUrl = MJ_URL.BILL_A_PAY_CASH_FLOW.mjFormat(billTypeName, billId, curChangeId);
			break;
		default:
			break;
	}
	var postData = {
		cashFlowId: newCashFlowId
	}

	mj.showLoading();
	doBillAction(postUrl, postData,
		function(response) {
			mui.toast('更新现金流量项目成功');
			mj.hideLoading();
			callback && callback();
		},
		function(response) {
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

function doBillActionUpdateToCurrencyAfterReview(newToCurrencyId, curChangeId, callback) {
	var billTypeName = getBillNameByType(currentBillType);
	var postUrl = MJ_URL.BILL_A_TO_CURRENCY.mjFormat(billTypeName, curChangeId);
	var postData = {
		toCurrencyId: newToCurrencyId
	}
	mj.showLoading();
	doBillAction(postUrl, postData,
		function(response) {
			mui.toast('更新冲应收币别成功');
			mj.hideLoading();
			callback && callback();
		},
		function(response) {
			showResult(response, LOST_NETWORK_CONNECTION);
			mj.hideLoading();
		}
	);
}

function showBillAccountSelect(options, callback) {
	var relatedAccount = options.showRelatedAccount;

	document.getElementById('billAccountSelectWrapper').style.display = 'block';
	initAccountBook({
		accountTapId: 'btnShowAccountSelectModal',
		accountShowId: 'selectedAccountName',
		title: '请选择帐套',
		showAll: false,
		showRelatedAccount: function() {
			var isSwitchActive = document.getElementById("showAllAccountSwitch").classList.contains('mui-active');
			isSwitchActive = relatedAccount && !isSwitchActive;
			return isSwitchActive;
		},
	}, function(selected) {
		billAccount = selected.id;
		billAccountName = selected.name;

		callback && callback(billAccount, billAccountName);
	});
}

function checkBillTypeAction(showBillTypeSelect, dictBillTypeDefaultSelect, callback, fnfix) {
	var billPreparePopover = document.getElementById('billPreparePopover');
	var billBelongSelectWrapper = document.getElementById('billBelongSelectWrapper');
	var selectedBillFor = -1;
	if (!dictBillTypeDefaultSelect) {
		dictBillTypeDefaultSelect = "both";
	} else if ("department" == dictBillTypeDefaultSelect) {
		selectedBillFor = EXPENSE_BELONG_DEPARTMENT;
	} else if ("project" == dictBillTypeDefaultSelect) {
		selectedBillFor = EXPENSE_BELONG_PROJECT;
	} else {
		dictBillTypeDefaultSelect = "both";
	}

	if (showBillTypeSelect && dictBillTypeDefaultSelect == "both") {
		billBelongSelectWrapper.style.display = 'block';
		fnfix && fnfix();
	} else {
		if (billBelongSelectWrapper) billBelongSelectWrapper.style.display = 'none';
		if (!showBillTypeSelect) selectedBillFor = window.hasOwnProperty('billFor') ? billFor : EXPENSE_BELONG_NEUTRAL;
		callback && callback(selectedBillFor);
	}
}

function showBillPrepareSelectPopover(options) {
	options = options || {};
	var showBillTypeSelect = options.showBillTypeSelect;
	var billTypeArr = ['department','project','both'];
	var dictBillTypeDefaultSelect = (billTypeArr.indexOf(mj.getDict(BILL_DEFAULT_TYPE_SELECT)) ==-1) ? 'both' : mj.getDict(BILL_DEFAULT_TYPE_SELECT);
	var isManageAccount = true;
	var $billPreparePopover = mui('#billPreparePopover');
	var billPreparePopover = document.getElementById('billPreparePopover');
	var billBanWrapper = document.getElementById('billBanWrapper');
	var billSwicthForShowAllAccount = document.getElementById('billSwicthForShowAllAccount');
	var btnConfirmFill = document.getElementById('btnConfirmFill');

	var billSelectedAccount = mj.getAccountId() ? mj.getAccountId() : -1;
	var billSelectedAccountName = mj.getAccountName() ? mj.getAccountName() : '';
	var billShowRelatedAccount = false;

	var isSelectingUnfinished = true;

	var mask;
	mask = mui.createMask(function() {
		billPreparePopover.classList.add('mui-active');
		return !isSelectingUnfinished;
	});

	//启用多帐套
	mjQueryAllAccountBooks(function(accountBooks) {
		accountBooks = accountBooks;
		billPreparePopover.classList.add('mj-account-bill-prepare-popover');
		billPreparePopover.classList.add('mui-active');
		billPreparePopover.classList.remove('mj-show-related-account-switch');
		billSwicthForShowAllAccount.style.display = 'none';
		mask.show();
		//系统帐套配置为空
		if (accountBooks.length == 0) {
			isManageAccount = false;
			billPreparePopover.classList.remove('mj-account-bill-prepare-popover');
			billPreparePopover.classList.add('mj-ban-bill-prepare-popover');
			billBanWrapper.style.display = 'block';
		} else {
			//系统帐套配置不为空
			isManageAccount = true;
			billPreparePopover.classList.remove('mj-ban-bill-prepare-popover');
			billBanWrapper.style.display = 'none';

			if (accountBooks && accountBooks.length == 1) {
				billSelectedAccount = accountBooks[0].id;
				billSelectedAccountName = accountBooks[0].name;
			}

			if (billSelectedAccount > -1 && billSelectedAccountName != '') {
				document.getElementById('selectedAccountName').innerHTML = billSelectedAccountName;
				billPreparePopover.classList.add('mj-show-related-account-switch');
				billSwicthForShowAllAccount.style.display = 'block';
				billShowRelatedAccount = true;
			}

			showBillAccountSelect({
				showRelatedAccount: billShowRelatedAccount
			}, function(account, accountName) {
				billSelectedAccount = account;
				billSelectedAccountName = accountName;
			});

			checkBillTypeAction(showBillTypeSelect, dictBillTypeDefaultSelect, function(selectedBillFor) {
				//单据类型唯一
				billPreparePopover.classList.remove('mj-whole-bill-prepare-popover');
			}, function() {
				//多种单据类型
				billPreparePopover.classList.remove('mj-account-bill-prepare-popover');
				billPreparePopover.classList.add('mj-whole-bill-prepare-popover');
			});

		}
	});

	if (showBillTypeSelect && dictBillTypeDefaultSelect == "both") {
		$billPreparePopover.on('tap', '.bill-belong', function(e) {
			var lastActiveElem = document.querySelector('#billPreparePopover .bill-belong.selected');
			lastActiveElem && lastActiveElem.classList.remove('selected');
			e.target.classList.add('selected');
			billFor = this.getAttribute('data-pid');
		});
	}

	btnConfirmFill.addEventListener('tap', function() {
		if (!isManageAccount) {
			isSelectingUnfinished = false;
			mui.back();
			return false;
		}

		if (billSelectedAccount == -1) {
			mui.toast('请选择单据所属帐套');
			return false;
		}
		billAccount = billSelectedAccount;

		checkBillTypeAction(showBillTypeSelect, dictBillTypeDefaultSelect, function(selectedBillFor) {
			billFor = selectedBillFor;
			isSelectingUnfinished = false;
			mjBillPrepared = true;
			mask.close();
			billPreparePopover.classList.remove('mui-active');
			renderBillAccount(billSelectedAccountName);
			if (showBillTypeSelect) onSelectBillType();

		}, function() {

			if (!billFor) {
				mui.toast('请选择单据类型');
				return false;
			}

			isSelectingUnfinished = false;
			mjBillPrepared = true;
			mask.close();
			billPreparePopover.classList.remove('mui-active');
			renderBillAccount(billSelectedAccountName);
			if (showBillTypeSelect) onSelectBillType();
		});
	});
}

function renderBillAccount(accountName) {
	var selectedAccountName = accountName ? accountName : '';
	document.getElementById('billAccountCell').style.display = 'block';
	document.getElementById('billAccountName').innerHTML = selectedAccountName;
}

function onSelectBillType() {
	if (window.hasOwnProperty('billFor')) {
		document.getElementById('billBelongCell').style.display = 'block';
		if (billFor && billFor > 0) document.getElementById('billBelong').innerText = ExpenseBelongEnum[billFor];
		if (billFor == EXPENSE_BELONG_PROJECT) {
			var billProjectCell = document.getElementById('billProjectCell');
			if (billProjectCell) billProjectCell.style.display = 'block';
		}
	}
}

function renderCustomerSelect(selector, payTarget, callback) {
	var objCustomerText = document.getElementById(selector);
	switch (Number(payTarget)) {
		case PAY_TARGET_SUPPLIER:
		case PAY_TARGET_CONSUMER:
			objCustomerText.style.color = "#000";
			break;
		case PAY_TARGET_USER:
		default:
			objCustomerText.style.color = "#999";
			break;
	}
	callback && callback();
}

//扩展字段
function getBillConfFeeDms(dm, data, callback) {
	var showInput = false;
	var showSelect = false;
	var feeDms = {};
	if (data.hasOwnProperty(dm) && data[dm].hasOwnProperty('t')) {
		switch (data[dm]['t']) {
			case 'input':
				showInput = true;
				showSelect = false;
				break;
			case 'select':
				feeDms = data[dm]['data'];
				showInput = false;
				showSelect = true;
				break;
			default:
				break;
		}
	}
	callback && callback(showInput, showSelect, feeDms);
}

//单据明细时间
function initFeeDayDp(tapClass, showClass, tapCallback, showCallback) {
	var timeSelects = mui(tapClass);
	timeSelects.each(function(i, timeSelect) {
		timeSelect.addEventListener('tap', function() {
			//点击事件回调
			if ((tapCallback != undefined) && !tapCallback()) {
				return false;
			}

			var objLi = this;
			var objTime = objLi.querySelector(showClass);
			var optionsJson = {
				type: "date",
				value: objTime.innerText,
				beginYear: 2010
			};
			var picker = new mui.DtPicker(optionsJson);
			picker.show(function(rs) {
				objTime.innerText = rs.text;
				picker.dispose();
				//显示时间回调
				showCallback && showCallback();
			});
		}, false);
	});
}

//单据明细扣款日期时间/开始时间/结束时间
function initFeeDayDtPicker() {
	initFeeDayDp('.fee-time-select', '.selected-fee-time', undefined, undefined);
}

//单据明细预计/实际收款日期
function checkCollectTimeDtPicker() {
	var timeSelectValid = true;
	if (window.hasOwnProperty('currentBillType') && window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
		switch (currentBillType) {
			case BILL_TYPE_SALE:
				if (window.hasOwnProperty('billEaTypeInt') && (billEaTypeInt != EA_TYPE_ASSET_RECV)) {
					mui.toast('请单据级别选择科目属性是资产类应收账款的借方科目');
					timeSelectValid = false;
				}
				break;
			case BILL_TYPE_SUPER:
				if (window.hasOwnProperty('currentBillDc')) {
					switch (Number(currentBillDc)) {
						case BILL_DC_DR:
							if (window.hasOwnProperty('drFeeMap') && window.hasOwnProperty('currentBillFeeId') && (drFeeMap[currentBillFeeId]
									.eaTypeInt != EA_TYPE_ASSET_RECV)) {
								mui.toast('请选择科目属性是资产类应收账款的会计科目');
								timeSelectValid = false;
							}
							break;
						case BILL_DC_CR:
						default:
							if (window.hasOwnProperty('crFeeMap') && window.hasOwnProperty('currentBillFeeId') && (crFeeMap[currentBillFeeId]
									.eaTypeInt != EA_TYPE_ASSET_RECV)) {
								mui.toast('请选择科目属性是资产类应收账款的会计科目');
								timeSelectValid = false;
							}
							break;
					}
				}
				break;
			default:
				if (window.hasOwnProperty('checkFeeCollectTimeEnable')) {
					timeSelectValid = true;
				}
				break;
		}
	}
	return timeSelectValid;
}


function initCollectTimeDtPicker() {
	initFeeDayDp('.fee-collect-time-cell', '.selected-fee-collect-time', function() {
		return checkCollectTimeDtPicker();
	});
}

function initChangeCollectTimeInReview(opt, callback) {
	opt = opt || {};
	var $feePageId = opt.feePageId;
	var collectTimeTapId = opt.collectTimeTapId;
	var defaultCollectTime = '';
	mui($feePageId).on('tap', '#' + collectTimeTapId, function() {
		if (!checkCollectTimeDtPicker()) {
			return false;
		}

		if (window.hasOwnProperty('currentBillType')) {
			switch (Number(currentBillType)) {
				case BILL_TYPE_SALE:
				case BILL_TYPE_COLLECTION:
					if (window.hasOwnProperty('currentFee') && (currentFee.collectTime != '')) {
						defaultCollectTime = currentFee.collectTime;
					} else {
						defaultCollectTime = '';
					}
					break;
				case BILL_TYPE_SUPER:
					if (window.hasOwnProperty('currentBillDc')) {
						switch (Number(currentBillDc)) {
							case BILL_DC_DR:
								if (window.hasOwnProperty('drFeeMap') && window.hasOwnProperty('currentBillFeeId') && (drFeeMap[
										currentBillFeeId].collectTime != '')) {
									defaultCollectTime = drFeeMap[currentBillFeeId].collectTime;
								} else {
									defaultCollectTime = '';
								}
								break;
							case BILL_DC_CR:
							default:
								if (window.hasOwnProperty('crFeeMap') && window.hasOwnProperty('currentBillFeeId') && (crFeeMap[
										currentBillFeeId].collectTime != '')) {
									defaultCollectTime = crFeeMap[currentBillFeeId].collectTime;
								} else {
									defaultCollectTime = '';
								}
								break;
						}
					}
					break;
				default:
					defaultCollectTime = '';
					break;
			}
		}

		if (defaultCollectTime && defaultCollectTime != '') {
			defaultCollectTime = new Date(defaultCollectTime).format('yyyy-MM-dd');
		} else {
			defaultCollectTime = new Date().format('yyyy-MM-dd');
		}

		var optionsJson = {
			type: "date",
			value: defaultCollectTime
		};

		var picker = new mui.DtPicker(optionsJson);
		picker.show(function(rs) {
			picker.dispose();
			callback && callback(rs);
		});
	}, false);
}

//common
//切换审批流程&操作记录
function sliderRenderActiveTab(billId, data, callback) {
	document.getElementById('slider').addEventListener('slide', function(e) {
		if (e.detail.slideNumber === 1) {
			if (billProcessActive) {
				return;
			}
			billProcessActive = true;
			renderBillProcess(objBillProcessContent, billId, data, billProcessActive);
		} else if (e.detail.slideNumber === 3) {
			if (billActionActive) {
				return;
			}
			billActionActive = true;
			renderBillActions(objBillActionContent, data.billId, data.billTypeInt);

		}
	});
}

//编辑按钮跳转
function doShowBillEditView(billType) {
	switch (Number(billType)) {
		case BILL_TYPE_REPAYMENT:
			href = 'repayment_bill_edit_temp.html';
			break;
		case BILL_TYPE_TRAVEL:
			href = 'travel_bill_edit_temp.html';
			break;
		case BILL_TYPE_SUPPLIER_PREPAY:
			href = 'supplier_prepay_bill_edit_temp.html';
			break;
		case BILL_TYPE_SUPPLIER_PAY:
			href = 'supplier_pay_bill_edit_temp.html';
			break;
		case BILL_TYPE_SUPPLIER_ASSET:
			href = 'supplier_asset_bill_edit_temp.html';
			break;
		case BILL_TYPE_SUPPLIER_PAY_GOODS:
			href = 'supplier_pay_goods_bill_edit_temp.html';
			break;
		case BILL_TYPE_MATERIAL_REQ:
			href = 'material_req_bill_edit_temp.html';
			break;
		case BILL_TYPE_SALE:
			href = 'sale_bill_edit_temp.html';
			break;
		case BILL_TYPE_COLLECTION:
			href = 'collection_bill_edit_temp.html';
			break;
		case BILL_TYPE_BANK_DEDUCTION:
		case BILL_TYPE_DEPRECIATION:
		case BILL_TYPE_ACCRUED:
		case BILL_TYPE_SUPER:
		case BILL_TYPE_TRANSFER:
		default:
			break;
	}

	return href;
}

function showEditViewFromDetail(billId, editUrl) {
	pushWebView({
		webType: 'newWebview_Third',
		id: editUrl,
		href: 'views/bill/' + editUrl,
		aniShow: 'slide-in-right',
		title: "单据编辑",
		isBars: false,
		barsIcon: '',
		extendOptions: {
			noCache: true,
			billId: billId
		}
	})
}

//单据回复
//获取回复列表
function mjQueryBillRepliy(billId, callback) {
	mj.get(MJ_URL.BILL_F_REPLY.mjFormat(billId), {}, function(data) {
		callback && callback(data);
	}, function(xhr) {
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

function checkBillRepliesAction(billId, bill) {
	var objReplyWrapper = document.getElementById('replyListWrapper');

	if (bill.status == BILL_STATUS_CREATED) {
		objReplyWrapper.style.display = 'none';
		return false;
	}
	objReplyWrapper.style.display = 'block';
	mjQueryBillRepliy(billId, function(o) {
		if (o && o.status == SYSTEM_SUCCEED) {
			var billReplyLength = o.data.length;
			if (billReplyLength > 0) {
				var listHtml = generateBillReplyList(o.data);
				document.getElementById('replyList').innerHTML = listHtml;
				document.getElementById('billReplyNum').innerText = billReplyLength;
			}

			bindBillReplyAction(billId, bill);
		} else {
			showFromCode(o.status);
		}
	});
}

function bindBillReplyAction(billId, bill) {
	if (bill.status == BILL_STATUS_CREATED || bill.status == BILL_STATUS_REJECTED ||
		bill.status == BILL_STATUS_PAID || bill.status == BILL_STATUS_COLLECT) {
		return false;
	}

	var $btnCreateNewReply = document.getElementById('btnCreateNewReply');
	$btnCreateNewReply.style.display = 'block';
	$btnCreateNewReply.addEventListener('tap', function(e) {
		mui('#middleReplyPopover').popover('show');
	});

	document.getElementById('btnConfirmReply').addEventListener('tap', function() {
		onCreateBillReply(billId);
	});

	document.getElementById('btnCancelReply').addEventListener('tap', function() {
		mui('#middleReplyPopover').popover('hide');
	});

}

//自动聚焦输入框并弹出软键盘
function openSoftKeyboard($selector) {
	if (mui.os.ios) {
		setTimeout(function() {
			var wv_current = plus.webview.currentWebview().nativeInstanceObject();
			wv_current.plusCallMethod({
				"setKeyboardDisplayRequiresUserAction": false
			});
			//	    document.querySelector($selector).focus();
		}, 330);
	} else {
		setTimeout(function() {
			var wv_current = plus.android.currentWebview();
			plus.android.importClass(wv_current);
			wv_current.requestFocus();

			var Context = plus.android.importClass("android.content.Context");
			var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
			var main = plus.android.runtimeMainActivity();
			var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			document.querySelector($selector).focus();
		}, 100);
	}
}

function onCreateBillReply(billId) {
	var $replyTxt = document.getElementById('replyTxt');
	var $objBillReplyList = document.getElementById('replyList')

	var replyTxt = $replyTxt.value;
	var newReply = {
		billId: billId,
		note: replyTxt
	}
	if (replyTxt.trim() == '') {
		mj.alert('请输入回复内容');
		return;
	}
	doCreateReply($objBillReplyList, billId, newReply);
}

function doCreateReply(objBillReplyList, billId, newReply) {
	mj.showLoading();

	mj.post(MJ_URL.BILL_F_REPLY.mjFormat(billId), newReply, function() {
		var objBillReplyNum = document.getElementById('billReplyNum');
		var oldReplayNum = objBillReplyNum.innerText;
		mj.hideLoading();
		newReply.createDate = new Date();
		newReply.senderName = mj.getNickName();
		objBillReplyList.innerHTML = generateBillReplyItem(newReply) + objBillReplyList.innerHTML;
		document.getElementById("replyTxt").value = '';
		objBillReplyNum.innerText = Number(oldReplayNum) + 1;
		mui('#middleReplyPopover').popover('hide');
		mui.toast('单据回复成功');
	}, function(xhr) {
		mj.hideLoading();
		showResult(xhr, LOST_NETWORK_CONNECTION);
	});
}

//冲抵借款单的详情
function renderBillLoans(billId) {
	queryBillLoans(billId, function(data) {
		document.getElementById('loansDetailList').innerHTML = generateBillDetailLoadLoans(data);
	});
}

//报销明细详情
function initBillFeesUI(billId) {
	queryBillFees(billId, function(data) {
		var feeList = data;
		var feeItem;
		for (var i = 0; i < feeList.length; i++) {
			feeItem = feeList[i];
			feeMap[feeItem.id] = feeItem;
		}
		document.getElementById('feesDetailList').innerHTML = generateBillDetailContentFees(data, '#feeDetailPage');
	});
}

function renderBillFees(billId, feeHeaderDictKey) {
	initBillFeesUI(billId);

	getFeeTableColumnsHeaderForDetail(feeHeaderDictKey, defaultFeeClms,
		function(_feeClms, data) {
			feeClms = _feeClms;
			dms = data;
		},
		function(_feeClms) {
			getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, _feeClms);
		});
}

function renderFinBillFees(billId, feeHeaderDictKey) {
	queryBillFees(billId, function(fees) {
		var crFees = [],
			drFees = [];
		var crFeeItem, drFeeItem;
		var totalCrExpense = 0;

		fixBillSubs(fees, drFees, crFees, function(drFeeItem) {
			feeMap[drFeeItem.id] = drFeeItem;
		}, function(crFeeItem) {

		}, function(totalCrExpense) {
			document.getElementById('crTotalExpense').innerText = totalCrExpense.toFixed(2);
			document.getElementById('crTotalExpenseCapital').innerText = (totalCrExpense.toFixed(2) + '').toCapitalMoney();
		});

		document.getElementById('feesDetailList').innerHTML = generateBillDetailContentFees(drFees, '#feeDetailPage');

		document.getElementById('crFeesDetailList').innerHTML = generateBillDetailContentCrFees(crFees);
	});

	getFeeTableColumnsHeaderForDetail(feeHeaderDictKey, defaultFeeClms,
		function(_feeClms, data) {
			feeClms = _feeClms;
			dms = data;
		},
		function(_feeClms) {
			getFeeTableColumnHeaderSpecofied(feeHeaderDictKey, _feeClms);
		});
}

function fixBillSubs(fees, drFees, crFees, fixDrFee, fixCrFee, callback) {
	var totalExpense = 0;
	mui.each(fees, function(index, fee) {
		if (BILL_DC_CR == fee.billDcTypeInt) {
			totalExpense += fee.expense;
			crFees.push(fee);
			fixCrFee && fixCrFee(fee);
		} else {
			drFees.push(fee);
			fixDrFee && fixDrFee(fee);
		}
	});

	callback && callback(totalExpense);
}

function fixBillSubsForSuper(fees, drFees, crFees, callback){
  var totalExpense = 0,totalCrExpense = 0;
  mui.each(fees, function(index, fee){
	if (!billMultiCurrency){
		fee.bizExpense = fee.expense;
	}else{
		fee.bizExpense = fee.expense >=0 ? Math.abs(fee.bizExpense) :(fee.bizExpense <0 ? fee.bizExpense : -fee.bizExpense);
	}
    if(BILL_DC_CR==fee.billDcTypeInt){
		totalCrExpense += fee.bizExpense;
		crFees.push(fee);
    } else {
		totalExpense += fee.bizExpense;
		drFees.push(fee);
    }
  });
  callback && callback(totalExpense,totalCrExpense);
}

function initDetailFee(options) {
	//报销明细详情
	var $this;
	var currentFeeEaId = -1,
		currentFeeEaName = '',
		currentFeeEaTypeInt = -1;
	var currentFeeCashFlowId = -1,
		currentFeeCashFlowName = '';
	var currentFeeToCurrencyId = -1,
		currentFeeToCurrencyName = '';
	var currentFeeTaxEaId = -1,
		currentFeeTaxEaName = '';
	var currentFeeCollectTime = '';
	var currentFeeDm1Id = -1,
		currentFeeDm1 = '';
	var currentFeeDm2Id = -1,
		currentFeeDm2 = '';
	var currentFeeDm3Id = -1,
		currentFeeDm3 = '';
	var currentFeeDm4Id = -1,
		currentFeeDm4 = '';
	var currentFeeDm5Id = -1,
		currentFeeDm5 = '';
	var tmpFeeEa = -1,
		tmpFeeEaName = '',
		tmpFeeEaTypeInt = -1;
	var tmpFeeCashFlow = -1,
		tmpFeeCashFlowName = '';
	var tmpFeeToCurrency = -1,
		tmpFeeToCurrencyName = '';
	var tmpFeeCollectTime = '';
	var tmpFeeTaxEa = -1,
		tmpFeeTaxEaName = '';
	var tmpFeeDm1Id = -2,
		tmpFeeDm1 = '';
	var tmpFeeDm2Id = -2,
		tmpFeeDm2 = '';
	var tmpFeeDm3Id = -2,
		tmpFeeDm3 = '';
	var tmpFeeDm4Id = -2,
		tmpFeeDm4 = '';
	var tmpFeeDm5Id = -2,
		tmpFeeDm5 = '';
	var currentFeeClms;
	var currentFeeStatus = -1;

	options = options || {};
	var feePageShowId = options.feePageShowId;
	var feeListShowId = options.feeListShowId;
	var btnBackActionOnHead = options.btnBackAction;
	var btnConfirmFeeWrapper = options.btnConfirmFeeWrapper;
	var btnConfirmFeeTapId = options.btnConfirmFeeTapId;
	var objFeeDetailPage = document.getElementById(feePageShowId);
	var $feeDetailPage = mui('#' + feePageShowId);
	var $btnConfirmFeeWrapper = mui('#' + btnConfirmFeeWrapper);

	var oldScrollHeight = 0;

	//明细右上角返回按钮
	document.getElementById(btnBackActionOnHead).addEventListener('tap', function() {
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	//点击单据明细看单据详情
	mui('#' + feeListShowId).on('tap', '.fees-table-view', function() {
		$this = this;
		currentFeeClms = feeClms;
		currentFeeId = this.getAttribute('vid');
		currentFee = feeMap[currentFeeId];
		oldScrollHeight = document.body.scrollTop ? document.body.scrollTop : document.documentElement.scrollTop;
		mj.scrollToTop();

		buildFeeDetail(feeClms, dms, document.getElementById('feeDetailWrapper'), currentFee);
		currentFeeStatus = currentFee.status ? currentFee.status : -1;
		currentFeeEaId = currentFee.eaId ? currentFee.eaId : -1;
		currentFeeEaName = currentFee.eaName ? currentFee.eaName : '';
		currentFeeEaTypeInt = currentFee.eaTypeInt ? currentFee.eaTypeInt : -1;
		currentFeeCashFlowId = currentFee.cashFlowId ? currentFee.cashFlowId : -1;
		currentFeeCashFlowName = currentFee.cashFlowName ? currentFee.cashFlowName : '';
		currentFeeToCurrencyId = currentFee.toCurrencyId >= 0 ? currentFee.toCurrencyId : -1;
		currentFeeToCurrencyName = currentFee.toCurrencyName ? currentFee.toCurrencyName : '';
		currentFeeCollectTime = currentFee.collectTime ? new Date(currentFee.collectTime).format('yyyy-MM-dd') : '';
		//现金流量项目
		if ((currentFeeEaTypeInt == EA_TYPE_ASSET_CASH) || (currentFeeCashFlowId > 0)) {
			setTimeout(function() {
				renderCashFlowText(EA_TYPE_ASSET_CASH, currentFeeCashFlowName, 'feeCashFlowText', 'feeSelectedCashFlowName');
			}, 150);
		}
		//冲应收币别
		if ((currentFeeEaTypeInt == EA_TYPE_ASSET_RECV) || (currentFeeToCurrencyId >= 0)) {
			setTimeout(function() {
				renderFeeCurrencyText(EA_TYPE_ASSET_RECV, currentFeeToCurrencyName, 'feeCurrencyText',
					'feeSelectedCurrencyName');
			}, 150);
		}
		//预计/实际收款日期
		var checkCollectTimeCondition = false;
		switch (currentBillType) {
			case BILL_TYPE_SALE:
				checkCollectTimeCondition = ((billEaTypeInt == EA_TYPE_ASSET_RECV) || (currentFeeCollectTime != ''));
				break;
			case BILL_TYPE_COLLECTION:
			default:
				checkCollectTimeCondition = ((currentFeeEaTypeInt == EA_TYPE_ASSET_RECV) || (currentFeeCollectTime != '')) ||
					checkWindowProperty('checkFeeCollectTimeEnable');
				break;
		}
		if (checkCollectTimeCondition) {
			setTimeout(function() {
				renderFeeCollectTimeText(EA_TYPE_ASSET_RECV, currentFeeCollectTime, 'feeCollectTimeText', 'feeCollectTime');
			}, 150);
		}

		//审核后更新预计/实际收款日期
		if (window.hasOwnProperty('isRecvEnable') && isRecvEnable && currentFeeClms.collectTime) {
			var $btnUpdateCollectTimeWrapper = document.getElementById('btnUpdateCollectTimeWrapper');
			switch (Number(currentFeeStatus)) {
				case BILL_STATUS_APPROVED:
				case BILL_STATUS_PAID:
				case BILL_STATUS_COLLECT:
					if ($btnUpdateCollectTimeWrapper && (currentFeeCollectTime != '') && has_bill_recv_permission) {
						$btnUpdateCollectTimeWrapper.style.display = 'block';
					}
					break;
				default:
					if ($btnUpdateCollectTimeWrapper) {
						$btnUpdateCollectTimeWrapper.style.display = 'none';
					}
					break;
			}
		}

		currentFeeTaxEaId = currentFee.taxEaId ? currentFee.taxEaId : -1;
		currentFeeTaxEaName = currentFee.taxEaName ? currentFee.taxEaName : '';

		currentFeeDm1Id = currentFee.dm1Id ? currentFee.dm1Id : -1;
		currentFeeDm1 = currentFee.dm1 ? currentFee.dm1 : '';
		currentFeeDm2Id = currentFee.dm2Id ? currentFee.dm2Id : -1;
		currentFeeDm2 = currentFee.dm2 ? currentFee.dm2 : '';
		currentFeeDm3Id = currentFee.dm3Id ? currentFee.dm3Id : -1;
		currentFeeDm3 = currentFee.dm3 ? currentFee.dm3 : '';
		currentFeeDm4Id = currentFee.dm4Id ? currentFee.dm4Id : -1;
		currentFeeDm4 = currentFee.dm4 ? currentFee.dm4 : '';
		currentFeeDm5Id = currentFee.dm5Id ? currentFee.dm5Id : -1;
		currentFeeDm5 = currentFee.dm5 ? currentFee.dm5 : '';

		tmpFeeEa = -1;
		tmpFeeEaName = '';
		tmpFeeEaTypeInt = -1;
		tmpFeeCashFlow = -1;
		tmpFeeCashFlowName = '';
		tmpFeeToCurrency = -1;
		tmpFeeToCurrencyName = '';
		tmpFeeCollectTime = '';
		tmpFeeTaxEa = -1;
		tmpFeeTaxEaName = '';
		tmpFeeDm1Id = -2;
		tmpFeeDm1 = '';
		tmpFeeDm2Id = -2;
		tmpFeeDm2 = '';
		tmpFeeDm3Id = -2;
		tmpFeeDm3 = '';
		tmpFeeDm4Id = -2;
		tmpFeeDm4 = '';
		tmpFeeDm5Id = -2;
		tmpFeeDm5 = '';
	});

	//修改金额
	$feeDetailPage.on('input', '#feeExpense', function() {
		var objTaxExpense = document.getElementById('feeTaxExpense');
		var objExpenseExcludeTax = document.getElementById('feeExpenseExcludeTax');
		var expense = document.getElementById('feeExpense').value;
		if (objExpenseExcludeTax) var taxExpense = objTaxExpense.value;
		var expenseExcludeTax = expense - taxExpense;
		if (objExpenseExcludeTax) objExpenseExcludeTax.innerText = expenseExcludeTax.toFixed(2);
	});

	//修改进项税
	$feeDetailPage.on('input', '#feeTaxExpense', function() {
		var taxExpense = document.getElementById('feeTaxExpense').value;
		var expenseExcludeTax = currentFee.expense - taxExpense;
		document.getElementById('feeExpenseExcludeTax').innerText = expenseExcludeTax.toFixed(2);
	});

	//修改进项税科目
	$feeDetailPage.on('tap', '#feeTaxEaCell', function() {
		switch (currentBillType) {
			case BILL_TYPE_SALE:
				showOutputTaxEaBookForBillFee(function(selected) {
					tmpFeeTaxEa = selected.id;
					tmpFeeTaxEaName = selected.name;

					document.querySelector('.fee-tax-ea').innerText = tmpFeeTaxEaName;
				});
				break;
			default:
				showTaxEaBookForBillFee(function(selected) {
					tmpFeeTaxEa = selected.id;
					tmpFeeTaxEaName = selected.name;

					document.querySelector('.fee-tax-ea').innerText = tmpFeeTaxEaName;
				});
				break;
		}
	});

	//修改科目
	$feeDetailPage.on('tap', '#feeEaCell', function() {
		switch (currentBillType) {
			case BILL_TYPE_COLLECTION:
				showCollectionEaBookForBillFee({
					feeDirect: BILL_DC_CR,
					title: '请选择收款类型',
					showEas: []
				}, function(selected) {
					tmpFeeEa = selected.id;
					tmpFeeEaName = selected.name;
					tmpFeeEaTypeInt = selected.field;
					currentFee.eaTypeInt = tmpFeeEaTypeInt;
					tmpFeeCashFlow = -1;
					tmpFeeCashFlowName = '';
					currentFeeCashFlowId = -1;
					currentFeeCashFlowName = '';
					tmpFeeToCurrency = -1;
					tmpFeeToCurrencyName = '';
					tmpFeeCollectTime = '';
					currentFeeToCurrencyId = -1;
					currentFeeToCurrencyName = '';

					document.querySelector('.fee-selected-ea').innerText = tmpFeeEaName;
					renderCashFlowText(tmpFeeEaTypeInt, currentFeeCashFlowName, 'feeCashFlowText', 'feeSelectedCashFlowName');
					renderFeeCurrencyText(tmpFeeEaTypeInt, currentFeeToCurrencyName, 'feeCurrencyText', 'feeSelectedCurrencyName');
					// renderFeeCollectTimeText(tmpFeeEaTypeInt, currentFeeCollectTime, 'feeCollectTimeText', 'feeCollectTime');
				});
				break;
			case BILL_TYPE_SALE:
				showSaleCrBookForBillFee(function(selected) {
					tmpFeeEa = selected.id;
					tmpFeeEaName = selected.name;
					tmpFeeEaTypeInt = selected.field;
					currentFee.eaTypeInt = tmpFeeEaTypeInt;
					tmpFeeCashFlow = -1;
					tmpFeeCashFlowName = '';
					currentFeeCashFlowId = -1;
					currentFeeCashFlowName = '';

					document.querySelector('.fee-selected-ea').innerText = tmpFeeEaName;
					renderCashFlowText(tmpFeeEaTypeInt, currentFeeCashFlowName, 'feeCashFlowText', 'feeSelectedCashFlowName');
				});
				break;
			case BILL_TYPE_SUPPLIER_ASSET:
				showAssetBookForBillFee(function(selected) {
					tmpFeeEa = selected.id;
					tmpFeeEaName = selected.name;
					tmpFeeEaTypeInt = selected.field;
					currentFee.eaTypeInt = tmpFeeEaTypeInt;
					tmpFeeCashFlow = -1;
					tmpFeeCashFlowName = '';
					currentFeeCashFlowId = -1;
					currentFeeCashFlowName = '';

					document.querySelector('.fee-selected-ea').innerText = tmpFeeEaName;
					renderCashFlowText(tmpFeeEaTypeInt, currentFeeCashFlowName, 'feeCashFlowText', 'feeSelectedCashFlowName');
				});
				break;
			case BILL_TYPE_BANK_DEDUCTION:
				showEaBookForBillFee(function(selected) {
					tmpFeeEa = selected.id;
					tmpFeeEaName = selected.name;
					tmpFeeEaTypeInt = selected.field;
					currentFee.eaTypeInt = tmpFeeEaTypeInt;

					document.querySelector('.fee-selected-ea').innerText = tmpFeeEaName;
					if (currentFeeClms.budget || currentFeeClms.totalBudget) {
						if (billFor == EXPENSE_BELONG_PROJECT) {
							getBudgetForFee(currentFeeClms, billFor, currentFee.projectId, tmpFeeEa, document.getElementById(
								'billBudgetTime').innerText);
						} else {
							getBudgetForFee(currentFeeClms, billFor, currentFee.departmentId, tmpFeeEa, document.getElementById(
								'billBudgetTime').innerText);
						}
					}
				});
				break;
			default:
				showEaBookForBillFee(function(selected) {
					tmpFeeEa = selected.id;
					tmpFeeEaName = selected.name;
					tmpFeeEaTypeInt = selected.field;
					currentFee.eaTypeInt = tmpFeeEaTypeInt;
					tmpFeeCashFlow = -1;
					tmpFeeCashFlowName = '';
					currentFeeCashFlowId = -1;
					currentFeeCashFlowName = '';

					document.querySelector('.fee-selected-ea').innerText = tmpFeeEaName;
					renderCashFlowText(tmpFeeEaTypeInt, currentFeeCashFlowName, 'feeCashFlowText', 'feeSelectedCashFlowName');

					if (currentFeeClms.budget || currentFeeClms.totalBudget) {
						if (billFor == EXPENSE_BELONG_PROJECT) {
							getBudgetForFee(currentFeeClms, billFor, currentFee.projectId, tmpFeeEa, document.getElementById(
								'billBudgetTime').innerText);
						} else {
							getBudgetForFee(currentFeeClms, billFor, currentFee.departmentId, tmpFeeEa, document.getElementById(
								'billBudgetTime').innerText);
						}
					}
				})
				break;
		}
	});

	//现金流量项目
	if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable && window.hasOwnProperty('cashFlowItemArr')) {
		//审核中→修改现金流量项目
		initCashFlowBookForFee({
			cashFlowItem: cashFlowItemArr,
			feePageShowId: 'feeDetailPage',
			feeTapCellId: 'feeCashFlowCell',
			feeCahsFlowShowId: 'feeSelectedCashFlowName',
			checkStatus: function() {
				return currentFeeStatus;
			}
		}, function(selected) {
			currentFee.cashFlowId = selected.id;
			currentFee.cashFlowName = selected.name;
			tmpFeeCashFlow = selected.id;
			tmpFeeCashFlowName = selected.name;
		});

		//审核后→已付款,已收款,已审核→修改现金流量项目
		if (window.hasOwnProperty('has_bill_cashflow_permission') && has_bill_cashflow_permission) {
			var curCashFlowUpdateId = -1;
			initCashFlowBookForFee({
				cashFlowItem: cashFlowItemArr,
				feePageShowId: 'feeDetailPage',
				feeTapCellId: 'updateCashFlowCellAfterReview',
				feeCahsFlowShowId: 'updateSelectedCashFlowName',
				checkStatus: function() {
					return currentFeeStatus;
				}
			}, function(selected) {
				curCashFlowUpdateId = selected.id;

				doBillActionUpdateCashFlowAfterReview(billId, 'fee', currentFeeId, curCashFlowUpdateId, function() {
					mj.hideModal(feePageShowId);
					mj.reload(true);
				});
			});
		}
	}

	//冲应收币别
	if (window.hasOwnProperty('isToCurrency') && isToCurrency) {
		//审核中→修改冲应收币别
		initToCurrencyBookForBillFee(function(selected) {
			tmpFeeToCurrency = selected.id;
			tmpFeeToCurrencyName = selected.name;
		});
		//审核后→已审核/已付款/已收款→修改冲应收币别
		if (window.hasOwnProperty('has_bill_recv_permission') && has_bill_recv_permission) {
			var curToCurrencyUpdateId = -1;
			initToCurrencyBookForBillFeeAfterReview({
				checkStatus: function() {
					return currentFeeStatus;
				}
			}, function(selected) {
				curToCurrencyUpdateId = selected.id;
				doBillActionUpdateToCurrencyAfterReview(curToCurrencyUpdateId, currentFeeId, function() {
					mj.hideModal(feePageShowId);
					mj.reload(true);
				});
			});
		}
	}

	//预计/实际收款日期
	if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
		initChangeCollectTimeInReview({
			feePageId: '#feeDetailPage',
			collectTimeTapId: 'feeCollectTimeCell'
		}, function(rs) {
			tmpFeeCollectTime = rs.text;
			document.querySelector('.fee-collect-time').innerText = tmpFeeCollectTime;
		});
	}

	//修改扩展字段
	//扩展字段1
	$feeDetailPage.on('tap', '#feeDm1Cell', function() {
		showDmBookForBillFee(mj.getDict(BILL_FEE_DM1), dm1s, function(selected) {
			tmpFeeDm1Id = selected.id;
			tmpFeeDm1 = selected.name;

			document.querySelector('.fee-dm1').innerText = tmpFeeDm1;
		});
	});

	//扩展字段2
	$feeDetailPage.on('tap', '#feeDm2Cell', function() {
		showDmBookForBillFee(mj.getDict(BILL_FEE_DM2), dm2s, function(selected) {
			tmpFeeDm2Id = selected.id;
			tmpFeeDm2 = selected.name;

			document.querySelector('.fee-dm2').innerText = tmpFeeDm2;
		});
	});

	//扩展字段3
	$feeDetailPage.on('tap', '#feeDm3Cell', function() {
		showDmBookForBillFee(mj.getDict(BILL_FEE_DM3), dm3s, function(selected) {
			tmpFeeDm3Id = selected.id;
			tmpFeeDm3 = selected.name;

			document.querySelector('.fee-dm3').innerText = tmpFeeDm3;
		});
	});

	//扩展字段4
	$feeDetailPage.on('tap', '#feeDm4Cell', function() {
		showDmBookForBillFee(mj.getDict(BILL_FEE_DM4), dm4s, function(selected) {
			tmpFeeDm4Id = selected.id;
			tmpFeeDm4 = selected.name;

			document.querySelector('.fee-dm4').innerText = tmpFeeDm4;
		});
	});

	//扩展字段5
	$feeDetailPage.on('tap', '#feeDm5Cell', function() {
		showDmBookForBillFee(mj.getDict(BILL_FEE_DM5), dm5s, function(selected) {
			tmpFeeDm5Id = selected.id;
			tmpFeeDm5 = selected.name;

			document.querySelector('.fee-dm5').innerText = tmpFeeDm5;
		});
	});

	//审核中
	$btnConfirmFeeWrapper.on('tap', '#' + btnConfirmFeeTapId, function() {
		//报销金额
		var objExpense = document.getElementById('feeExpense');
		if (window.hasOwnProperty('checkChangeExpensePer') && checkChangeExpensePer && objExpense) {
			currentFee.expense = Number(objExpense.value);
			if (currentFee.expense == '') {
				mui.toast('请输入金额');
				return false;
			}
			$this.querySelector('#fee-s-expense-' + currentFee.id).innerText = currentFee.expense;
			calcBillExpenseTotal(currentBillType);
		}
		//进项税
		var objTaxExpense = document.getElementById('feeTaxExpense');
		var objExpenseExcludeTax = document.getElementById('feeExpenseExcludeTax');
		if (objTaxExpense) {
			currentFee.taxExpense = Number(objTaxExpense.value);
			currentFee.expenseExcludeTax = Number(objExpenseExcludeTax.innerText);
		}
		//进项税科目
		var objFeeTaxEa = document.querySelector('.fee-tax-ea');
		if (objFeeTaxEa) {
			currentFee.taxEaId = (tmpFeeTaxEa != -1) ? tmpFeeTaxEa : currentFeeTaxEaId;
			currentFee.taxEaName = (tmpFeeTaxEaName != '') ? tmpFeeTaxEaName : currentFeeTaxEaName;
		}
		//扩展字段
		var objFeeDm1 = document.getElementById('feeDm1');
		var objFeeDm2 = document.getElementById('feeDm2');
		var objFeeDm3 = document.getElementById('feeDm3');
		var objFeeDm4 = document.getElementById('feeDm4');
		var objFeeDm5 = document.getElementById('feeDm5');

		var objSelectedDm1 = document.getElementById('feeSelectedDm1');
		var objSelectedDm2 = document.getElementById('feeSelectedDm2');
		var objSelectedDm3 = document.getElementById('feeSelectedDm3');
		var objSelectedDm4 = document.getElementById('feeSelectedDm4');
		var objSelectedDm5 = document.getElementById('feeSelectedDm5');

		currentFee.dm1 = objFeeDm1 ? objFeeDm1.value : (objSelectedDm1 ? objSelectedDm1.innerText : currentFeeDm1);
		currentFee.dm2 = objFeeDm2 ? objFeeDm2.value : (objSelectedDm2 ? objSelectedDm2.innerText : currentFeeDm2);
		currentFee.dm3 = objFeeDm3 ? objFeeDm3.value : (objSelectedDm3 ? objSelectedDm3.innerText : currentFeeDm3);
		currentFee.dm4 = objFeeDm4 ? objFeeDm4.value : (objSelectedDm4 ? objSelectedDm4.innerText : currentFeeDm4);
		currentFee.dm5 = objFeeDm5 ? objFeeDm5.value : (objSelectedDm5 ? objSelectedDm5.innerText : currentFeeDm5);

		currentFee.dm1Id = (tmpFeeDm1Id != -2) ? tmpFeeDm1Id : currentFeeDm1Id;
		currentFee.dm2Id = (tmpFeeDm2Id != -2) ? tmpFeeDm2Id : currentFeeDm2Id;
		currentFee.dm3Id = (tmpFeeDm3Id != -2) ? tmpFeeDm3Id : currentFeeDm3Id;
		currentFee.dm4Id = (tmpFeeDm4Id != -2) ? tmpFeeDm4Id : currentFeeDm4Id;
		currentFee.dm5Id = (tmpFeeDm5Id != -2) ? tmpFeeDm5Id : currentFeeDm5Id;
		//会计科目
		var objFeeEa = document.querySelector('.fee-selected-ea');
		if (objFeeEa) {
			currentFee.eaId = (tmpFeeEa != -1) ? tmpFeeEa : currentFeeEaId;
			currentFee.eaName = (tmpFeeEaName != '') ? tmpFeeEaName : currentFeeEaName;
			currentFee.eaTypeInt = (tmpFeeEaTypeInt != -1) ? tmpFeeEaTypeInt : currentFeeEaTypeInt;
			$this.querySelector('#fee-s-ea-' + currentFee.id).innerText = (currentFee.eaName ? currentFee.eaName : '未选科目');
		}
		//现金流量项目
		var objFeeCashFlowCell = document.querySelector('.fee-review-cash-flow-cell');
		var objFeeCashFlow = document.querySelector('.fee-selected-cash-flow');
		if (objFeeCashFlow) {
			currentFee.cashFlowId = (tmpFeeCashFlow != -1) ? tmpFeeCashFlow : currentFeeCashFlowId;
			currentFee.cashFlowName = (tmpFeeCashFlowName != '') ? tmpFeeCashFlowName : currentFeeCashFlowName;
		}
		//冲应收币别
		var objFeeCurrencyCell = document.querySelector('.fee-review-currency-cell');
		var objFeeCurrency = document.querySelector('.fee-selected-currency');
		if (objFeeCurrency) {
			currentFee.toCurrencyId = (tmpFeeToCurrency != -1) ? tmpFeeToCurrency : currentFeeToCurrencyId;
			currentFee.toCurrencyName = (tmpFeeToCurrencyName != '') ? tmpFeeToCurrencyName : currentFeeToCurrencyName;
		}
		//预计/实际收款日期
		var objFeeCollectTimeCell = document.querySelector('.fee-collect-time-cell');
		var objFeeCollectTime = document.querySelector('.fee-collect-time');
		if (objFeeCollectTime) {
			currentFee.collectTime = (tmpFeeCollectTime != '') ? tmpFeeCollectTime : currentFeeCollectTime;
		}
		//预算
		if (currentFeeClms.budget || currentFeeClms.totalBudget) {
			var objFeeBudget = document.querySelector('.fee-budget');
			var objFeeTotalBudget = document.querySelector('.fee-total-budget');
			if (objFeeBudget) currentFee.budget = objFeeBudget.value;
			if (objFeeTotalBudget) currentFee.totalBudget = objFeeTotalBudget.value;
		}

		if (window.hasOwnProperty('isCashFlowEnable') && isCashFlowEnable && objFeeCashFlowCell) {
			switch (currentBillType) {
				case BILL_TYPE_BANK_DEDUCTION:
					if (currentFee.cashFlowId == -1) {
						mui.toast('请选择现金流量项目');
						return false;
					}
					break;
				default:
					if (currentFee.eaId && currentFee.eaTypeInt == EA_TYPE_ASSET_CASH && currentFee.cashFlowId == -1) {
						mui.toast('请选择现金流量项目');
						return false;
					}
					break;
			}
		}

		if (window.hasOwnProperty('isToCurrency') && isToCurrency && objFeeCurrencyCell) {
			if (currentFee.eaId && currentFee.eaTypeInt == EA_TYPE_ASSET_RECV && currentFee.toCurrencyId == -1) {
				mui.toast('请选择冲应收币别');
				return false;
			}
		}

		if (window.hasOwnProperty('isRecvEnable') && isRecvEnable && objFeeCollectTimeCell) {
			var collectTimeMsg = '';
			var checkCollectTimeValid = false;
			switch (currentBillType) {
				case BILL_TYPE_SALE:
					collectTimeMsg = '预计收款日期';
					checkCollectTimeValid = (billEaTypeInt == EA_TYPE_ASSET_RECV && currentFee.collectTime == '');
					break;
				case BILL_TYPE_COLLECTION:
				default:
					collectTimeMsg = '实际收款日期';
					checkCollectTimeValid = (currentFee.eaId && currentFee.eaTypeInt == EA_TYPE_ASSET_RECV && currentFee.collectTime ==
						'');
					break;
			}

			if (checkCollectTimeValid) {
				mui.toast('请选择' + collectTimeMsg);
				return false;
			}
		}

		//重置页面滑动距离，关闭单据详情弹出框
		mj.fixScrollTop(oldScrollHeight);
		mj.hideModal(feePageShowId);
	});

	//审核后→已付款,已收款,已审核→修改预计收款日期
	mui('#btnUpdateCollectTimeWrapper').on('tap', '#btnUpdateCollectTime', function() {
		if (!window.hasOwnProperty('currentBillType')) {
			return falase;
		}

		var billTypeName = getBillNameByType(currentBillType);
		var $updateCollectTime = document.querySelector('.fee-collect-time');
		var updateCollectTime = $updateCollectTime ? $updateCollectTime.innerText : '';
		var updateCollectTimeMsg = '';
		switch (currentBillType) {
			case BILL_TYPE_SALE:
				updateCollectTimeMsg = '预计收款日期';
				break;
			case BILL_TYPE_COLLECTION:
				updateCollectTimeMsg = '实际收款日期';
			default:
				break;
		}
		if (updateCollectTime == '') {
			mui.toast('请选择' + updateCollectTimeMsg);
			return false;
		}

		var postUrl = MJ_URL.BILL_A_RECV.mjFormat(billTypeName, currentFeeId);
		var postData = {
			collectTime: updateCollectTime
		};
		doBillAction(postUrl, postData, function(response) {
			mui.toast('修改' + updateCollectTimeMsg + '成功');
			mj.hideModal(feePageShowId);
			mj.reload(true);
		}, function(response) {
			showResult(response, LOST_NETWORK_CONNECTION);
		});
	});
}

function canUploadAttach(bill) {
	var canUpload = false;
	if (bill.status == BILL_STATUS_CREATED || bill.status == BILL_STATUS_REVIEWING || bill.status == BILL_STATUS_REJECTED) {
		canUpload = true;
	}
	return canUpload;
}

function renderCreateBillAttaches() {
	prepareUpload('#btnAddAttach', 'attachWrapper', 'bill', 0, '/api/m/bills/attach/upload', '/api/m/bills/attach/delete',
		mj.getCompress(), mj.getMultiple());
}

function checkAttachesForCreateProgress(postData, callback) {
	var uploadFinishedValid = true;
	var uploadUnfinishedCount = 0;
	plus.uploader.enumerate(function(uploadTasks) {
		mui.each(uploadTasks, function(index, item) {
			if (item.state != 4) {
				uploadUnfinishedCount++;
			}
		});

		log('uploadUnfinishedCount' + uploadUnfinishedCount);

		if (uploadUnfinishedCount > 0) {
			uploadFinishedValid = false;
			mj.alert(uploadUnfinishedCount + '个附件正在上传中,请稍候');
		} else {
			postData.attaches = attaches;
		}

		callback && callback(uploadFinishedValid);
	}, -1);
}

function fnGetBillAttachUrl(attachId) {
	return '/api/m/bills/attach/download?id=' + attachId;
}

function fnGetBillAttachSavePath(attachId, attachExt) {
	return '_downloads/image/' + mj.getId() + '_attach_' + attachId + attachExt;
}

function renderBillAttaches(bill) {
	var canUpload = canUploadAttach(bill);
	if (canUpload) {
		document.getElementById('btnAddAttach').style.display = 'block';
		prepareUpload('#btnAddAttach', 'attachWrapper', 'bill', billId, '/api/m/bills/attach/upload',
			'/api/m/bills/attach/delete', mj.getCompress(), mj.getMultiple());
	}

	mj.get(MJ_URL.BILL_ATTACH_LIST + billId, {}, function(d) {
		var item;
		var defaultFileImg = "../../@/img/file/file_sm.png";

		for (var i = 0; i < d.length; i++) {
			item = d[i];

			var isImg = imgFilter.test(item.ext);
			var imgName = item.name;
			var attachExt = imgName.substr(imgName.lastIndexOf('.'));

			if (isImg) {
				var loadUrl = fnGetBillAttachUrl(item.id);
				var relativePath = fnGetBillAttachSavePath(item.id, attachExt);
				doGetAttach(loadUrl, relativePath, imgName, 'attachWrapper', item.id);
			} else {
				var imgDom = setImgFromLocal(defaultFileImg, imgName, 'attachWrapper', item.id);
				imgDom.setAttribute('vi', item.id);
				imgDom.setAttribute('vt', attachExt);

				var img = imgDom.getElementsByTagName('img');
				for (var j = 0; j < img.length; j++) {
					img[j].removeAttribute('data-preview-src');
					img[j].removeAttribute('data-preview-group');
				}

				imgDom.addEventListener('tap', function() {
					var attachId = this.getAttribute('vi');
					var attachExt = this.getAttribute('vt');

					var relativePath = fnGetBillAttachSavePath(attachId, attachExt);
					plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
						log("附件已存在,地址:" + relativePath);
						showAttach(relativePath);
					}, function(e) {
						var loadUrl = fnGetBillAttachUrl(attachId);
						mj.download(loadUrl, relativePath, function(succeed) {
							if (succeed) {
								log("附件已下载,地址:" + relativePath);
								showAttach(relativePath);
							}
						});
					});
				});
			}
		}
	}, function() {});
}

function showAttach(relativePath) {
	var imgUrl = 'file://' + plus.io.convertLocalFileSystemURL(relativePath);

	plus.runtime.openFile(imgUrl, {}, function(e) {
		mui.toast("无法打开此文件：" + e.emssage);
	});
}

//所属部门
function initUserDepartmentBookForBill(options, callback) {
	options = options || {};
	var accountId = options.accountId || -1;
	document.getElementById('billDepartmentCell').addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'DEPARTMENT',
			title: '请选择所属部门',
			param: {
				url: MJ_URL.DEPT_LIST_BY_ME
			},
			hasSpecial: false,
			showDirectSub: false,
			splitByAccount: true,
			accountId: accountId,
			showDepartments: [],
			callback: function(selected) {
				billDepartment = selected.id;
				document.getElementById('selectedDepartmentName').innerText = selected.name;
				callback && callback(billDepartment);
			}
		});
	});
}

//员工
function initUserBookForBillOwner(options, callback) {
	options = options || {};
	document.getElementById('billOwnerCell').addEventListener('tap', function() {
		if (!billDepartment || billDepartment <= 0) {
			mui.toast('请先选择部门');
			return false;
		}

		pushUserSelectWebView({
			source: 'USER',
			title: '请选择申请人',
			param: {
				url: MJ_URL.USER_LIST_BY_DEPT,
				department: billDepartment
			},
			showAll: options.showAll || false,
			hasSpecial: options.hasSpecial || false,
			showSubSelect: options.showSubSelect || false,
			autoLoad: false,
			showUsers: [],
			callback: function(selected) {
				billOwner = selected.id;
				document.getElementById('selectedOwnerName').innerText = selected.name;

				var isUser = options.isUser || false;
				if (isUser) {
					resetBankSelect();
				}

				callback && callback(billOwner);
			}
		});
	});
}

//单据明细员工
function initUserBookForBillFee() {
	document.getElementById('feeOwnerCell').addEventListener('tap', function() {
		var feeDepartment = currentFee.departmentId;
		if (!feeDepartment || feeDepartment <= 0) {
			feeDepartment = -1;
		}

		pushUserSelectWebView({
			source: 'USER',
			title: '请选择归属人',
			param: {
				url: MJ_URL.USER_LIST_BY_DEPT,
				department: feeDepartment
			},
			showAll: false,
			hasSpecial: true,
			showSubSelect: false,
			autoLoad: false,
			showUsers: [],
			callback: function(selected) {
				currentFee.owner = selected.id;
				currentFee.ownerName = selected.name;

				document.getElementById('feeSelectedOwnerName').innerText = selected.name;
			}
		});
	});
}

//币别
function showCurrencyBook(options, callback) {
	options = options || {};
	var hasSpecial = options.hasSpecial || false;
	var currencyShowId = options.currencyShowId;
	pushUserSelectWebView({
		source: 'CURRENCY',
		title: '请选择币别',
		param: {
			url: MJ_URL.CURRENCY_API
		},
		hasSpecial: hasSpecial,
		callback: function(selected) {
			if (currencyShowId) document.getElementById(currencyShowId).innerText = selected.name;
			callback && callback(selected);
		}
	});

}

//单据币别
function initPayCurrencyBookForBill(options, callback) {
	options = options || {};
	var isRelateToFeeTax = options.isRelateToFeeTax || false;
	document.getElementById('billPayCurrencyCell').addEventListener('tap', function() {
		showCurrencyBook({
			hasSpecial: options.hasSpecial || false,
			currencyShowId: 'selectedPayCurrency'
		}, function(selected) {
			billPayCurrency = selected.id;
			if(isRelateToFeeTax){
				renderFeeTaxExpense();
				mui.each(feeMap, function(index, item) {
					item.taxExpense = '0.00';
					item.expenseExcludeTax = Number(item.expense).toFixed(2);
				});
			}
			callback && callback(billPayCurrency);
		});
	});
}

//单据明细币别
function renderFeeCurrencyText(eaType, currencyName, currencyTextShowId, currencyShowId) {
	var $currencyTextShow = document.getElementById(currencyTextShowId);
	var $currencyNameShow = document.getElementById(currencyShowId);
	if (eaType && (eaType == EA_TYPE_ASSET_RECV)) {
		if ($currencyTextShow) $currencyTextShow.style.color = "#000";
		if (currencyName == undefined || currencyName == '') return false;
		if ($currencyNameShow) $currencyNameShow.innerText = currencyName ? currencyName : '';
	} else {
		if ($currencyTextShow) $currencyTextShow.style.color = "#999";
		if ($currencyNameShow) $currencyNameShow.innerText = '';
	}
}

function initToCurrencyBookForBillFee(callback) {
	mui('#feeDetailPage').on('tap', '#feeCurrencyCell', function() {
		if (window.hasOwnProperty('currentFee') && currentFee.eaTypeInt != EA_TYPE_ASSET_RECV) {
			mui.toast('请选择科目属性是资产类应收账款的会计科目');
			return false;
		}

		showCurrencyBook({
			hasSpecial: false,
			currencyShowId: 'feeSelectedCurrencyName'
		}, function(selected) {
			currentFee.toCurrencyId = selected.id;
			currentFee.toCurrencyName = selected.name;
			callback && callback(selected);
		});
	});
}

function initToCurrencyBookForBillFeeAfterReview(options, callback) {
	options = options || {};
	mui('#feeDetailPage').on('tap', '#updateCurrencyCellAfterReview', function() {
		options.prepare && options.prepare();
		var curStatus = options.checkStatus() ? options.checkStatus() : -1;
		curStatus = Number(curStatus);
		if (curStatus != BILL_STATUS_APPROVED && curStatus != BILL_STATUS_PAID && curStatus != BILL_STATUS_COLLECT) {
			return false;
		}
		showCurrencyBook({
			hasSpecial: false,
			currencyShowId: 'updateSelectedCurrencyName'
		}, function(selected) {
			callback && callback(selected);
		});
	});
}

//单据信息付款对象
function initPayTargetBookForBill(options, callback) {
	options = options || {};
	var title = options.title || '请选择付款对象';
	var showUser = options.showUser || false;
	var showCustomer = options.showCustomer || false;
	var showConsumer = options.showConsumer || false;
	var isRelateToCustomer = options.isRelateToCustomer || false;
	var isRelateToConsumer = options.isRelateToConsumer || false;
	var isRelateToBank = options.isRelateToBank || false;
	var payTargets = [];
	if (showUser) {
		payTargets.push({
			id: PAY_TARGET_USER,
			name: PayTargetPool[PAY_TARGET_USER]
		});
	}
	if (showCustomer) {
		payTargets.push({
			id: PAY_TARGET_SUPPLIER,
			name: PayTargetPool[PAY_TARGET_SUPPLIER]
		});
	}
	if (showConsumer) {
		payTargets.push({
			id: PAY_TARGET_CONSUMER,
			name: PayTargetPool[PAY_TARGET_CONSUMER]
		});
	}

	document.getElementById('billPayTargetCell').addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'PAY_TARGET',
			title: title,
			param: {},
			showPayTargets: payTargets,
			callback: function(selected) {
				//供应商置空
				if (showCustomer && !showConsumer && isRelateToCustomer && !isRelateToConsumer) {
					document.getElementById('selectedCustomerName').innerText = '';
					billCustomer = -1;
				}

				//供应商/客户置空
				if (showCustomer && showConsumer && isRelateToCustomer && isRelateToConsumer) {
					document.getElementById('selectedCcName').innerText = '';
					billCustomer = -1;
					billConsumer = -1;
				}

				//银行账号置空
				if (isRelateToBank) {
					resetBankSelect();
				}

				billPayTarget = selected.id;
				document.getElementById('selectedPayTargetInt').innerText = selected.name;
				callback && callback(selected);
			}
		});
	});
}

//单据信息销售方式
function initSaleTypeBookForBill() {
	var saleTypes = [];
	mui.each(SaleTypeEnum, function(index, item) {
		saleTypes.push({
			id: index,
			name: item
		});
	});

	document.getElementById('billSaleTypeCell').addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'SALE_TYPE',
			title: '请选择销售方式',
			param: {},
			showSaleTypes: saleTypes,
			callback: function(selected) {
				billSaleTypeInt = selected.id;
				document.getElementById('selectedSaleTypeInt').innerText = selected.name;
			}
		});
	});
}

//供应商(单据信息)
function initSupplierBookForBill(options, callback) {
	options = options || {};
	var title = options.title || '请选择供应商';
	var accountId = options.accountId || -1;
	document.getElementById('billCustomerCell').addEventListener('tap', function() {
		if (Number(billPayTarget) != PAY_TARGET_SUPPLIER) {
			return false;
		}

		pushUserSelectWebView({
			source: 'SUPPLIER',
			title: title,
			param: {
				url: MJ_URL.SPL_API
			},
			hasSpecial: false,
			splitByAccount: true,
			accountId: accountId,
			callback: function(selected) {
				var isRelateToBank = options.isRelateToBank || false;
				if (isRelateToBank) {
					resetBankSelect();
				}

				document.getElementById('selectedCustomerName').innerText = selected.name;

				callback && callback(selected);
			}
		});
	});
}

function renderPayTargetObjSelectForFee(payTarget, $container, callback) {
	switch (Number(payTarget)) {
		case PAY_TARGET_CONSUMER:
			if ($container.classList.contains('bill-fee-customer-visible')) {
				$container.classList.remove('bill-fee-customer-visible');
			}
			$container.classList.add('bill-fee-consumer-visible');
			break;
		case PAY_TARGET_SUPPLIER:
		default:
			if ($container.classList.contains('bill-fee-consumer-visible')) {
				$container.classList.remove('bill-fee-consumer-visible');
			}
			$container.classList.add('bill-fee-customer-visible');
			break;
	}
}

//单据明细供应商
function initSupplierBookForBillFee() {
	document.getElementById('feeCustomerCell').addEventListener('tap', function() {
		if (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_COLLECTION) {
			if (window.hasOwnProperty('billPayTarget') && billPayTarget != PAY_TARGET_SUPPLIER) {
				mui.toast('请先选择单据级别的收款对象');
				return false;

			}
		}

		pushUserSelectWebView({
			source: 'SUPPLIER',
			title: '请选择供应商',
			param: {
				url: MJ_URL.SPL_API
			},
			hasSpecial: true,
			splitByAccount: true,
			accountId: billAccount,
			callback: function(selected) {
				currentFee.supplierId = selected.id;
				currentFee.customerId = selected.id;
				currentFee.customerName = selected.name;

				document.getElementById('feeSelectedCustomerName').innerText = selected.name;
			}
		});
	});
}

//单据列表供应商
function initSupplierBookForBillList(options, callback) {
	options = options || {};
	var supplierTapId = options.supplierTapId;
	var supplierShowId = options.supplierShowId;
	var title = options.title || '请选择供应商';
	document.getElementById(supplierTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'SUPPLIER',
			title: title,
			param: {
				url: MJ_URL.SPL_API
			},
			hasSpecial: false,
			splitByAccount: true,
			accountId: -1,
			callback: function(selected) {
				if (supplierShowId) document.getElementById(supplierShowId).innerText = selected.name;
				callback && callback(selected);
			}
		});
	});
}

//客户,供应商切换
function initCcBookForBill(options, callback) {
	var payTargetTitle = options.payTargetTitle || '付款对象';
	var accountId = options.accountId || -1;
	var source = '';
	var title = '';
	var params = {};
	document.getElementById('billCcCell').addEventListener('tap', function() {
		if (billPayTarget < 0) {
			mui.toast('请选择' + payTargetTitle);
			return false;
		}

		if (Number(billPayTarget) != PAY_TARGET_SUPPLIER && Number(billPayTarget) != PAY_TARGET_CONSUMER) {
			return false;
		}

		switch (Number(billPayTarget)) {
			case PAY_TARGET_SUPPLIER:
				source = 'SUPPLIER';
				params.url = MJ_URL.SPL_API;
				title = '请选择供应商';
				break;
			case PAY_TARGET_CONSUMER:
				source = 'CONSUMER';
				params.url = MJ_URL.CC_LIST_BY_PERMISSION;
				params.systemModule = SYSTEM_MODULE_FIN;
				params.t1 = 'work';
				title = '请选择客户';
				break;
			default:
				break;
		}

		pushUserSelectWebView({
			source: source,
			title: title,
			param: params,
			hasSpecial: false,
			splitByAccount: true,
			accountId: accountId,
			callback: function(selected) {
				document.getElementById('selectedCcName').innerText = selected.name;

				var isRelateToBank = options.isRelateToBank || false;
				if (isRelateToBank) {
					resetBankSelect();
				}

				callback && callback(selected);
			}
		});
	});

}

//单据明细客户
function initConsumerBookForBillFee() {
	document.getElementById('feeConsumerCell').addEventListener('tap', function() {
		if (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_COLLECTION) {
			if (window.hasOwnProperty('billPayTarget') && billPayTarget != PAY_TARGET_CONSUMER) {
				mui.toast('请先选择单据级别的收款对象');
				return false;

			}
		}

		pushUserSelectWebView({
			source: 'CONSUMER',
			title: '请选择客户',
			param: {
				url: MJ_URL.CC_LIST_BY_PERMISSION,
				systemModule:SYSTEM_MODULE_FIN,
				t1:'work'
			},
			hasSpecial: true,
			splitByAccount: true,
			accountId: billAccount,
			callback: function(selected) {
				currentFee.consumerId = selected.id;
				currentFee.consumerName = selected.name;

				document.getElementById('feeSelectedConsumerName').innerText = selected.name;
			}
		});
	});
}

//借款/预付款单-借款/预付类型
function initDrEaBookForSupplierPrepayBill(options, callback) {
	options = options || {};
	var drEaTapId = options.drEaTapId;
	var drEaShowId = options.drEaShowId;
	document.getElementById(drEaTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'EA',
			title: '请选择借款/预付类型',
			param: {
				url: MJ_URL.EA_BILL_LOAN_DR
			},
			filterEaType: false,
			eaTypeInt: BIZ_TYPE_ALL,
			splitByAccount: true,
			accountId: billAccount,
			callback: function(selected) {
				if (drEaShowId) document.getElementById(drEaShowId).innerText = selected.name;

				callback && callback(selected);
			}
		});
	});
}

function initDrEaBookForSupplierPayGoodBill(options, callback) {
	options = options || {};
	var drEaTapId = options.drEaTapId;
	var drEaShowId = options.drEaShowId;
	document.getElementById(drEaTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'EA',
			title: '请选择应付类型',
			param: {
				url: MJ_URL.EA_BILL_PAYGOODS_DR
			},
			filterEaType: false,
			eaTypeInt: BIZ_TYPE_ALL,
			splitByAccount: true,
			accountId: billAccount,
			callback: function(selected) {
				if (drEaShowId) document.getElementById(drEaShowId).innerText = selected.name;

				callback && callback(selected);
			}
		});
	});
}

//销售单-借方科目
function initDrEaBookForSaleBill(options, callback) {
	options = options || {};
	var drEaTapId = options.drEaTapId;
	var drEaShowId = options.drEaShowId;
	var isCashFlowEnable = options.isCashFlowEnable || false;
	document.getElementById(drEaTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'EA',
			title: '请选择借方科目',
			param: {
				url: MJ_URL.EA_BILL_SALE_DR
			},
			filterEaType: false,
			eaTypeInt: BIZ_TYPE_ALL,
			splitByAccount: true,
			accountId: billAccount,
			callback: function(selected) {
				if (drEaShowId) document.getElementById(drEaShowId).innerText = selected.name;

				callback && callback(selected);
			}
		});
	});
}

//单据明细会计科目(部门单据/项目单据)
function showEaBookForBillFee(callback) {
	var paramUrl = '';
	var paramId = -1;
	var paramUser = -1;
	var paramBillFor = -1;
	var optEaTypeInt = BIZ_TYPE_ALL;
	if (checkWindowProperty('billFor') && billFor == EXPENSE_BELONG_PROJECT && currentFee.projectId != undefined) {
		if (currentFee.projectId == undefined || currentFee.projectId < 0) {
			mui.toast('请选择项目');
			return false;
		}
		paramUrl = MJ_URL.EA_LIST_BY_PROJ,
		paramId = currentFee.projectId;
	} else {
		if (currentFee.departmentId == undefined || currentFee.departmentId < 0) {
			mui.toast('请选择部门');
			return false;
		}
		paramUrl = MJ_URL.EA_LIST_BY_DEPT,
		paramId = currentFee.departmentId;
	}

	paramUser = currentFee.owner;
	paramBillFor = billFor;

	if (window.hasOwnProperty('billBizTypeInt')) {
		optEaTypeInt = Number(billBizTypeInt);
	}

	pushUserSelectWebView({
		source: 'EA',
		title: '请选择科目',
		param: {
			url: paramUrl,
			paramId: paramId,
			user: paramUser,
			billFor: paramBillFor
		},
		filterEaType: true,
		eaTypeInt: optEaTypeInt,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initEaBookForBillFee() {
	var paramUrl = '';
	var paramId = -1;
	var paramUser = -1;
	var paramBillFor = -1;
	var optEaTypeInt = BIZ_TYPE_ALL;
	document.getElementById('feeEaCell').addEventListener('tap', function() {
		showEaBookForBillFee(function(selected) {
			document.getElementById('feeSelectedEaName').innerText = selected.name;

			currentFee.eaId = selected.id;
			currentFee.eaName = selected.name;

			if (feeClms.budget || feeClms.totalBudget) {
				var objBillBudgetTime = document.getElementById('budgetTime');
				if (billFor == EXPENSE_BELONG_PROJECT) {
					getBudgetForFee(feeClms, billFor, currentFee.projectId, selected.id, objBillBudgetTime.innerText);
				} else {
					getBudgetForFee(feeClms, billFor, currentFee.departmentId, selected.id, objBillBudgetTime.innerText);
				}
			}
		});
	});
}

//单据明细资产类型
function showAssetBookForBillFee(callback) {
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择资产类型',
		param: {
			url: MJ_URL.EA_BILL_ASSET
		},
		filterEaType: false,
		splitByAccount: true,
		accountId: billAccount,
		eaTypeInt: BIZ_TYPE_ALL,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initAssetBookForBillFee() {
	document.getElementById('feeEaCell').addEventListener('tap', function() {
		showAssetBookForBillFee(function(selected) {
			document.getElementById('feeSelectedEaName').innerText = selected.name;
			currentFee.eaId = selected.id;
			currentFee.eaName = selected.name;
		});
	});
}

//销售单收入类型
function showSaleCrBookForBillFee(callback) {
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择收入类型',
		param: {
			url: MJ_URL.EA_BILL_SALE_CR
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		splitByAccount: true,
		accountId: billAccount,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initSaleCrBookForBillFee() {
	document.getElementById('feeEaCell').addEventListener('tap', function() {
		showSaleCrBookForBillFee(function(selected) {
			document.getElementById('feeSelectedEaName').innerText = selected.name;
			currentFee.eaId = selected.id;
			currentFee.eaName = selected.name;
		});
	});
}

//收款单收款类型
function showCollectionEaBookForBillFee(options, callback) {
	var feeDirect = options.feeDirect;
	var title = options.title || '请选择收款类型';
	var showEas = options.showEas || [];
	var paramUrl = '';

	if (feeDirect && feeDirect == BILL_DC_CR) {
		paramUrl = MJ_URL.EA_BILL_COLLECTION_CR;
	} else {
		paramUrl = MJ_URL.EA_BILL_COLLECTION_DR;
	}

	pushUserSelectWebView({
		source: 'EA',
		title: title,
		param: {
			url: paramUrl
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		showEas: showEas,
		splitByAccount: true,
		accountId: billAccount,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initCollectionDrBookForBillFee(feePageShowId) {
	var showCollectionDrEas = []
	document.getElementById('feeCollectionDrEaCell').addEventListener('tap', function() {
		if (window.hasOwnProperty('collectionDrEas') && collectionDrEas.length != 0) {
			showCollectionDrEas = collectionDrEas;
		} else {
			showCollectionDrEas = [];
		}

		showCollectionEaBookForBillFee({
			feeDirect: BILL_DC_DR,
			title: '请选择会计科目',
			showEas: showCollectionDrEas
		}, function(selected) {
			document.getElementById('feeCollectionSelectedDrEaName').innerText = selected.name;
			currentCustomFee.eaId = selected.id;
			currentCustomFee.eaName = selected.name;
			currentCustomFee.eaTypeInt = selected.field;
			currentCustomFee.cashFlowId = -1;
			currentCustomFee.cashFlowName = '';
			renderCashFlowText(currentCustomFee.eaTypeInt, undefined, 'feeCollectionDrCashFlowText',
				'feeCollectionSelectedDrCashFlowName');
		});
	});
}

function initCollectionCrBookForBillFee() {
	document.getElementById('feeEaCell').addEventListener('tap', function() {
		showCollectionEaBookForBillFee({
			feeDirect: BILL_DC_CR,
			title: '请选择收款类型',
			showEas: []
		}, function(selected) {
			document.getElementById('feeSelectedEaName').innerText = selected.name;
			currentFee.eaId = selected.id;
			currentFee.eaName = selected.name;
			currentFee.eaTypeInt = selected.field;
			currentFee.toCurrencyId = -1;
			currentFee.toCurrencyName = '';
			//重置冲应收币别
			if (window.hasOwnProperty('isToCurrency') && isToCurrency) {
				renderFeeCurrencyText(currentFee.eaTypeInt, undefined, 'feeCurrencyText', 'feeSelectedCurrencyName');
			}
			//收款单重置实际收款日期
			// if (window.hasOwnProperty('isRecvEnable') && isRecvEnable) {
			// 	renderFeeCollectTimeText(currentFee.eaTypeInt, currentFee.collectTime, 'feeCollectTimeText', 'feeCollectTime');
			// }
		});
	});
}

//领料单贷方科目
function showMaterialReqCrBookForBillFee(callback) {
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择科目',
		param: {
			url: MJ_URL.EA_BILL_MATERIAL_CR
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		splitByAccount: true,
		accountId: billAccount,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initMaterialReqCrBookForBillFee() {
	document.querySelector('#crFeeEaCell').addEventListener('tap', function() {
		showMaterialReqCrBookForBillFee(function(selected) {
			document.getElementById('crFeeSelectedEaName').innerText = selected.name;
			crCurrentFee.eaId = selected.id;
			crCurrentFee.eaName = selected.name;
		});
	});
}

//通用单据借方/贷方信息会计科目
function showEaAllBookForBillFee(opt,callback) {
	var accountId = opt.accountId || -1;
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择科目',
		param: {
			url: MJ_URL.EA_API
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		splitByAccount: true,
		accountId: accountId,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

//单据明细进项税科目
function showTaxEaBookForBillFee(callback) {
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择进项税科目',
		param: {
			url: MJ_URL.EA_BILL_TAX
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		splitByAccount: true,
		accountId: billAccount,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

//单据明细销项税科目
function showOutputTaxEaBookForBillFee(callback) {
	pushUserSelectWebView({
		source: 'EA',
		title: '请选择销项税科目',
		param: {
			url: MJ_URL.EA_BILL_OUT_TAX
		},
		filterEaType: false,
		eaTypeInt: BIZ_TYPE_ALL,
		splitByAccount: true,
		accountId: billAccount,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

//单据信息业务类型
function initBizTypeBookForBill(options, callback) {
	options = options || {};
	var bizTypeTapId = options.bizTypeTapId;
	var bizTypeShowId = options.bizTypeShowId;
	var dictBizType = options.dictBizType || '';
	var doNotRefreshCashFlow = (window.hasOwnProperty('currentBillType') && currentBillType == BILL_TYPE_BANK_DEDUCTION);

	if (!dictBizType) {
		document.getElementById(bizTypeShowId).innerText = BizTypeEnum[BIZ_TYPE_ALL];
		billBizTypeInt = BIZ_TYPE_ALL;
		return false;
	}

	var bizTypes = [];
	var rd = dictBizType;
	rd = rd.replace('，', ',');
	rd = rd.split(',');

	mui.each(rd, function(index, item) {
		bizTypes.push({
			id: item,
			name: BizTypeEnum[item]
		});
	});

	if (bizTypes.length == 1) {
		document.getElementById(bizTypeShowId).innerText = bizTypes[0].name;
		callback && callback(bizTypes[0]);
	}

	document.getElementById(bizTypeTapId).addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'BIZ_TYPE',
			title: '请选择业务类型',
			param: {},
			showBizTypes: bizTypes,
			callback: function(selected) {
				if (bizTypeShowId) document.getElementById(bizTypeShowId).innerText = selected.name;

				//清空费用明细的会计科目
				mui.each(feeMap, function(index, item) {
					document.querySelector('#fee-s-ea-' + item.id).innerText = '未选科目';
					item.eaId = -1;
					item.eaName = '';
					if (!doNotRefreshCashFlow) {
						item.cashFlowId = -1;
						item.cashFlowName = '';
					}
					if (item.budget) {
						item.budget = 0;
					}
					if (item.totalBudget) {
						item.totalBudget = 0;
					}
				});

				callback && callback(selected);
			}
		});
	});
}

//单据信息支付方式
function initPayTypeBookForBill(options, callback) {
	options = options || {};
	var payTypes = [];
	var payTypeArr = options.payTypeArr || [PAY_TYPE_CASH, PAY_TYPE_ONLINE, PAY_TYPE_EXCHANGE, PAY_TYPE_CREDIT,
		PAY_TYPE_CHECK, PAY_TYPE_LETTER_OF_CREDIT
	];
	var isRelateToBank = options.isRelateToBank || false;

	mui.each(payTypeArr, function(index, item) {
		payTypes.push({
			id: item,
			name: PayTypeEnum[item]
		});
	});

	document.getElementById('billPayTypeCell').addEventListener('tap', function() {
		pushUserSelectWebView({
			source: 'PAY_TYPE',
			title: '请选择支付方式',
			param: {},
			showPayTypes: payTypes,
			callback: function(selected) {
				document.getElementById('selectedPayType').innerText = selected.name;
				billPayType = selected.id;

				if (isRelateToBank) {
					resetBankSelect();
				}

				callback && callback(selected);
			}
		});
	});
}

//单据附票据
function renderBillPaperNum(canReview, data, $paperNum, $paperNumInput) {
	if (canReview) {
		$paperNumInput.style.display = 'block';
	} else {
		objPaperNum.style.display = 'block';
	}
	var billPaperNum = data.hasOwnProperty('paperNum') ? data.paperNum : '';
	$paperNum.innerText = billPaperNum;
	$paperNumInput.value = billPaperNum;
}

//渲染银行账号文字
function renderBillBankText(payType, $bankText, ableCallback) {
	if ((payType == PAY_TYPE_ONLINE) || (payType == PAY_TYPE_EXCHANGE) || (payType == PAY_TYPE_CHECK)) {
		$bankText.style.color = "#000";
		ableCallback && ableCallback();
	} else {
		$bankText.style.color = "#999";
	}
}

//银行账号显示
function renderBillBankName(bill, $bankName) {
	receiveBankId = bill.receiveId ? bill.receiveId : -1;;
	receiveBankName = bill.receiveBank ? bill.receiveBank : '';
	receiveBankNum = bill.receiveNum ? bill.receiveNum : '';
	receiveBankCode = bill.receiveCode ? bill.receiveCode : '';
	var showBankCode = receiveBankCode != '' ? (receiveBankCode + '\n') : '';
	$bankName.innerText = showBankCode + receiveBankName + '\n' + receiveBankNum;
}

//更新银行账号
function resetBankSelect() {
	document.getElementById('selectedReceiveBankName').innerText = '';
	receiveBankId = -1;
	receiveBankName = '';
	receiveBankNum = '';
	receiveBankCode = '';
}

//保存银行信息
function doBillActionSaveBankInfo(postData) {
	postData.receiveId = receiveBankId;
	postData.receiveBank = receiveBankName;
	postData.receiveNum = receiveBankNum;
	postData.receiveCode = receiveBankCode;
}

//单据信息个人银行账号
function initBankBookForBill(options) {
	var payTargetOpt = options.payTarget || PAY_TARGET_USER;
	var paramUrl = '';
	var paramId = '';
	var currentPayTarget = -1;
	document.getElementById('billBankCell').addEventListener('tap', function() {

		if ((billPayType != PAY_TYPE_ONLINE) && (billPayType != PAY_TYPE_EXCHANGE) && (billPayType != PAY_TYPE_CHECK)) {
			return false;
		}

		if (window.hasOwnProperty('billPayTarget')) {
			if (billPayTarget < 0) {
				mui.toast('请选择付款对象');
				return false;
			}

			currentPayTarget = billPayTarget;
		} else {
			currentPayTarget = payTargetOpt;
		}

		switch (Number(currentPayTarget)) {
			case PAY_TARGET_USER:
				if (!billOwner || billOwner < 0) {
					mui.toast('请选择申请人');
					return false;
				}
				paramUrl = MJ_URL.BA_LIST_BY_USER;
				paramId = billOwner;
				break;
			case PAY_TARGET_SUPPLIER:
				if (!billCustomer || billCustomer < 0) {
					mui.toast('请选择供应商');
					return false;
				}
				paramUrl = MJ_URL.BA_LIST_BY_SUPPLIER;
				paramId = billCustomer;
				break;
			case PAY_TARGET_CONSUMER:
				if (!billConsumer || billConsumer < 0) {
					mui.toast('请选择客户');
					return false;
				}
				paramUrl = MJ_URL.BA_LIST_BY_CONSUMER;
				paramId = billConsumer;
				break;
			default:
				break;
		}

		pushUserSelectWebView({
			source: 'BANK',
			title: '请选择银行账号',
			param: {
				url: paramUrl,
				pid: paramId
			},
			callback: function(selected) {
				receiveBankId = selected.id;
				receiveBankName = selected.name;
				receiveBankNum = selected.bankNum;
				receiveBankCode = selected.bankCode ? selected.bankCode : '';
				var showBankCode = receiveBankCode != '' ? (receiveBankCode + '\n') : '';
				document.getElementById('selectedReceiveBankName').innerText = showBankCode + receiveBankName + '\n' +
					receiveBankNum;
			}
		});
	});
}

//单据明细业务活动
function initBizBookForBillFee() {
	document.getElementById('feeBizCell').addEventListener('tap', function() {
		var feeDepartment = currentFee.departmentId;
		if (!feeDepartment || feeDepartment <= 0) {
			mui.toast('请先选择部门');
			return false;
		}

		pushUserSelectWebView({
			source: 'BIZ',
			title: '请选择业务活动',
			param: {
				url: MJ_URL.BIZ_LIST_BY_DEPT,
				department: feeDepartment
			},
			hasSpecial: true,
			callback: function(selected) {
				currentFee.bizId = selected.id;
				currentFee.bizName = selected.name;

				document.getElementById('feeSelectedBizName').innerText = selected.name;
			}
		});
	});
}

//单据明细车辆
function initCarBookForBillFee() {
	document.getElementById('feeCarCell').addEventListener('tap', function() {

		pushUserSelectWebView({
			source: 'CAR',
			title: '请选择车辆',
			param: {
				url: MJ_URL.CAR_API
			},
			hasSpecial: true,
			callback: function(selected) {
				currentFee.carId = selected.id;
				currentFee.carNum = selected.name;

				document.getElementById('feeSelectedCarNum').innerText = selected.name;
			}
		});
	});
}

//单据明细扩展字段
function showDmBookForBillFee(dmTitle, billDms, callback) {
	pushUserSelectWebView({
		source: 'BILL_DM',
		title: dmTitle,
		param: {},
		hasSpecial: true,
		showBillDms: billDms,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initDmBookForBillFee(options, callback) {
	options = options || {};
	var dmTapId = options.dmTapId;
	var dmShowId = options.dmShowId;
	var dmTitle = options.dmTitle || '请选择扩展字段';
	var billDms = options.dms || [];
	document.getElementById(dmTapId).addEventListener('tap', function() {
		showDmBookForBillFee(dmTitle, billDms, function(selected) {
			if (dmShowId) document.getElementById(dmShowId).innerText = selected.name;
			callback && callback(selected);
		});
	});
}

//现金流量项目
function renderCashFlowText(eaType, cashFlowName, cashFlowTextShowId, cashFlowShowId) {
	var $cashFlowTextShowId = document.getElementById(cashFlowTextShowId);
	var $cashFlowShowId = document.getElementById(cashFlowShowId);
	var checkBillTypeCondition = (window.hasOwnProperty && window.hasOwnProperty('checkFeeCashFlowEnable') &&
		checkFeeCashFlowEnable);
	if ((eaType && (eaType == EA_TYPE_ASSET_CASH)) || checkBillTypeCondition) {
		if ($cashFlowTextShowId) $cashFlowTextShowId.style.color = "#000";
		if (cashFlowName == undefined || cashFlowName == '') return false;
		if ($cashFlowTextShowId) $cashFlowShowId.innerText = cashFlowName ? cashFlowName : '';
	} else {
		if ($cashFlowTextShowId) $cashFlowTextShowId.style.color = "#999";
		if ($cashFlowShowId) $cashFlowShowId.innerText = '';
	}
}

function showCashFlowBook(cashFlowItem, callback) {
	pushUserSelectWebView({
		source: 'CASHFLOW',
		title: '请选择现金流量项目',
		param: {
			url: MJ_URL.CASH_FLOW_API
		},
		cashFlowItem: cashFlowItem,
		callback: function(selected) {
			callback && callback(selected);
		}
	});
}

function initCashFlowBookForBill(options, callback) {
	options = options || {};
	var cashFlowTapId = options.cashFlowTapId;
	var cashFlowShowId = options.cashFlowShowId;
	var cashFlowItem = options.cashFlowItem || [];
	document.getElementById(cashFlowTapId).addEventListener('tap', function() {
		//单据级别
		if (window.hasOwnProperty('billEaTypeInt') && billEaTypeInt != EA_TYPE_ASSET_CASH) {
			mui.toast('请选择科目属性是资产类现金的借方科目');
			return false;
		}

		showCashFlowBook(cashFlowItem, function(selected) {
			if (cashFlowShowId) document.getElementById(cashFlowShowId).innerText = selected.name;
			callback && callback(selected);
		});
	});
}

function initCashFlowBookForFee(options, callback) {
	var cashFlowItem = options.cashFlowItem || [];
	var feePageShowId = options.feePageShowId;
	var feeTapCellId = options.feeTapCellId;
	var feeCahsFlowShowId = options.feeCahsFlowShowId;
	mui('#' + feePageShowId).on('tap', '#' + feeTapCellId, function() {
		options.prepare && options.prepare();

		var curStatus = options.checkStatus() ? options.checkStatus() : -1;
		switch (Number(curStatus)) {
			case BILL_STATUS_APPROVED:
			case BILL_STATUS_PAID:
			case BILL_STATUS_COLLECT:
				if (window.hasOwnProperty('has_bill_cashflow_permission') && !has_bill_cashflow_permission) {
					return false;
				}
				break;
			case BILL_STATUS_REVIEWING:
			default:
				if (window.hasOwnProperty('currentBillType')) {
					switch (currentBillType) {
						case BILL_TYPE_COLLECTION:
							if (window.hasOwnProperty('currentCustomFee') && currentCustomFee.eaTypeInt != EA_TYPE_ASSET_CASH) {
								mui.toast('请选择科目属性是资产类现金的会计科目');
								return false;
							}
							break;
						case BILL_TYPE_BANK_DEDUCTION:
						case BILL_TYPE_BUDGET_COLLECT:
						case BILL_TYPE_BUDGET_PAY:
							break;
						default:
							if (window.hasOwnProperty('currentFee') && currentFee.eaTypeInt != EA_TYPE_ASSET_CASH) {
								mui.toast('请选择科目属性是资产类现金的会计科目');
								return false;
							}
							break;

					}
				}
				break;
		}

		showCashFlowBook(cashFlowItem, function(selected) {
			if (feeCahsFlowShowId) document.getElementById(feeCahsFlowShowId).innerText = selected.name;
			callback && callback(selected);
		});
	});
}

//预计/实际收款日期
function renderFeeCollectTimeText(eaTypeInt, collectTime, collectTimeTextShowId, collectTimeShowId) {
	var $collectTimeShow = document.getElementById(collectTimeShowId);
	var $collectTimeTextShow = document.getElementById(collectTimeTextShowId);
	var checkBillTypeCondition = checkWindowProperty('checkFeeCollectTimeEnable');
	if ((eaTypeInt && (eaTypeInt == EA_TYPE_ASSET_RECV)) || checkBillTypeCondition) {
		if ($collectTimeTextShow) $collectTimeTextShow.style.color = "#000";
		if (collectTime == undefined || collectTime == '') return false;
		if ($collectTimeShow) $collectTimeShow.innerText = collectTime ? new Date(collectTime).format('yyyy-MM-dd') : '';
	} else {
		if ($collectTimeTextShow) $collectTimeTextShow.style.color = "#999";
		if ($collectTimeShow) $collectTimeShow.innerText = '';
	}
}

//单据明细进项税
function renderFeeTaxExpense(opt){
	opt = opt || {};
	var taxText = opt.taxText || '.fee-tax-text';
	var taxExpenseShow = opt.taxExpenseShow || '.fee-taxexpense';
	var checkCurrency = opt.payCurrency || checkWindowProperty('billPayCurrency');
	if(taxText) var $taxText = document.querySelector(taxText);
	if(taxExpenseShow )var $taxExpenseShow = document.querySelector(taxExpenseShow);
	var checkTaxExpenseInputEnable = false;
	switch (currentBillType){
		case BILL_TYPE_SUPER:
			checkTaxExpenseInputEnable = true;
			break;
		default:
			checkTaxExpenseInputEnable = (checkCurrency ==PAY_CURRENCY_LOCAL);
			break;
	}

	if(!checkTaxExpenseInputEnable){
		if ($taxText) $taxText.style.color = "#999";
		if ($taxExpenseShow) $taxExpenseShow.setAttribute('disabled',true);
		
	}else{
		if ($taxText) $taxText.style.color = "#000";
		if ($taxExpenseShow) $taxExpenseShow.removeAttribute('disabled');
	}
}

// 制单时单据默认信息
function renderDefaultBillFillInfo(options) {
	var selectedAccountId = options.accountId || -1;
	var curUserId = mj.getId();
	var curUserNickName = mj.getNickName();
	var userMainAccount = mj.getAccountId() ? mj.getAccountId() : -1;
	var userMainDepartment = mj.getDepartmentId() ? mj.getDepartmentId() : -1;
	var userMainDepartmentName = mj.getDepartmentName() ? mj.getDepartmentName() : '';
	var departmentSelector = options.departmentSelector || '';
	var userSelector = options.userSelector || '';
	if (departmentSelector) var $department = document.getElementById(departmentSelector);
	if (userSelector) var $user = document.getElementById(userSelector);

	checkDataCache(accountBooks, function(accountBooks) {
		if (accountBooks && accountBooks.length == 1) {
			userMainAccount = accountBooks[0].id;
			selectedAccountId = userMainAccount;
		}
	}, function(queryCallback) {
		mjQueryAllAccountBooks(function(queryAccountBooks) {
			if (checkWindowProperty('accountBooks')) accountBooks = queryAccountBooks;
			queryCallback(queryAccountBooks);
		});
	});

	if (selectedAccountId == userMainAccount) {
		if ($department) $department.innerText = userMainDepartmentName;
		if (checkWindowProperty('billDepartment')) billDepartment = userMainDepartment;
		if ($user) {
			$user.innerText = curUserNickName;
			if (checkWindowProperty('billOwner')) billOwner = curUserId;
		}
	}
}

//检验全局变量
function checkWindowProperty(propertyName) {
	var isHasProperty = window.hasOwnProperty && window.hasOwnProperty(propertyName);
	if (isHasProperty) {
		var propertyValue = mj.propertyGetMethod(window, propertyName);
		return propertyValue;
	} else {
		return false;
	}
}
